
[Setup]
AppName=ASTAP, the Astrometric STAcking Program, astrometric solver and FITS viewer.

AppVerName=ASTAP 

;Keep this always the same for identification. This id is not shown to users
AppId=AppName=ASTAP, the Astrometric STAcking Program, astrometric solver and FITS viewer.


AppPublisher=Han Kleijn
AppPublisherURL=http://www.hnsky.org
AppSupportURL=http://www.hnsky.org
AppUpdatesURL=http://www.hnsky.org

DefaultDirName={pf}\astap
UsePreviousAppDir=yes
; Setup will look in the registry to see if the same application is already installed, and if so, it will use the directory of the previous installation as the default directory presented to the user in the wizard
DefaultGroupName=ASTAP
AllowNoIcons=yes

InfoAfterFile=C:\astap.fpc\astap_install.txt

; "ArchitecturesInstallIn64BitMode=x64" requests that the install be
; done in "64-bit mode" on x64, meaning it should use the native
; 64-bit Program Files directory and the 64-bit view of the registry.
; On all other architectures it will install in "32-bit mode".
ArchitecturesInstallIn64BitMode=x64
; Note: We don't set ProcessorsAllowed because we want this
; installation to run on all architectures (including Itanium,
; since it's capable of running 32-bit code too).



[Tasks]
Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; MinVersion: 4,4

[Dirs]  

[Files]


[InstallDelete]

 
[Files]
Source: "c:\astap.fpc\astap.exe"; DestDir: "{app}"; DestName: "astap.exe"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\astap_cli.exe"; DestDir: "{app}"; DestName: "astap_cli.exe"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\deep_sky.csv"; DestDir: "{app}"; DestName: "deep_sky.csv"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\variable_stars.csv"; DestDir: "{app}"; DestName: "variable_stars.csv"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\libraw\unprocessed_raw.exe"; DestDir: "{app}"; DestName: "unprocessed_raw.exe"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\dcraw.exe"; DestDir: "{app}"; DestName: "dcraw.exe"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\astap_install.txt"; DestDir: "{app}"; DestName: "astap_install.txt"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\acknowledgement of databases.txt"; DestDir: "{app}"; DestName: "acknowledgement of databases.txt"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\openssl\*.dll"; DestDir: "{app}"; Check: Is64BitInstallMode; Flags: ignoreversion
Source: "c:\astap.fpc\openssl\OpenSSL License for files libeay.dll and ssleay.dll.txt"; DestDir: "{app}"; Check: Is64BitInstallMode; Flags: ignoreversion



[Icons]
Name: "{group}\Astrometric stacking program"; Filename: "{app}\astap.exe";WorkingDir: "{app}"
; Note Han working dir added"
Name: "{userdesktop}\ASTAP"; Filename: "{app}\astap.exe"; MinVersion: 4,4; Tasks: desktopicon;WorkingDir: "{app}"
; Note Han working dir added"

[Run]
Filename: "{app}\astap.exe"; Description: "Launch the Astrometric stacking program"; Flags: nowait postinstall skipifsilent


