
unit unit_1476;

{$MODE Delphi}

interface
var
  tof    : file;
  nr_of_stars           : longint;
  nr_of_skipped         : longint;


type
hnskyhdr1476_A7 = packed record {interim record}
             ra7 : byte;
             ra8 : byte;
             ra9 : byte;
             dec7: byte;
             dec8: byte;    {note with word and smallint, delphi makes longer records !!!}
             dec9: shortint;
             Bp_Rp: shortint;{blue minus red magnitude}
   end;

hnskyhdr1476_A6 = packed record {interim record}
             ra7 : byte;
             ra8 : byte;
             ra9 : byte;
             dec7: byte;
             dec8: byte;    {note with word and smallint, delphi makes longer records !!!}
             dec9: shortint;
   end;
hnskyhdr1476_5 = packed record
             ra7 : byte;
             ra8 : byte;
             ra9 : byte;
             dec7: byte;
             dec8: byte;    {note with word and smallint, delphi makes longer records !!!}
   end;

hnskyhdr1476_6 = packed record
             ra7 : byte;
             ra8 : byte;
             ra9 : byte;
             dec7: byte;
             dec8: byte;    {note with word and smallint, delphi makes longer records !!!}
             Bp_Rp: shortint;{blue minus red magnitude}
   end;



var
   Numwritten                  : integer;
   new_magnitude_record_written : array[1..1801] of integer;{keep record if new magnitude step record is written to file for 6 byte records}

function limit_radialen(z:double):double;

function name1476(ra,dec:real): string; {give segment name}


function filenames1476(nr:integer): string;

const
ring0=-90*pi/180;
ring1=-87.42857143*pi/180;
ring2=-82.28571429*pi/180;
ring3=-77.14285714*pi/180;
ring4=-72*pi/180;
ring5=-66.85714286*pi/180;
ring6=-61.71428571*pi/180;
ring7=-56.57142857*pi/180;
ring8=-51.42857143*pi/180;
ring9=-46.28571429*pi/180;
ring10=-41.14285714*pi/180;
ring11=-36*pi/180;
ring12=-30.85714286*pi/180;
ring13=-25.71428571*pi/180;
ring14=-20.57142857*pi/180;
ring15=-15.42857143*pi/180;
ring16=-10.28571429*pi/180;
ring17=-5.142857143*pi/180;

ring18=0*pi/180;

ring19=5.142857143*pi/180;
ring20=10.28571429*pi/180;
ring21=15.42857143*pi/180;
ring22=20.57142857*pi/180;
ring23=25.71428571*pi/180;
ring24=30.85714286*pi/180;
ring25=36*pi/180;
ring26=41.14285714*pi/180;
ring27=46.28571429*pi/180;
ring28=51.42857143*pi/180;
ring29=56.57142857*pi/180;
ring30=61.71428571*pi/180;
ring31=66.85714286*pi/180;
ring32=72*pi/180;
ring33=77.14285714*pi/180;
ring34=82.28571429*pi/180;
ring35=87.42857143*pi/180;
ring36=90*pi/180;





centers1476 : array[1..1476,1..6] of real= {divide sky in 1476 area's in bands of constant DEC}

 {ra_center, dec_center, ra_min    ,ra_max, dec_min, dec_max}

    (( 0       , ring0          ,  0        ,pi         ,ring0,ring1),  {1  south pole    }

    (0.5/3*2*pi, (ring1+ring2)/2, 0.0/3*2*pi, 1.0/3*2*pi,ring1,ring2),  {3 circle segments. Keep the min dimension around 5 degrees resulting in three segments}
    (1.5/3*2*pi, (ring1+ring2)/2, 1.0/3*2*pi, 2.0/3*2*pi,ring1,ring2),  {3 circle segments}
    (2.5/3*2*pi, (ring1+ring2)/2, 2.0/3*2*pi, 3.0/3*2*pi,ring1,ring2),  {3 circle segments}

    (0.5/9*2*pi, (ring2+ring3)/2, 0.0/9*2*pi, 1.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (1.5/9*2*pi, (ring2+ring3)/2, 1.0/9*2*pi, 2.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (2.5/9*2*pi, (ring2+ring3)/2, 2.0/9*2*pi, 3.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (3.5/9*2*pi, (ring2+ring3)/2, 3.0/9*2*pi, 4.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (4.5/9*2*pi, (ring2+ring3)/2, 4.0/9*2*pi, 5.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (5.5/9*2*pi, (ring2+ring3)/2, 5.0/9*2*pi, 6.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (6.5/9*2*pi, (ring2+ring3)/2, 6.0/9*2*pi, 7.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (7.5/9*2*pi, (ring2+ring3)/2, 7.0/9*2*pi, 8.0/9*2*pi,ring2,ring3),  {9 circle segments}
    (8.5/9*2*pi, (ring2+ring3)/2, 8.0/9*2*pi, 9.0/9*2*pi,ring2,ring3),  {9 circle segments}


    (0.5/15*2*pi, (ring3+ring4)/2, 0.0/15*2*pi, 1.0/15*2*pi,ring3,ring4),
    (1.5/15*2*pi, (ring3+ring4)/2, 1.0/15*2*pi, 2.0/15*2*pi,ring3,ring4),
    (2.5/15*2*pi, (ring3+ring4)/2, 2.0/15*2*pi, 3.0/15*2*pi,ring3,ring4),
    (3.5/15*2*pi, (ring3+ring4)/2, 3.0/15*2*pi, 4.0/15*2*pi,ring3,ring4),
    (4.5/15*2*pi, (ring3+ring4)/2, 4.0/15*2*pi, 5.0/15*2*pi,ring3,ring4),
    (5.5/15*2*pi, (ring3+ring4)/2, 5.0/15*2*pi, 6.0/15*2*pi,ring3,ring4),
    (6.5/15*2*pi, (ring3+ring4)/2, 6.0/15*2*pi, 7.0/15*2*pi,ring3,ring4),
    (7.5/15*2*pi, (ring3+ring4)/2, 7.0/15*2*pi, 8.0/15*2*pi,ring3,ring4),
    (8.5/15*2*pi, (ring3+ring4)/2, 8.0/15*2*pi, 9.0/15*2*pi,ring3,ring4),
    (9.5/15*2*pi, (ring3+ring4)/2, 9.0/15*2*pi, 10.0/15*2*pi,ring3,ring4),
    (10.5/15*2*pi, (ring3+ring4)/2, 10.0/15*2*pi, 11.0/15*2*pi,ring3,ring4),
    (11.5/15*2*pi, (ring3+ring4)/2, 11.0/15*2*pi, 12.0/15*2*pi,ring3,ring4),
    (12.5/15*2*pi, (ring3+ring4)/2, 12.0/15*2*pi, 13.0/15*2*pi,ring3,ring4),
    (13.5/15*2*pi, (ring3+ring4)/2, 13.0/15*2*pi, 14.0/15*2*pi,ring3,ring4),
    (14.5/15*2*pi, (ring3+ring4)/2, 14.0/15*2*pi, 15.0/15*2*pi,ring3,ring4),


    (0.5/21*2*pi, (ring4+ring5)/2, 0.0/21*2*pi, 1.0/21*2*pi,ring4,ring5),
    (1.5/21*2*pi, (ring4+ring5)/2, 1.0/21*2*pi, 2.0/21*2*pi,ring4,ring5),
    (2.5/21*2*pi, (ring4+ring5)/2, 2.0/21*2*pi, 3.0/21*2*pi,ring4,ring5),
    (3.5/21*2*pi, (ring4+ring5)/2, 3.0/21*2*pi, 4.0/21*2*pi,ring4,ring5),
    (4.5/21*2*pi, (ring4+ring5)/2, 4.0/21*2*pi, 5.0/21*2*pi,ring4,ring5),
    (5.5/21*2*pi, (ring4+ring5)/2, 5.0/21*2*pi, 6.0/21*2*pi,ring4,ring5),
    (6.5/21*2*pi, (ring4+ring5)/2, 6.0/21*2*pi, 7.0/21*2*pi,ring4,ring5),
    (7.5/21*2*pi, (ring4+ring5)/2, 7.0/21*2*pi, 8.0/21*2*pi,ring4,ring5),
    (8.5/21*2*pi, (ring4+ring5)/2, 8.0/21*2*pi, 9.0/21*2*pi,ring4,ring5),
    (9.5/21*2*pi, (ring4+ring5)/2, 9.0/21*2*pi, 10.0/21*2*pi,ring4,ring5),
    (10.5/21*2*pi, (ring4+ring5)/2, 10.0/21*2*pi, 11.0/21*2*pi,ring4,ring5),
    (11.5/21*2*pi, (ring4+ring5)/2, 11.0/21*2*pi, 12.0/21*2*pi,ring4,ring5),
    (12.5/21*2*pi, (ring4+ring5)/2, 12.0/21*2*pi, 13.0/21*2*pi,ring4,ring5),
    (13.5/21*2*pi, (ring4+ring5)/2, 13.0/21*2*pi, 14.0/21*2*pi,ring4,ring5),
    (14.5/21*2*pi, (ring4+ring5)/2, 14.0/21*2*pi, 15.0/21*2*pi,ring4,ring5),
    (15.5/21*2*pi, (ring4+ring5)/2, 15.0/21*2*pi, 16.0/21*2*pi,ring4,ring5),
    (16.5/21*2*pi, (ring4+ring5)/2, 16.0/21*2*pi, 17.0/21*2*pi,ring4,ring5),
    (17.5/21*2*pi, (ring4+ring5)/2, 17.0/21*2*pi, 18.0/21*2*pi,ring4,ring5),
    (18.5/21*2*pi, (ring4+ring5)/2, 18.0/21*2*pi, 19.0/21*2*pi,ring4,ring5),
    (19.5/21*2*pi, (ring4+ring5)/2, 19.0/21*2*pi, 20.0/21*2*pi,ring4,ring5),
    (20.5/21*2*pi, (ring4+ring5)/2, 20.0/21*2*pi, 21.0/21*2*pi,ring4,ring5),


    (0.5/27*2*pi, (ring5+ring6)/2, 0.0/27*2*pi, 1.0/27*2*pi,ring5,ring6),
    (1.5/27*2*pi, (ring5+ring6)/2, 1.0/27*2*pi, 2.0/27*2*pi,ring5,ring6),
    (2.5/27*2*pi, (ring5+ring6)/2, 2.0/27*2*pi, 3.0/27*2*pi,ring5,ring6),
    (3.5/27*2*pi, (ring5+ring6)/2, 3.0/27*2*pi, 4.0/27*2*pi,ring5,ring6),
    (4.5/27*2*pi, (ring5+ring6)/2, 4.0/27*2*pi, 5.0/27*2*pi,ring5,ring6),
    (5.5/27*2*pi, (ring5+ring6)/2, 5.0/27*2*pi, 6.0/27*2*pi,ring5,ring6),
    (6.5/27*2*pi, (ring5+ring6)/2, 6.0/27*2*pi, 7.0/27*2*pi,ring5,ring6),
    (7.5/27*2*pi, (ring5+ring6)/2, 7.0/27*2*pi, 8.0/27*2*pi,ring5,ring6),
    (8.5/27*2*pi, (ring5+ring6)/2, 8.0/27*2*pi, 9.0/27*2*pi,ring5,ring6),
    (9.5/27*2*pi, (ring5+ring6)/2, 9.0/27*2*pi, 10.0/27*2*pi,ring5,ring6),
    (10.5/27*2*pi, (ring5+ring6)/2, 10.0/27*2*pi, 11.0/27*2*pi,ring5,ring6),
    (11.5/27*2*pi, (ring5+ring6)/2, 11.0/27*2*pi, 12.0/27*2*pi,ring5,ring6),
    (12.5/27*2*pi, (ring5+ring6)/2, 12.0/27*2*pi, 13.0/27*2*pi,ring5,ring6),
    (13.5/27*2*pi, (ring5+ring6)/2, 13.0/27*2*pi, 14.0/27*2*pi,ring5,ring6),
    (14.5/27*2*pi, (ring5+ring6)/2, 14.0/27*2*pi, 15.0/27*2*pi,ring5,ring6),
    (15.5/27*2*pi, (ring5+ring6)/2, 15.0/27*2*pi, 16.0/27*2*pi,ring5,ring6),
    (16.5/27*2*pi, (ring5+ring6)/2, 16.0/27*2*pi, 17.0/27*2*pi,ring5,ring6),
    (17.5/27*2*pi, (ring5+ring6)/2, 17.0/27*2*pi, 18.0/27*2*pi,ring5,ring6),
    (18.5/27*2*pi, (ring5+ring6)/2, 18.0/27*2*pi, 19.0/27*2*pi,ring5,ring6),
    (19.5/27*2*pi, (ring5+ring6)/2, 19.0/27*2*pi, 20.0/27*2*pi,ring5,ring6),
    (20.5/27*2*pi, (ring5+ring6)/2, 20.0/27*2*pi, 21.0/27*2*pi,ring5,ring6),
    (21.5/27*2*pi, (ring5+ring6)/2, 21.0/27*2*pi, 22.0/27*2*pi,ring5,ring6),
    (22.5/27*2*pi, (ring5+ring6)/2, 22.0/27*2*pi, 23.0/27*2*pi,ring5,ring6),
    (23.5/27*2*pi, (ring5+ring6)/2, 23.0/27*2*pi, 24.0/27*2*pi,ring5,ring6),
    (24.5/27*2*pi, (ring5+ring6)/2, 24.0/27*2*pi, 25.0/27*2*pi,ring5,ring6),
    (25.5/27*2*pi, (ring5+ring6)/2, 25.0/27*2*pi, 26.0/27*2*pi,ring5,ring6),
    (26.5/27*2*pi, (ring5+ring6)/2, 26.0/27*2*pi, 27.0/27*2*pi,ring5,ring6),



    (0.5/33*2*pi, (ring6+ring7)/2, 0.0/33*2*pi, 1.0/33*2*pi,ring6,ring7),
    (1.5/33*2*pi, (ring6+ring7)/2, 1.0/33*2*pi, 2.0/33*2*pi,ring6,ring7),
    (2.5/33*2*pi, (ring6+ring7)/2, 2.0/33*2*pi, 3.0/33*2*pi,ring6,ring7),
    (3.5/33*2*pi, (ring6+ring7)/2, 3.0/33*2*pi, 4.0/33*2*pi,ring6,ring7),
    (4.5/33*2*pi, (ring6+ring7)/2, 4.0/33*2*pi, 5.0/33*2*pi,ring6,ring7),
    (5.5/33*2*pi, (ring6+ring7)/2, 5.0/33*2*pi, 6.0/33*2*pi,ring6,ring7),
    (6.5/33*2*pi, (ring6+ring7)/2, 6.0/33*2*pi, 7.0/33*2*pi,ring6,ring7),
    (7.5/33*2*pi, (ring6+ring7)/2, 7.0/33*2*pi, 8.0/33*2*pi,ring6,ring7),
    (8.5/33*2*pi, (ring6+ring7)/2, 8.0/33*2*pi, 9.0/33*2*pi,ring6,ring7),
    (9.5/33*2*pi, (ring6+ring7)/2, 9.0/33*2*pi, 10.0/33*2*pi,ring6,ring7),
    (10.5/33*2*pi, (ring6+ring7)/2, 10.0/33*2*pi, 11.0/33*2*pi,ring6,ring7),
    (11.5/33*2*pi, (ring6+ring7)/2, 11.0/33*2*pi, 12.0/33*2*pi,ring6,ring7),
    (12.5/33*2*pi, (ring6+ring7)/2, 12.0/33*2*pi, 13.0/33*2*pi,ring6,ring7),
    (13.5/33*2*pi, (ring6+ring7)/2, 13.0/33*2*pi, 14.0/33*2*pi,ring6,ring7),
    (14.5/33*2*pi, (ring6+ring7)/2, 14.0/33*2*pi, 15.0/33*2*pi,ring6,ring7),
    (15.5/33*2*pi, (ring6+ring7)/2, 15.0/33*2*pi, 16.0/33*2*pi,ring6,ring7),
    (16.5/33*2*pi, (ring6+ring7)/2, 16.0/33*2*pi, 17.0/33*2*pi,ring6,ring7),
    (17.5/33*2*pi, (ring6+ring7)/2, 17.0/33*2*pi, 18.0/33*2*pi,ring6,ring7),
    (18.5/33*2*pi, (ring6+ring7)/2, 18.0/33*2*pi, 19.0/33*2*pi,ring6,ring7),
    (19.5/33*2*pi, (ring6+ring7)/2, 19.0/33*2*pi, 20.0/33*2*pi,ring6,ring7),
    (20.5/33*2*pi, (ring6+ring7)/2, 20.0/33*2*pi, 21.0/33*2*pi,ring6,ring7),
    (21.5/33*2*pi, (ring6+ring7)/2, 21.0/33*2*pi, 22.0/33*2*pi,ring6,ring7),
    (22.5/33*2*pi, (ring6+ring7)/2, 22.0/33*2*pi, 23.0/33*2*pi,ring6,ring7),
    (23.5/33*2*pi, (ring6+ring7)/2, 23.0/33*2*pi, 24.0/33*2*pi,ring6,ring7),
    (24.5/33*2*pi, (ring6+ring7)/2, 24.0/33*2*pi, 25.0/33*2*pi,ring6,ring7),
    (25.5/33*2*pi, (ring6+ring7)/2, 25.0/33*2*pi, 26.0/33*2*pi,ring6,ring7),
    (26.5/33*2*pi, (ring6+ring7)/2, 26.0/33*2*pi, 27.0/33*2*pi,ring6,ring7),
    (27.5/33*2*pi, (ring6+ring7)/2, 27.0/33*2*pi, 28.0/33*2*pi,ring6,ring7),
    (28.5/33*2*pi, (ring6+ring7)/2, 28.0/33*2*pi, 29.0/33*2*pi,ring6,ring7),
    (29.5/33*2*pi, (ring6+ring7)/2, 29.0/33*2*pi, 30.0/33*2*pi,ring6,ring7),
    (30.5/33*2*pi, (ring6+ring7)/2, 30.0/33*2*pi, 31.0/33*2*pi,ring6,ring7),
    (31.5/33*2*pi, (ring6+ring7)/2, 31.0/33*2*pi, 32.0/33*2*pi,ring6,ring7),
    (32.5/33*2*pi, (ring6+ring7)/2, 32.0/33*2*pi, 33.0/33*2*pi,ring6,ring7),


    (0.5/38*2*pi, (ring7+ring8)/2, 0.0/38*2*pi, 1.0/38*2*pi,ring7,ring8),
    (1.5/38*2*pi, (ring7+ring8)/2, 1.0/38*2*pi, 2.0/38*2*pi,ring7,ring8),
    (2.5/38*2*pi, (ring7+ring8)/2, 2.0/38*2*pi, 3.0/38*2*pi,ring7,ring8),
    (3.5/38*2*pi, (ring7+ring8)/2, 3.0/38*2*pi, 4.0/38*2*pi,ring7,ring8),
    (4.5/38*2*pi, (ring7+ring8)/2, 4.0/38*2*pi, 5.0/38*2*pi,ring7,ring8),
    (5.5/38*2*pi, (ring7+ring8)/2, 5.0/38*2*pi, 6.0/38*2*pi,ring7,ring8),
    (6.5/38*2*pi, (ring7+ring8)/2, 6.0/38*2*pi, 7.0/38*2*pi,ring7,ring8),
    (7.5/38*2*pi, (ring7+ring8)/2, 7.0/38*2*pi, 8.0/38*2*pi,ring7,ring8),
    (8.5/38*2*pi, (ring7+ring8)/2, 8.0/38*2*pi, 9.0/38*2*pi,ring7,ring8),
    (9.5/38*2*pi, (ring7+ring8)/2, 9.0/38*2*pi, 10.0/38*2*pi,ring7,ring8),
    (10.5/38*2*pi, (ring7+ring8)/2, 10.0/38*2*pi, 11.0/38*2*pi,ring7,ring8),
    (11.5/38*2*pi, (ring7+ring8)/2, 11.0/38*2*pi, 12.0/38*2*pi,ring7,ring8),
    (12.5/38*2*pi, (ring7+ring8)/2, 12.0/38*2*pi, 13.0/38*2*pi,ring7,ring8),
    (13.5/38*2*pi, (ring7+ring8)/2, 13.0/38*2*pi, 14.0/38*2*pi,ring7,ring8),
    (14.5/38*2*pi, (ring7+ring8)/2, 14.0/38*2*pi, 15.0/38*2*pi,ring7,ring8),
    (15.5/38*2*pi, (ring7+ring8)/2, 15.0/38*2*pi, 16.0/38*2*pi,ring7,ring8),
    (16.5/38*2*pi, (ring7+ring8)/2, 16.0/38*2*pi, 17.0/38*2*pi,ring7,ring8),
    (17.5/38*2*pi, (ring7+ring8)/2, 17.0/38*2*pi, 18.0/38*2*pi,ring7,ring8),
    (18.5/38*2*pi, (ring7+ring8)/2, 18.0/38*2*pi, 19.0/38*2*pi,ring7,ring8),
    (19.5/38*2*pi, (ring7+ring8)/2, 19.0/38*2*pi, 20.0/38*2*pi,ring7,ring8),
    (20.5/38*2*pi, (ring7+ring8)/2, 20.0/38*2*pi, 21.0/38*2*pi,ring7,ring8),
    (21.5/38*2*pi, (ring7+ring8)/2, 21.0/38*2*pi, 22.0/38*2*pi,ring7,ring8),
    (22.5/38*2*pi, (ring7+ring8)/2, 22.0/38*2*pi, 23.0/38*2*pi,ring7,ring8),
    (23.5/38*2*pi, (ring7+ring8)/2, 23.0/38*2*pi, 24.0/38*2*pi,ring7,ring8),
    (24.5/38*2*pi, (ring7+ring8)/2, 24.0/38*2*pi, 25.0/38*2*pi,ring7,ring8),
    (25.5/38*2*pi, (ring7+ring8)/2, 25.0/38*2*pi, 26.0/38*2*pi,ring7,ring8),
    (26.5/38*2*pi, (ring7+ring8)/2, 26.0/38*2*pi, 27.0/38*2*pi,ring7,ring8),
    (27.5/38*2*pi, (ring7+ring8)/2, 27.0/38*2*pi, 28.0/38*2*pi,ring7,ring8),
    (28.5/38*2*pi, (ring7+ring8)/2, 28.0/38*2*pi, 29.0/38*2*pi,ring7,ring8),
    (29.5/38*2*pi, (ring7+ring8)/2, 29.0/38*2*pi, 30.0/38*2*pi,ring7,ring8),
    (30.5/38*2*pi, (ring7+ring8)/2, 30.0/38*2*pi, 31.0/38*2*pi,ring7,ring8),
    (31.5/38*2*pi, (ring7+ring8)/2, 31.0/38*2*pi, 32.0/38*2*pi,ring7,ring8),
    (32.5/38*2*pi, (ring7+ring8)/2, 32.0/38*2*pi, 33.0/38*2*pi,ring7,ring8),
    (33.5/38*2*pi, (ring7+ring8)/2, 33.0/38*2*pi, 34.0/38*2*pi,ring7,ring8),
    (34.5/38*2*pi, (ring7+ring8)/2, 34.0/38*2*pi, 35.0/38*2*pi,ring7,ring8),
    (35.5/38*2*pi, (ring7+ring8)/2, 35.0/38*2*pi, 36.0/38*2*pi,ring7,ring8),
    (36.5/38*2*pi, (ring7+ring8)/2, 36.0/38*2*pi, 37.0/38*2*pi,ring7,ring8),
    (37.5/38*2*pi, (ring7+ring8)/2, 37.0/38*2*pi, 38.0/38*2*pi,ring7,ring8),

    (0.5/43*2*pi, (ring8+ring9)/2, 0.0/43*2*pi, 1.0/43*2*pi,ring8,ring9),
    (1.5/43*2*pi, (ring8+ring9)/2, 1.0/43*2*pi, 2.0/43*2*pi,ring8,ring9),
    (2.5/43*2*pi, (ring8+ring9)/2, 2.0/43*2*pi, 3.0/43*2*pi,ring8,ring9),
    (3.5/43*2*pi, (ring8+ring9)/2, 3.0/43*2*pi, 4.0/43*2*pi,ring8,ring9),
    (4.5/43*2*pi, (ring8+ring9)/2, 4.0/43*2*pi, 5.0/43*2*pi,ring8,ring9),
    (5.5/43*2*pi, (ring8+ring9)/2, 5.0/43*2*pi, 6.0/43*2*pi,ring8,ring9),
    (6.5/43*2*pi, (ring8+ring9)/2, 6.0/43*2*pi, 7.0/43*2*pi,ring8,ring9),
    (7.5/43*2*pi, (ring8+ring9)/2, 7.0/43*2*pi, 8.0/43*2*pi,ring8,ring9),
    (8.5/43*2*pi, (ring8+ring9)/2, 8.0/43*2*pi, 9.0/43*2*pi,ring8,ring9),
    (9.5/43*2*pi, (ring8+ring9)/2, 9.0/43*2*pi, 10.0/43*2*pi,ring8,ring9),
    (10.5/43*2*pi, (ring8+ring9)/2, 10.0/43*2*pi, 11.0/43*2*pi,ring8,ring9),
    (11.5/43*2*pi, (ring8+ring9)/2, 11.0/43*2*pi, 12.0/43*2*pi,ring8,ring9),
    (12.5/43*2*pi, (ring8+ring9)/2, 12.0/43*2*pi, 13.0/43*2*pi,ring8,ring9),
    (13.5/43*2*pi, (ring8+ring9)/2, 13.0/43*2*pi, 14.0/43*2*pi,ring8,ring9),
    (14.5/43*2*pi, (ring8+ring9)/2, 14.0/43*2*pi, 15.0/43*2*pi,ring8,ring9),
    (15.5/43*2*pi, (ring8+ring9)/2, 15.0/43*2*pi, 16.0/43*2*pi,ring8,ring9),
    (16.5/43*2*pi, (ring8+ring9)/2, 16.0/43*2*pi, 17.0/43*2*pi,ring8,ring9),
    (17.5/43*2*pi, (ring8+ring9)/2, 17.0/43*2*pi, 18.0/43*2*pi,ring8,ring9),
    (18.5/43*2*pi, (ring8+ring9)/2, 18.0/43*2*pi, 19.0/43*2*pi,ring8,ring9),
    (19.5/43*2*pi, (ring8+ring9)/2, 19.0/43*2*pi, 20.0/43*2*pi,ring8,ring9),
    (20.5/43*2*pi, (ring8+ring9)/2, 20.0/43*2*pi, 21.0/43*2*pi,ring8,ring9),
    (21.5/43*2*pi, (ring8+ring9)/2, 21.0/43*2*pi, 22.0/43*2*pi,ring8,ring9),
    (22.5/43*2*pi, (ring8+ring9)/2, 22.0/43*2*pi, 23.0/43*2*pi,ring8,ring9),
    (23.5/43*2*pi, (ring8+ring9)/2, 23.0/43*2*pi, 24.0/43*2*pi,ring8,ring9),
    (24.5/43*2*pi, (ring8+ring9)/2, 24.0/43*2*pi, 25.0/43*2*pi,ring8,ring9),
    (25.5/43*2*pi, (ring8+ring9)/2, 25.0/43*2*pi, 26.0/43*2*pi,ring8,ring9),
    (26.5/43*2*pi, (ring8+ring9)/2, 26.0/43*2*pi, 27.0/43*2*pi,ring8,ring9),
    (27.5/43*2*pi, (ring8+ring9)/2, 27.0/43*2*pi, 28.0/43*2*pi,ring8,ring9),
    (28.5/43*2*pi, (ring8+ring9)/2, 28.0/43*2*pi, 29.0/43*2*pi,ring8,ring9),
    (29.5/43*2*pi, (ring8+ring9)/2, 29.0/43*2*pi, 30.0/43*2*pi,ring8,ring9),
    (30.5/43*2*pi, (ring8+ring9)/2, 30.0/43*2*pi, 31.0/43*2*pi,ring8,ring9),
    (31.5/43*2*pi, (ring8+ring9)/2, 31.0/43*2*pi, 32.0/43*2*pi,ring8,ring9),
    (32.5/43*2*pi, (ring8+ring9)/2, 32.0/43*2*pi, 33.0/43*2*pi,ring8,ring9),
    (33.5/43*2*pi, (ring8+ring9)/2, 33.0/43*2*pi, 34.0/43*2*pi,ring8,ring9),
    (34.5/43*2*pi, (ring8+ring9)/2, 34.0/43*2*pi, 35.0/43*2*pi,ring8,ring9),
    (35.5/43*2*pi, (ring8+ring9)/2, 35.0/43*2*pi, 36.0/43*2*pi,ring8,ring9),
    (36.5/43*2*pi, (ring8+ring9)/2, 36.0/43*2*pi, 37.0/43*2*pi,ring8,ring9),
    (37.5/43*2*pi, (ring8+ring9)/2, 37.0/43*2*pi, 38.0/43*2*pi,ring8,ring9),
    (38.5/43*2*pi, (ring8+ring9)/2, 38.0/43*2*pi, 39.0/43*2*pi,ring8,ring9),
    (39.5/43*2*pi, (ring8+ring9)/2, 39.0/43*2*pi, 40.0/43*2*pi,ring8,ring9),
    (40.5/43*2*pi, (ring8+ring9)/2, 40.0/43*2*pi, 41.0/43*2*pi,ring8,ring9),
    (41.5/43*2*pi, (ring8+ring9)/2, 41.0/43*2*pi, 42.0/43*2*pi,ring8,ring9),
    (42.5/43*2*pi, (ring8+ring9)/2, 42.0/43*2*pi, 43.0/43*2*pi,ring8,ring9),


    (0.5/48*2*pi, (ring9+ring10)/2, 0.0/48*2*pi, 1.0/48*2*pi,ring9,ring10),
    (1.5/48*2*pi, (ring9+ring10)/2, 1.0/48*2*pi, 2.0/48*2*pi,ring9,ring10),
    (2.5/48*2*pi, (ring9+ring10)/2, 2.0/48*2*pi, 3.0/48*2*pi,ring9,ring10),
    (3.5/48*2*pi, (ring9+ring10)/2, 3.0/48*2*pi, 4.0/48*2*pi,ring9,ring10),
    (4.5/48*2*pi, (ring9+ring10)/2, 4.0/48*2*pi, 5.0/48*2*pi,ring9,ring10),
    (5.5/48*2*pi, (ring9+ring10)/2, 5.0/48*2*pi, 6.0/48*2*pi,ring9,ring10),
    (6.5/48*2*pi, (ring9+ring10)/2, 6.0/48*2*pi, 7.0/48*2*pi,ring9,ring10),
    (7.5/48*2*pi, (ring9+ring10)/2, 7.0/48*2*pi, 8.0/48*2*pi,ring9,ring10),
    (8.5/48*2*pi, (ring9+ring10)/2, 8.0/48*2*pi, 9.0/48*2*pi,ring9,ring10),
    (9.5/48*2*pi, (ring9+ring10)/2, 9.0/48*2*pi, 10.0/48*2*pi,ring9,ring10),
    (10.5/48*2*pi, (ring9+ring10)/2, 10.0/48*2*pi, 11.0/48*2*pi,ring9,ring10),
    (11.5/48*2*pi, (ring9+ring10)/2, 11.0/48*2*pi, 12.0/48*2*pi,ring9,ring10),
    (12.5/48*2*pi, (ring9+ring10)/2, 12.0/48*2*pi, 13.0/48*2*pi,ring9,ring10),
    (13.5/48*2*pi, (ring9+ring10)/2, 13.0/48*2*pi, 14.0/48*2*pi,ring9,ring10),
    (14.5/48*2*pi, (ring9+ring10)/2, 14.0/48*2*pi, 15.0/48*2*pi,ring9,ring10),
    (15.5/48*2*pi, (ring9+ring10)/2, 15.0/48*2*pi, 16.0/48*2*pi,ring9,ring10),
    (16.5/48*2*pi, (ring9+ring10)/2, 16.0/48*2*pi, 17.0/48*2*pi,ring9,ring10),
    (17.5/48*2*pi, (ring9+ring10)/2, 17.0/48*2*pi, 18.0/48*2*pi,ring9,ring10),
    (18.5/48*2*pi, (ring9+ring10)/2, 18.0/48*2*pi, 19.0/48*2*pi,ring9,ring10),
    (19.5/48*2*pi, (ring9+ring10)/2, 19.0/48*2*pi, 20.0/48*2*pi,ring9,ring10),
    (20.5/48*2*pi, (ring9+ring10)/2, 20.0/48*2*pi, 21.0/48*2*pi,ring9,ring10),
    (21.5/48*2*pi, (ring9+ring10)/2, 21.0/48*2*pi, 22.0/48*2*pi,ring9,ring10),
    (22.5/48*2*pi, (ring9+ring10)/2, 22.0/48*2*pi, 23.0/48*2*pi,ring9,ring10),
    (23.5/48*2*pi, (ring9+ring10)/2, 23.0/48*2*pi, 24.0/48*2*pi,ring9,ring10),
    (24.5/48*2*pi, (ring9+ring10)/2, 24.0/48*2*pi, 25.0/48*2*pi,ring9,ring10),
    (25.5/48*2*pi, (ring9+ring10)/2, 25.0/48*2*pi, 26.0/48*2*pi,ring9,ring10),
    (26.5/48*2*pi, (ring9+ring10)/2, 26.0/48*2*pi, 27.0/48*2*pi,ring9,ring10),
    (27.5/48*2*pi, (ring9+ring10)/2, 27.0/48*2*pi, 28.0/48*2*pi,ring9,ring10),
    (28.5/48*2*pi, (ring9+ring10)/2, 28.0/48*2*pi, 29.0/48*2*pi,ring9,ring10),
    (29.5/48*2*pi, (ring9+ring10)/2, 29.0/48*2*pi, 30.0/48*2*pi,ring9,ring10),
    (30.5/48*2*pi, (ring9+ring10)/2, 30.0/48*2*pi, 31.0/48*2*pi,ring9,ring10),
    (31.5/48*2*pi, (ring9+ring10)/2, 31.0/48*2*pi, 32.0/48*2*pi,ring9,ring10),
    (32.5/48*2*pi, (ring9+ring10)/2, 32.0/48*2*pi, 33.0/48*2*pi,ring9,ring10),
    (33.5/48*2*pi, (ring9+ring10)/2, 33.0/48*2*pi, 34.0/48*2*pi,ring9,ring10),
    (34.5/48*2*pi, (ring9+ring10)/2, 34.0/48*2*pi, 35.0/48*2*pi,ring9,ring10),
    (35.5/48*2*pi, (ring9+ring10)/2, 35.0/48*2*pi, 36.0/48*2*pi,ring9,ring10),
    (36.5/48*2*pi, (ring9+ring10)/2, 36.0/48*2*pi, 37.0/48*2*pi,ring9,ring10),
    (37.5/48*2*pi, (ring9+ring10)/2, 37.0/48*2*pi, 38.0/48*2*pi,ring9,ring10),
    (38.5/48*2*pi, (ring9+ring10)/2, 38.0/48*2*pi, 39.0/48*2*pi,ring9,ring10),
    (39.5/48*2*pi, (ring9+ring10)/2, 39.0/48*2*pi, 40.0/48*2*pi,ring9,ring10),
    (40.5/48*2*pi, (ring9+ring10)/2, 40.0/48*2*pi, 41.0/48*2*pi,ring9,ring10),
    (41.5/48*2*pi, (ring9+ring10)/2, 41.0/48*2*pi, 42.0/48*2*pi,ring9,ring10),
    (42.5/48*2*pi, (ring9+ring10)/2, 42.0/48*2*pi, 43.0/48*2*pi,ring9,ring10),
    (43.5/48*2*pi, (ring9+ring10)/2, 43.0/48*2*pi, 44.0/48*2*pi,ring9,ring10),
    (44.5/48*2*pi, (ring9+ring10)/2, 44.0/48*2*pi, 45.0/48*2*pi,ring9,ring10),
    (45.5/48*2*pi, (ring9+ring10)/2, 45.0/48*2*pi, 46.0/48*2*pi,ring9,ring10),
    (46.5/48*2*pi, (ring9+ring10)/2, 46.0/48*2*pi, 47.0/48*2*pi,ring9,ring10),
    (47.5/48*2*pi, (ring9+ring10)/2, 47.0/48*2*pi, 48.0/48*2*pi,ring9,ring10),



    (0.5/52*2*pi, (ring10+ring11)/2, 0.0/52*2*pi, 1.0/52*2*pi,ring10,ring11),
    (1.5/52*2*pi, (ring10+ring11)/2, 1.0/52*2*pi, 2.0/52*2*pi,ring10,ring11),
    (2.5/52*2*pi, (ring10+ring11)/2, 2.0/52*2*pi, 3.0/52*2*pi,ring10,ring11),
    (3.5/52*2*pi, (ring10+ring11)/2, 3.0/52*2*pi, 4.0/52*2*pi,ring10,ring11),
    (4.5/52*2*pi, (ring10+ring11)/2, 4.0/52*2*pi, 5.0/52*2*pi,ring10,ring11),
    (5.5/52*2*pi, (ring10+ring11)/2, 5.0/52*2*pi, 6.0/52*2*pi,ring10,ring11),
    (6.5/52*2*pi, (ring10+ring11)/2, 6.0/52*2*pi, 7.0/52*2*pi,ring10,ring11),
    (7.5/52*2*pi, (ring10+ring11)/2, 7.0/52*2*pi, 8.0/52*2*pi,ring10,ring11),
    (8.5/52*2*pi, (ring10+ring11)/2, 8.0/52*2*pi, 9.0/52*2*pi,ring10,ring11),
    (9.5/52*2*pi, (ring10+ring11)/2, 9.0/52*2*pi, 10.0/52*2*pi,ring10,ring11),
    (10.5/52*2*pi, (ring10+ring11)/2, 10.0/52*2*pi, 11.0/52*2*pi,ring10,ring11),
    (11.5/52*2*pi, (ring10+ring11)/2, 11.0/52*2*pi, 12.0/52*2*pi,ring10,ring11),
    (12.5/52*2*pi, (ring10+ring11)/2, 12.0/52*2*pi, 13.0/52*2*pi,ring10,ring11),
    (13.5/52*2*pi, (ring10+ring11)/2, 13.0/52*2*pi, 14.0/52*2*pi,ring10,ring11),
    (14.5/52*2*pi, (ring10+ring11)/2, 14.0/52*2*pi, 15.0/52*2*pi,ring10,ring11),
    (15.5/52*2*pi, (ring10+ring11)/2, 15.0/52*2*pi, 16.0/52*2*pi,ring10,ring11),
    (16.5/52*2*pi, (ring10+ring11)/2, 16.0/52*2*pi, 17.0/52*2*pi,ring10,ring11),
    (17.5/52*2*pi, (ring10+ring11)/2, 17.0/52*2*pi, 18.0/52*2*pi,ring10,ring11),
    (18.5/52*2*pi, (ring10+ring11)/2, 18.0/52*2*pi, 19.0/52*2*pi,ring10,ring11),
    (19.5/52*2*pi, (ring10+ring11)/2, 19.0/52*2*pi, 20.0/52*2*pi,ring10,ring11),
    (20.5/52*2*pi, (ring10+ring11)/2, 20.0/52*2*pi, 21.0/52*2*pi,ring10,ring11),
    (21.5/52*2*pi, (ring10+ring11)/2, 21.0/52*2*pi, 22.0/52*2*pi,ring10,ring11),
    (22.5/52*2*pi, (ring10+ring11)/2, 22.0/52*2*pi, 23.0/52*2*pi,ring10,ring11),
    (23.5/52*2*pi, (ring10+ring11)/2, 23.0/52*2*pi, 24.0/52*2*pi,ring10,ring11),
    (24.5/52*2*pi, (ring10+ring11)/2, 24.0/52*2*pi, 25.0/52*2*pi,ring10,ring11),
    (25.5/52*2*pi, (ring10+ring11)/2, 25.0/52*2*pi, 26.0/52*2*pi,ring10,ring11),
    (26.5/52*2*pi, (ring10+ring11)/2, 26.0/52*2*pi, 27.0/52*2*pi,ring10,ring11),
    (27.5/52*2*pi, (ring10+ring11)/2, 27.0/52*2*pi, 28.0/52*2*pi,ring10,ring11),
    (28.5/52*2*pi, (ring10+ring11)/2, 28.0/52*2*pi, 29.0/52*2*pi,ring10,ring11),
    (29.5/52*2*pi, (ring10+ring11)/2, 29.0/52*2*pi, 30.0/52*2*pi,ring10,ring11),
    (30.5/52*2*pi, (ring10+ring11)/2, 30.0/52*2*pi, 31.0/52*2*pi,ring10,ring11),
    (31.5/52*2*pi, (ring10+ring11)/2, 31.0/52*2*pi, 32.0/52*2*pi,ring10,ring11),
    (32.5/52*2*pi, (ring10+ring11)/2, 32.0/52*2*pi, 33.0/52*2*pi,ring10,ring11),
    (33.5/52*2*pi, (ring10+ring11)/2, 33.0/52*2*pi, 34.0/52*2*pi,ring10,ring11),
    (34.5/52*2*pi, (ring10+ring11)/2, 34.0/52*2*pi, 35.0/52*2*pi,ring10,ring11),
    (35.5/52*2*pi, (ring10+ring11)/2, 35.0/52*2*pi, 36.0/52*2*pi,ring10,ring11),
    (36.5/52*2*pi, (ring10+ring11)/2, 36.0/52*2*pi, 37.0/52*2*pi,ring10,ring11),
    (37.5/52*2*pi, (ring10+ring11)/2, 37.0/52*2*pi, 38.0/52*2*pi,ring10,ring11),
    (38.5/52*2*pi, (ring10+ring11)/2, 38.0/52*2*pi, 39.0/52*2*pi,ring10,ring11),
    (39.5/52*2*pi, (ring10+ring11)/2, 39.0/52*2*pi, 40.0/52*2*pi,ring10,ring11),
    (40.5/52*2*pi, (ring10+ring11)/2, 40.0/52*2*pi, 41.0/52*2*pi,ring10,ring11),
    (41.5/52*2*pi, (ring10+ring11)/2, 41.0/52*2*pi, 42.0/52*2*pi,ring10,ring11),
    (42.5/52*2*pi, (ring10+ring11)/2, 42.0/52*2*pi, 43.0/52*2*pi,ring10,ring11),
    (43.5/52*2*pi, (ring10+ring11)/2, 43.0/52*2*pi, 44.0/52*2*pi,ring10,ring11),
    (44.5/52*2*pi, (ring10+ring11)/2, 44.0/52*2*pi, 45.0/52*2*pi,ring10,ring11),
    (45.5/52*2*pi, (ring10+ring11)/2, 45.0/52*2*pi, 46.0/52*2*pi,ring10,ring11),
    (46.5/52*2*pi, (ring10+ring11)/2, 46.0/52*2*pi, 47.0/52*2*pi,ring10,ring11),
    (47.5/52*2*pi, (ring10+ring11)/2, 47.0/52*2*pi, 48.0/52*2*pi,ring10,ring11),
    (48.5/52*2*pi, (ring10+ring11)/2, 48.0/52*2*pi, 49.0/52*2*pi,ring10,ring11),
    (49.5/52*2*pi, (ring10+ring11)/2, 49.0/52*2*pi, 50.0/52*2*pi,ring10,ring11),
    (50.5/52*2*pi, (ring10+ring11)/2, 50.0/52*2*pi, 51.0/52*2*pi,ring10,ring11),
    (51.5/52*2*pi, (ring10+ring11)/2, 51.0/52*2*pi, 52.0/52*2*pi,ring10,ring11),



    (0.5/56*2*pi, (ring11+ring12)/2, 0.0/56*2*pi, 1.0/56*2*pi,ring11,ring12),
    (1.5/56*2*pi, (ring11+ring12)/2, 1.0/56*2*pi, 2.0/56*2*pi,ring11,ring12),
    (2.5/56*2*pi, (ring11+ring12)/2, 2.0/56*2*pi, 3.0/56*2*pi,ring11,ring12),
    (3.5/56*2*pi, (ring11+ring12)/2, 3.0/56*2*pi, 4.0/56*2*pi,ring11,ring12),
    (4.5/56*2*pi, (ring11+ring12)/2, 4.0/56*2*pi, 5.0/56*2*pi,ring11,ring12),
    (5.5/56*2*pi, (ring11+ring12)/2, 5.0/56*2*pi, 6.0/56*2*pi,ring11,ring12),
    (6.5/56*2*pi, (ring11+ring12)/2, 6.0/56*2*pi, 7.0/56*2*pi,ring11,ring12),
    (7.5/56*2*pi, (ring11+ring12)/2, 7.0/56*2*pi, 8.0/56*2*pi,ring11,ring12),
    (8.5/56*2*pi, (ring11+ring12)/2, 8.0/56*2*pi, 9.0/56*2*pi,ring11,ring12),
    (9.5/56*2*pi, (ring11+ring12)/2, 9.0/56*2*pi, 10.0/56*2*pi,ring11,ring12),
    (10.5/56*2*pi, (ring11+ring12)/2, 10.0/56*2*pi, 11.0/56*2*pi,ring11,ring12),
    (11.5/56*2*pi, (ring11+ring12)/2, 11.0/56*2*pi, 12.0/56*2*pi,ring11,ring12),
    (12.5/56*2*pi, (ring11+ring12)/2, 12.0/56*2*pi, 13.0/56*2*pi,ring11,ring12),
    (13.5/56*2*pi, (ring11+ring12)/2, 13.0/56*2*pi, 14.0/56*2*pi,ring11,ring12),
    (14.5/56*2*pi, (ring11+ring12)/2, 14.0/56*2*pi, 15.0/56*2*pi,ring11,ring12),
    (15.5/56*2*pi, (ring11+ring12)/2, 15.0/56*2*pi, 16.0/56*2*pi,ring11,ring12),
    (16.5/56*2*pi, (ring11+ring12)/2, 16.0/56*2*pi, 17.0/56*2*pi,ring11,ring12),
    (17.5/56*2*pi, (ring11+ring12)/2, 17.0/56*2*pi, 18.0/56*2*pi,ring11,ring12),
    (18.5/56*2*pi, (ring11+ring12)/2, 18.0/56*2*pi, 19.0/56*2*pi,ring11,ring12),
    (19.5/56*2*pi, (ring11+ring12)/2, 19.0/56*2*pi, 20.0/56*2*pi,ring11,ring12),
    (20.5/56*2*pi, (ring11+ring12)/2, 20.0/56*2*pi, 21.0/56*2*pi,ring11,ring12),
    (21.5/56*2*pi, (ring11+ring12)/2, 21.0/56*2*pi, 22.0/56*2*pi,ring11,ring12),
    (22.5/56*2*pi, (ring11+ring12)/2, 22.0/56*2*pi, 23.0/56*2*pi,ring11,ring12),
    (23.5/56*2*pi, (ring11+ring12)/2, 23.0/56*2*pi, 24.0/56*2*pi,ring11,ring12),
    (24.5/56*2*pi, (ring11+ring12)/2, 24.0/56*2*pi, 25.0/56*2*pi,ring11,ring12),
    (25.5/56*2*pi, (ring11+ring12)/2, 25.0/56*2*pi, 26.0/56*2*pi,ring11,ring12),
    (26.5/56*2*pi, (ring11+ring12)/2, 26.0/56*2*pi, 27.0/56*2*pi,ring11,ring12),
    (27.5/56*2*pi, (ring11+ring12)/2, 27.0/56*2*pi, 28.0/56*2*pi,ring11,ring12),
    (28.5/56*2*pi, (ring11+ring12)/2, 28.0/56*2*pi, 29.0/56*2*pi,ring11,ring12),
    (29.5/56*2*pi, (ring11+ring12)/2, 29.0/56*2*pi, 30.0/56*2*pi,ring11,ring12),
    (30.5/56*2*pi, (ring11+ring12)/2, 30.0/56*2*pi, 31.0/56*2*pi,ring11,ring12),
    (31.5/56*2*pi, (ring11+ring12)/2, 31.0/56*2*pi, 32.0/56*2*pi,ring11,ring12),
    (32.5/56*2*pi, (ring11+ring12)/2, 32.0/56*2*pi, 33.0/56*2*pi,ring11,ring12),
    (33.5/56*2*pi, (ring11+ring12)/2, 33.0/56*2*pi, 34.0/56*2*pi,ring11,ring12),
    (34.5/56*2*pi, (ring11+ring12)/2, 34.0/56*2*pi, 35.0/56*2*pi,ring11,ring12),
    (35.5/56*2*pi, (ring11+ring12)/2, 35.0/56*2*pi, 36.0/56*2*pi,ring11,ring12),
    (36.5/56*2*pi, (ring11+ring12)/2, 36.0/56*2*pi, 37.0/56*2*pi,ring11,ring12),
    (37.5/56*2*pi, (ring11+ring12)/2, 37.0/56*2*pi, 38.0/56*2*pi,ring11,ring12),
    (38.5/56*2*pi, (ring11+ring12)/2, 38.0/56*2*pi, 39.0/56*2*pi,ring11,ring12),
    (39.5/56*2*pi, (ring11+ring12)/2, 39.0/56*2*pi, 40.0/56*2*pi,ring11,ring12),
    (40.5/56*2*pi, (ring11+ring12)/2, 40.0/56*2*pi, 41.0/56*2*pi,ring11,ring12),
    (41.5/56*2*pi, (ring11+ring12)/2, 41.0/56*2*pi, 42.0/56*2*pi,ring11,ring12),
    (42.5/56*2*pi, (ring11+ring12)/2, 42.0/56*2*pi, 43.0/56*2*pi,ring11,ring12),
    (43.5/56*2*pi, (ring11+ring12)/2, 43.0/56*2*pi, 44.0/56*2*pi,ring11,ring12),
    (44.5/56*2*pi, (ring11+ring12)/2, 44.0/56*2*pi, 45.0/56*2*pi,ring11,ring12),
    (45.5/56*2*pi, (ring11+ring12)/2, 45.0/56*2*pi, 46.0/56*2*pi,ring11,ring12),
    (46.5/56*2*pi, (ring11+ring12)/2, 46.0/56*2*pi, 47.0/56*2*pi,ring11,ring12),
    (47.5/56*2*pi, (ring11+ring12)/2, 47.0/56*2*pi, 48.0/56*2*pi,ring11,ring12),
    (48.5/56*2*pi, (ring11+ring12)/2, 48.0/56*2*pi, 49.0/56*2*pi,ring11,ring12),
    (49.5/56*2*pi, (ring11+ring12)/2, 49.0/56*2*pi, 50.0/56*2*pi,ring11,ring12),
    (50.5/56*2*pi, (ring11+ring12)/2, 50.0/56*2*pi, 51.0/56*2*pi,ring11,ring12),
    (51.5/56*2*pi, (ring11+ring12)/2, 51.0/56*2*pi, 52.0/56*2*pi,ring11,ring12),
    (52.5/56*2*pi, (ring11+ring12)/2, 52.0/56*2*pi, 53.0/56*2*pi,ring11,ring12),
    (53.5/56*2*pi, (ring11+ring12)/2, 53.0/56*2*pi, 54.0/56*2*pi,ring11,ring12),
    (54.5/56*2*pi, (ring11+ring12)/2, 54.0/56*2*pi, 55.0/56*2*pi,ring11,ring12),
    (55.5/56*2*pi, (ring11+ring12)/2, 55.0/56*2*pi, 56.0/56*2*pi,ring11,ring12),


    (0.5/60*2*pi, (ring12+ring13)/2, 0.0/60*2*pi, 1.0/60*2*pi,ring12,ring13),
    (1.5/60*2*pi, (ring12+ring13)/2, 1.0/60*2*pi, 2.0/60*2*pi,ring12,ring13),
    (2.5/60*2*pi, (ring12+ring13)/2, 2.0/60*2*pi, 3.0/60*2*pi,ring12,ring13),
    (3.5/60*2*pi, (ring12+ring13)/2, 3.0/60*2*pi, 4.0/60*2*pi,ring12,ring13),
    (4.5/60*2*pi, (ring12+ring13)/2, 4.0/60*2*pi, 5.0/60*2*pi,ring12,ring13),
    (5.5/60*2*pi, (ring12+ring13)/2, 5.0/60*2*pi, 6.0/60*2*pi,ring12,ring13),
    (6.5/60*2*pi, (ring12+ring13)/2, 6.0/60*2*pi, 7.0/60*2*pi,ring12,ring13),
    (7.5/60*2*pi, (ring12+ring13)/2, 7.0/60*2*pi, 8.0/60*2*pi,ring12,ring13),
    (8.5/60*2*pi, (ring12+ring13)/2, 8.0/60*2*pi, 9.0/60*2*pi,ring12,ring13),
    (9.5/60*2*pi, (ring12+ring13)/2, 9.0/60*2*pi, 10.0/60*2*pi,ring12,ring13),
    (10.5/60*2*pi, (ring12+ring13)/2, 10.0/60*2*pi, 11.0/60*2*pi,ring12,ring13),
    (11.5/60*2*pi, (ring12+ring13)/2, 11.0/60*2*pi, 12.0/60*2*pi,ring12,ring13),
    (12.5/60*2*pi, (ring12+ring13)/2, 12.0/60*2*pi, 13.0/60*2*pi,ring12,ring13),
    (13.5/60*2*pi, (ring12+ring13)/2, 13.0/60*2*pi, 14.0/60*2*pi,ring12,ring13),
    (14.5/60*2*pi, (ring12+ring13)/2, 14.0/60*2*pi, 15.0/60*2*pi,ring12,ring13),
    (15.5/60*2*pi, (ring12+ring13)/2, 15.0/60*2*pi, 16.0/60*2*pi,ring12,ring13),
    (16.5/60*2*pi, (ring12+ring13)/2, 16.0/60*2*pi, 17.0/60*2*pi,ring12,ring13),
    (17.5/60*2*pi, (ring12+ring13)/2, 17.0/60*2*pi, 18.0/60*2*pi,ring12,ring13),
    (18.5/60*2*pi, (ring12+ring13)/2, 18.0/60*2*pi, 19.0/60*2*pi,ring12,ring13),
    (19.5/60*2*pi, (ring12+ring13)/2, 19.0/60*2*pi, 20.0/60*2*pi,ring12,ring13),
    (20.5/60*2*pi, (ring12+ring13)/2, 20.0/60*2*pi, 21.0/60*2*pi,ring12,ring13),
    (21.5/60*2*pi, (ring12+ring13)/2, 21.0/60*2*pi, 22.0/60*2*pi,ring12,ring13),
    (22.5/60*2*pi, (ring12+ring13)/2, 22.0/60*2*pi, 23.0/60*2*pi,ring12,ring13),
    (23.5/60*2*pi, (ring12+ring13)/2, 23.0/60*2*pi, 24.0/60*2*pi,ring12,ring13),
    (24.5/60*2*pi, (ring12+ring13)/2, 24.0/60*2*pi, 25.0/60*2*pi,ring12,ring13),
    (25.5/60*2*pi, (ring12+ring13)/2, 25.0/60*2*pi, 26.0/60*2*pi,ring12,ring13),
    (26.5/60*2*pi, (ring12+ring13)/2, 26.0/60*2*pi, 27.0/60*2*pi,ring12,ring13),
    (27.5/60*2*pi, (ring12+ring13)/2, 27.0/60*2*pi, 28.0/60*2*pi,ring12,ring13),
    (28.5/60*2*pi, (ring12+ring13)/2, 28.0/60*2*pi, 29.0/60*2*pi,ring12,ring13),
    (29.5/60*2*pi, (ring12+ring13)/2, 29.0/60*2*pi, 30.0/60*2*pi,ring12,ring13),
    (30.5/60*2*pi, (ring12+ring13)/2, 30.0/60*2*pi, 31.0/60*2*pi,ring12,ring13),
    (31.5/60*2*pi, (ring12+ring13)/2, 31.0/60*2*pi, 32.0/60*2*pi,ring12,ring13),
    (32.5/60*2*pi, (ring12+ring13)/2, 32.0/60*2*pi, 33.0/60*2*pi,ring12,ring13),
    (33.5/60*2*pi, (ring12+ring13)/2, 33.0/60*2*pi, 34.0/60*2*pi,ring12,ring13),
    (34.5/60*2*pi, (ring12+ring13)/2, 34.0/60*2*pi, 35.0/60*2*pi,ring12,ring13),
    (35.5/60*2*pi, (ring12+ring13)/2, 35.0/60*2*pi, 36.0/60*2*pi,ring12,ring13),
    (36.5/60*2*pi, (ring12+ring13)/2, 36.0/60*2*pi, 37.0/60*2*pi,ring12,ring13),
    (37.5/60*2*pi, (ring12+ring13)/2, 37.0/60*2*pi, 38.0/60*2*pi,ring12,ring13),
    (38.5/60*2*pi, (ring12+ring13)/2, 38.0/60*2*pi, 39.0/60*2*pi,ring12,ring13),
    (39.5/60*2*pi, (ring12+ring13)/2, 39.0/60*2*pi, 40.0/60*2*pi,ring12,ring13),
    (40.5/60*2*pi, (ring12+ring13)/2, 40.0/60*2*pi, 41.0/60*2*pi,ring12,ring13),
    (41.5/60*2*pi, (ring12+ring13)/2, 41.0/60*2*pi, 42.0/60*2*pi,ring12,ring13),
    (42.5/60*2*pi, (ring12+ring13)/2, 42.0/60*2*pi, 43.0/60*2*pi,ring12,ring13),
    (43.5/60*2*pi, (ring12+ring13)/2, 43.0/60*2*pi, 44.0/60*2*pi,ring12,ring13),
    (44.5/60*2*pi, (ring12+ring13)/2, 44.0/60*2*pi, 45.0/60*2*pi,ring12,ring13),
    (45.5/60*2*pi, (ring12+ring13)/2, 45.0/60*2*pi, 46.0/60*2*pi,ring12,ring13),
    (46.5/60*2*pi, (ring12+ring13)/2, 46.0/60*2*pi, 47.0/60*2*pi,ring12,ring13),
    (47.5/60*2*pi, (ring12+ring13)/2, 47.0/60*2*pi, 48.0/60*2*pi,ring12,ring13),
    (48.5/60*2*pi, (ring12+ring13)/2, 48.0/60*2*pi, 49.0/60*2*pi,ring12,ring13),
    (49.5/60*2*pi, (ring12+ring13)/2, 49.0/60*2*pi, 50.0/60*2*pi,ring12,ring13),
    (50.5/60*2*pi, (ring12+ring13)/2, 50.0/60*2*pi, 51.0/60*2*pi,ring12,ring13),
    (51.5/60*2*pi, (ring12+ring13)/2, 51.0/60*2*pi, 52.0/60*2*pi,ring12,ring13),
    (52.5/60*2*pi, (ring12+ring13)/2, 52.0/60*2*pi, 53.0/60*2*pi,ring12,ring13),
    (53.5/60*2*pi, (ring12+ring13)/2, 53.0/60*2*pi, 54.0/60*2*pi,ring12,ring13),
    (54.5/60*2*pi, (ring12+ring13)/2, 54.0/60*2*pi, 55.0/60*2*pi,ring12,ring13),
    (55.5/60*2*pi, (ring12+ring13)/2, 55.0/60*2*pi, 56.0/60*2*pi,ring12,ring13),
    (56.5/60*2*pi, (ring12+ring13)/2, 56.0/60*2*pi, 57.0/60*2*pi,ring12,ring13),
    (57.5/60*2*pi, (ring12+ring13)/2, 57.0/60*2*pi, 58.0/60*2*pi,ring12,ring13),
    (58.5/60*2*pi, (ring12+ring13)/2, 58.0/60*2*pi, 59.0/60*2*pi,ring12,ring13),
    (59.5/60*2*pi, (ring12+ring13)/2, 59.0/60*2*pi, 60.0/60*2*pi,ring12,ring13),



    (0.5/63*2*pi, (ring13+ring14)/2, 0.0/63*2*pi, 1.0/63*2*pi,ring13,ring14),
    (1.5/63*2*pi, (ring13+ring14)/2, 1.0/63*2*pi, 2.0/63*2*pi,ring13,ring14),
    (2.5/63*2*pi, (ring13+ring14)/2, 2.0/63*2*pi, 3.0/63*2*pi,ring13,ring14),
    (3.5/63*2*pi, (ring13+ring14)/2, 3.0/63*2*pi, 4.0/63*2*pi,ring13,ring14),
    (4.5/63*2*pi, (ring13+ring14)/2, 4.0/63*2*pi, 5.0/63*2*pi,ring13,ring14),
    (5.5/63*2*pi, (ring13+ring14)/2, 5.0/63*2*pi, 6.0/63*2*pi,ring13,ring14),
    (6.5/63*2*pi, (ring13+ring14)/2, 6.0/63*2*pi, 7.0/63*2*pi,ring13,ring14),
    (7.5/63*2*pi, (ring13+ring14)/2, 7.0/63*2*pi, 8.0/63*2*pi,ring13,ring14),
    (8.5/63*2*pi, (ring13+ring14)/2, 8.0/63*2*pi, 9.0/63*2*pi,ring13,ring14),
    (9.5/63*2*pi, (ring13+ring14)/2, 9.0/63*2*pi, 10.0/63*2*pi,ring13,ring14),
    (10.5/63*2*pi, (ring13+ring14)/2, 10.0/63*2*pi, 11.0/63*2*pi,ring13,ring14),
    (11.5/63*2*pi, (ring13+ring14)/2, 11.0/63*2*pi, 12.0/63*2*pi,ring13,ring14),
    (12.5/63*2*pi, (ring13+ring14)/2, 12.0/63*2*pi, 13.0/63*2*pi,ring13,ring14),
    (13.5/63*2*pi, (ring13+ring14)/2, 13.0/63*2*pi, 14.0/63*2*pi,ring13,ring14),
    (14.5/63*2*pi, (ring13+ring14)/2, 14.0/63*2*pi, 15.0/63*2*pi,ring13,ring14),
    (15.5/63*2*pi, (ring13+ring14)/2, 15.0/63*2*pi, 16.0/63*2*pi,ring13,ring14),
    (16.5/63*2*pi, (ring13+ring14)/2, 16.0/63*2*pi, 17.0/63*2*pi,ring13,ring14),
    (17.5/63*2*pi, (ring13+ring14)/2, 17.0/63*2*pi, 18.0/63*2*pi,ring13,ring14),
    (18.5/63*2*pi, (ring13+ring14)/2, 18.0/63*2*pi, 19.0/63*2*pi,ring13,ring14),
    (19.5/63*2*pi, (ring13+ring14)/2, 19.0/63*2*pi, 20.0/63*2*pi,ring13,ring14),
    (20.5/63*2*pi, (ring13+ring14)/2, 20.0/63*2*pi, 21.0/63*2*pi,ring13,ring14),
    (21.5/63*2*pi, (ring13+ring14)/2, 21.0/63*2*pi, 22.0/63*2*pi,ring13,ring14),
    (22.5/63*2*pi, (ring13+ring14)/2, 22.0/63*2*pi, 23.0/63*2*pi,ring13,ring14),
    (23.5/63*2*pi, (ring13+ring14)/2, 23.0/63*2*pi, 24.0/63*2*pi,ring13,ring14),
    (24.5/63*2*pi, (ring13+ring14)/2, 24.0/63*2*pi, 25.0/63*2*pi,ring13,ring14),
    (25.5/63*2*pi, (ring13+ring14)/2, 25.0/63*2*pi, 26.0/63*2*pi,ring13,ring14),
    (26.5/63*2*pi, (ring13+ring14)/2, 26.0/63*2*pi, 27.0/63*2*pi,ring13,ring14),
    (27.5/63*2*pi, (ring13+ring14)/2, 27.0/63*2*pi, 28.0/63*2*pi,ring13,ring14),
    (28.5/63*2*pi, (ring13+ring14)/2, 28.0/63*2*pi, 29.0/63*2*pi,ring13,ring14),
    (29.5/63*2*pi, (ring13+ring14)/2, 29.0/63*2*pi, 30.0/63*2*pi,ring13,ring14),
    (30.5/63*2*pi, (ring13+ring14)/2, 30.0/63*2*pi, 31.0/63*2*pi,ring13,ring14),
    (31.5/63*2*pi, (ring13+ring14)/2, 31.0/63*2*pi, 32.0/63*2*pi,ring13,ring14),
    (32.5/63*2*pi, (ring13+ring14)/2, 32.0/63*2*pi, 33.0/63*2*pi,ring13,ring14),
    (33.5/63*2*pi, (ring13+ring14)/2, 33.0/63*2*pi, 34.0/63*2*pi,ring13,ring14),
    (34.5/63*2*pi, (ring13+ring14)/2, 34.0/63*2*pi, 35.0/63*2*pi,ring13,ring14),
    (35.5/63*2*pi, (ring13+ring14)/2, 35.0/63*2*pi, 36.0/63*2*pi,ring13,ring14),
    (36.5/63*2*pi, (ring13+ring14)/2, 36.0/63*2*pi, 37.0/63*2*pi,ring13,ring14),
    (37.5/63*2*pi, (ring13+ring14)/2, 37.0/63*2*pi, 38.0/63*2*pi,ring13,ring14),
    (38.5/63*2*pi, (ring13+ring14)/2, 38.0/63*2*pi, 39.0/63*2*pi,ring13,ring14),
    (39.5/63*2*pi, (ring13+ring14)/2, 39.0/63*2*pi, 40.0/63*2*pi,ring13,ring14),
    (40.5/63*2*pi, (ring13+ring14)/2, 40.0/63*2*pi, 41.0/63*2*pi,ring13,ring14),
    (41.5/63*2*pi, (ring13+ring14)/2, 41.0/63*2*pi, 42.0/63*2*pi,ring13,ring14),
    (42.5/63*2*pi, (ring13+ring14)/2, 42.0/63*2*pi, 43.0/63*2*pi,ring13,ring14),
    (43.5/63*2*pi, (ring13+ring14)/2, 43.0/63*2*pi, 44.0/63*2*pi,ring13,ring14),
    (44.5/63*2*pi, (ring13+ring14)/2, 44.0/63*2*pi, 45.0/63*2*pi,ring13,ring14),
    (45.5/63*2*pi, (ring13+ring14)/2, 45.0/63*2*pi, 46.0/63*2*pi,ring13,ring14),
    (46.5/63*2*pi, (ring13+ring14)/2, 46.0/63*2*pi, 47.0/63*2*pi,ring13,ring14),
    (47.5/63*2*pi, (ring13+ring14)/2, 47.0/63*2*pi, 48.0/63*2*pi,ring13,ring14),
    (48.5/63*2*pi, (ring13+ring14)/2, 48.0/63*2*pi, 49.0/63*2*pi,ring13,ring14),
    (49.5/63*2*pi, (ring13+ring14)/2, 49.0/63*2*pi, 50.0/63*2*pi,ring13,ring14),
    (50.5/63*2*pi, (ring13+ring14)/2, 50.0/63*2*pi, 51.0/63*2*pi,ring13,ring14),
    (51.5/63*2*pi, (ring13+ring14)/2, 51.0/63*2*pi, 52.0/63*2*pi,ring13,ring14),
    (52.5/63*2*pi, (ring13+ring14)/2, 52.0/63*2*pi, 53.0/63*2*pi,ring13,ring14),
    (53.5/63*2*pi, (ring13+ring14)/2, 53.0/63*2*pi, 54.0/63*2*pi,ring13,ring14),
    (54.5/63*2*pi, (ring13+ring14)/2, 54.0/63*2*pi, 55.0/63*2*pi,ring13,ring14),
    (55.5/63*2*pi, (ring13+ring14)/2, 55.0/63*2*pi, 56.0/63*2*pi,ring13,ring14),
    (56.5/63*2*pi, (ring13+ring14)/2, 56.0/63*2*pi, 57.0/63*2*pi,ring13,ring14),
    (57.5/63*2*pi, (ring13+ring14)/2, 57.0/63*2*pi, 58.0/63*2*pi,ring13,ring14),
    (58.5/63*2*pi, (ring13+ring14)/2, 58.0/63*2*pi, 59.0/63*2*pi,ring13,ring14),
    (59.5/63*2*pi, (ring13+ring14)/2, 59.0/63*2*pi, 60.0/63*2*pi,ring13,ring14),
    (60.5/63*2*pi, (ring13+ring14)/2, 60.0/63*2*pi, 61.0/63*2*pi,ring13,ring14),
    (61.5/63*2*pi, (ring13+ring14)/2, 61.0/63*2*pi, 62.0/63*2*pi,ring13,ring14),
    (62.5/63*2*pi, (ring13+ring14)/2, 62.0/63*2*pi, 63.0/63*2*pi,ring13,ring14),



    (0.5/65*2*pi, (ring14+ring15)/2, 0.0/65*2*pi, 1.0/65*2*pi,ring14,ring15),
    (1.5/65*2*pi, (ring14+ring15)/2, 1.0/65*2*pi, 2.0/65*2*pi,ring14,ring15),
    (2.5/65*2*pi, (ring14+ring15)/2, 2.0/65*2*pi, 3.0/65*2*pi,ring14,ring15),
    (3.5/65*2*pi, (ring14+ring15)/2, 3.0/65*2*pi, 4.0/65*2*pi,ring14,ring15),
    (4.5/65*2*pi, (ring14+ring15)/2, 4.0/65*2*pi, 5.0/65*2*pi,ring14,ring15),
    (5.5/65*2*pi, (ring14+ring15)/2, 5.0/65*2*pi, 6.0/65*2*pi,ring14,ring15),
    (6.5/65*2*pi, (ring14+ring15)/2, 6.0/65*2*pi, 7.0/65*2*pi,ring14,ring15),
    (7.5/65*2*pi, (ring14+ring15)/2, 7.0/65*2*pi, 8.0/65*2*pi,ring14,ring15),
    (8.5/65*2*pi, (ring14+ring15)/2, 8.0/65*2*pi, 9.0/65*2*pi,ring14,ring15),
    (9.5/65*2*pi, (ring14+ring15)/2, 9.0/65*2*pi, 10.0/65*2*pi,ring14,ring15),
    (10.5/65*2*pi, (ring14+ring15)/2, 10.0/65*2*pi, 11.0/65*2*pi,ring14,ring15),
    (11.5/65*2*pi, (ring14+ring15)/2, 11.0/65*2*pi, 12.0/65*2*pi,ring14,ring15),
    (12.5/65*2*pi, (ring14+ring15)/2, 12.0/65*2*pi, 13.0/65*2*pi,ring14,ring15),
    (13.5/65*2*pi, (ring14+ring15)/2, 13.0/65*2*pi, 14.0/65*2*pi,ring14,ring15),
    (14.5/65*2*pi, (ring14+ring15)/2, 14.0/65*2*pi, 15.0/65*2*pi,ring14,ring15),
    (15.5/65*2*pi, (ring14+ring15)/2, 15.0/65*2*pi, 16.0/65*2*pi,ring14,ring15),
    (16.5/65*2*pi, (ring14+ring15)/2, 16.0/65*2*pi, 17.0/65*2*pi,ring14,ring15),
    (17.5/65*2*pi, (ring14+ring15)/2, 17.0/65*2*pi, 18.0/65*2*pi,ring14,ring15),
    (18.5/65*2*pi, (ring14+ring15)/2, 18.0/65*2*pi, 19.0/65*2*pi,ring14,ring15),
    (19.5/65*2*pi, (ring14+ring15)/2, 19.0/65*2*pi, 20.0/65*2*pi,ring14,ring15),
    (20.5/65*2*pi, (ring14+ring15)/2, 20.0/65*2*pi, 21.0/65*2*pi,ring14,ring15),
    (21.5/65*2*pi, (ring14+ring15)/2, 21.0/65*2*pi, 22.0/65*2*pi,ring14,ring15),
    (22.5/65*2*pi, (ring14+ring15)/2, 22.0/65*2*pi, 23.0/65*2*pi,ring14,ring15),
    (23.5/65*2*pi, (ring14+ring15)/2, 23.0/65*2*pi, 24.0/65*2*pi,ring14,ring15),
    (24.5/65*2*pi, (ring14+ring15)/2, 24.0/65*2*pi, 25.0/65*2*pi,ring14,ring15),
    (25.5/65*2*pi, (ring14+ring15)/2, 25.0/65*2*pi, 26.0/65*2*pi,ring14,ring15),
    (26.5/65*2*pi, (ring14+ring15)/2, 26.0/65*2*pi, 27.0/65*2*pi,ring14,ring15),
    (27.5/65*2*pi, (ring14+ring15)/2, 27.0/65*2*pi, 28.0/65*2*pi,ring14,ring15),
    (28.5/65*2*pi, (ring14+ring15)/2, 28.0/65*2*pi, 29.0/65*2*pi,ring14,ring15),
    (29.5/65*2*pi, (ring14+ring15)/2, 29.0/65*2*pi, 30.0/65*2*pi,ring14,ring15),
    (30.5/65*2*pi, (ring14+ring15)/2, 30.0/65*2*pi, 31.0/65*2*pi,ring14,ring15),
    (31.5/65*2*pi, (ring14+ring15)/2, 31.0/65*2*pi, 32.0/65*2*pi,ring14,ring15),
    (32.5/65*2*pi, (ring14+ring15)/2, 32.0/65*2*pi, 33.0/65*2*pi,ring14,ring15),
    (33.5/65*2*pi, (ring14+ring15)/2, 33.0/65*2*pi, 34.0/65*2*pi,ring14,ring15),
    (34.5/65*2*pi, (ring14+ring15)/2, 34.0/65*2*pi, 35.0/65*2*pi,ring14,ring15),
    (35.5/65*2*pi, (ring14+ring15)/2, 35.0/65*2*pi, 36.0/65*2*pi,ring14,ring15),
    (36.5/65*2*pi, (ring14+ring15)/2, 36.0/65*2*pi, 37.0/65*2*pi,ring14,ring15),
    (37.5/65*2*pi, (ring14+ring15)/2, 37.0/65*2*pi, 38.0/65*2*pi,ring14,ring15),
    (38.5/65*2*pi, (ring14+ring15)/2, 38.0/65*2*pi, 39.0/65*2*pi,ring14,ring15),
    (39.5/65*2*pi, (ring14+ring15)/2, 39.0/65*2*pi, 40.0/65*2*pi,ring14,ring15),
    (40.5/65*2*pi, (ring14+ring15)/2, 40.0/65*2*pi, 41.0/65*2*pi,ring14,ring15),
    (41.5/65*2*pi, (ring14+ring15)/2, 41.0/65*2*pi, 42.0/65*2*pi,ring14,ring15),
    (42.5/65*2*pi, (ring14+ring15)/2, 42.0/65*2*pi, 43.0/65*2*pi,ring14,ring15),
    (43.5/65*2*pi, (ring14+ring15)/2, 43.0/65*2*pi, 44.0/65*2*pi,ring14,ring15),
    (44.5/65*2*pi, (ring14+ring15)/2, 44.0/65*2*pi, 45.0/65*2*pi,ring14,ring15),
    (45.5/65*2*pi, (ring14+ring15)/2, 45.0/65*2*pi, 46.0/65*2*pi,ring14,ring15),
    (46.5/65*2*pi, (ring14+ring15)/2, 46.0/65*2*pi, 47.0/65*2*pi,ring14,ring15),
    (47.5/65*2*pi, (ring14+ring15)/2, 47.0/65*2*pi, 48.0/65*2*pi,ring14,ring15),
    (48.5/65*2*pi, (ring14+ring15)/2, 48.0/65*2*pi, 49.0/65*2*pi,ring14,ring15),
    (49.5/65*2*pi, (ring14+ring15)/2, 49.0/65*2*pi, 50.0/65*2*pi,ring14,ring15),
    (50.5/65*2*pi, (ring14+ring15)/2, 50.0/65*2*pi, 51.0/65*2*pi,ring14,ring15),
    (51.5/65*2*pi, (ring14+ring15)/2, 51.0/65*2*pi, 52.0/65*2*pi,ring14,ring15),
    (52.5/65*2*pi, (ring14+ring15)/2, 52.0/65*2*pi, 53.0/65*2*pi,ring14,ring15),
    (53.5/65*2*pi, (ring14+ring15)/2, 53.0/65*2*pi, 54.0/65*2*pi,ring14,ring15),
    (54.5/65*2*pi, (ring14+ring15)/2, 54.0/65*2*pi, 55.0/65*2*pi,ring14,ring15),
    (55.5/65*2*pi, (ring14+ring15)/2, 55.0/65*2*pi, 56.0/65*2*pi,ring14,ring15),
    (56.5/65*2*pi, (ring14+ring15)/2, 56.0/65*2*pi, 57.0/65*2*pi,ring14,ring15),
    (57.5/65*2*pi, (ring14+ring15)/2, 57.0/65*2*pi, 58.0/65*2*pi,ring14,ring15),
    (58.5/65*2*pi, (ring14+ring15)/2, 58.0/65*2*pi, 59.0/65*2*pi,ring14,ring15),
    (59.5/65*2*pi, (ring14+ring15)/2, 59.0/65*2*pi, 60.0/65*2*pi,ring14,ring15),
    (60.5/65*2*pi, (ring14+ring15)/2, 60.0/65*2*pi, 61.0/65*2*pi,ring14,ring15),
    (61.5/65*2*pi, (ring14+ring15)/2, 61.0/65*2*pi, 62.0/65*2*pi,ring14,ring15),
    (62.5/65*2*pi, (ring14+ring15)/2, 62.0/65*2*pi, 63.0/65*2*pi,ring14,ring15),
    (63.5/65*2*pi, (ring14+ring15)/2, 63.0/65*2*pi, 64.0/65*2*pi,ring14,ring15),
    (64.5/65*2*pi, (ring14+ring15)/2, 64.0/65*2*pi, 65.0/65*2*pi,ring14,ring15),


    (0.5/67*2*pi, (ring15+ring16)/2, 0.0/67*2*pi, 1.0/67*2*pi,ring15,ring16),
    (1.5/67*2*pi, (ring15+ring16)/2, 1.0/67*2*pi, 2.0/67*2*pi,ring15,ring16),
    (2.5/67*2*pi, (ring15+ring16)/2, 2.0/67*2*pi, 3.0/67*2*pi,ring15,ring16),
    (3.5/67*2*pi, (ring15+ring16)/2, 3.0/67*2*pi, 4.0/67*2*pi,ring15,ring16),
    (4.5/67*2*pi, (ring15+ring16)/2, 4.0/67*2*pi, 5.0/67*2*pi,ring15,ring16),
    (5.5/67*2*pi, (ring15+ring16)/2, 5.0/67*2*pi, 6.0/67*2*pi,ring15,ring16),
    (6.5/67*2*pi, (ring15+ring16)/2, 6.0/67*2*pi, 7.0/67*2*pi,ring15,ring16),
    (7.5/67*2*pi, (ring15+ring16)/2, 7.0/67*2*pi, 8.0/67*2*pi,ring15,ring16),
    (8.5/67*2*pi, (ring15+ring16)/2, 8.0/67*2*pi, 9.0/67*2*pi,ring15,ring16),
    (9.5/67*2*pi, (ring15+ring16)/2, 9.0/67*2*pi, 10.0/67*2*pi,ring15,ring16),
    (10.5/67*2*pi, (ring15+ring16)/2, 10.0/67*2*pi, 11.0/67*2*pi,ring15,ring16),
    (11.5/67*2*pi, (ring15+ring16)/2, 11.0/67*2*pi, 12.0/67*2*pi,ring15,ring16),
    (12.5/67*2*pi, (ring15+ring16)/2, 12.0/67*2*pi, 13.0/67*2*pi,ring15,ring16),
    (13.5/67*2*pi, (ring15+ring16)/2, 13.0/67*2*pi, 14.0/67*2*pi,ring15,ring16),
    (14.5/67*2*pi, (ring15+ring16)/2, 14.0/67*2*pi, 15.0/67*2*pi,ring15,ring16),
    (15.5/67*2*pi, (ring15+ring16)/2, 15.0/67*2*pi, 16.0/67*2*pi,ring15,ring16),
    (16.5/67*2*pi, (ring15+ring16)/2, 16.0/67*2*pi, 17.0/67*2*pi,ring15,ring16),
    (17.5/67*2*pi, (ring15+ring16)/2, 17.0/67*2*pi, 18.0/67*2*pi,ring15,ring16),
    (18.5/67*2*pi, (ring15+ring16)/2, 18.0/67*2*pi, 19.0/67*2*pi,ring15,ring16),
    (19.5/67*2*pi, (ring15+ring16)/2, 19.0/67*2*pi, 20.0/67*2*pi,ring15,ring16),
    (20.5/67*2*pi, (ring15+ring16)/2, 20.0/67*2*pi, 21.0/67*2*pi,ring15,ring16),
    (21.5/67*2*pi, (ring15+ring16)/2, 21.0/67*2*pi, 22.0/67*2*pi,ring15,ring16),
    (22.5/67*2*pi, (ring15+ring16)/2, 22.0/67*2*pi, 23.0/67*2*pi,ring15,ring16),
    (23.5/67*2*pi, (ring15+ring16)/2, 23.0/67*2*pi, 24.0/67*2*pi,ring15,ring16),
    (24.5/67*2*pi, (ring15+ring16)/2, 24.0/67*2*pi, 25.0/67*2*pi,ring15,ring16),
    (25.5/67*2*pi, (ring15+ring16)/2, 25.0/67*2*pi, 26.0/67*2*pi,ring15,ring16),
    (26.5/67*2*pi, (ring15+ring16)/2, 26.0/67*2*pi, 27.0/67*2*pi,ring15,ring16),
    (27.5/67*2*pi, (ring15+ring16)/2, 27.0/67*2*pi, 28.0/67*2*pi,ring15,ring16),
    (28.5/67*2*pi, (ring15+ring16)/2, 28.0/67*2*pi, 29.0/67*2*pi,ring15,ring16),
    (29.5/67*2*pi, (ring15+ring16)/2, 29.0/67*2*pi, 30.0/67*2*pi,ring15,ring16),
    (30.5/67*2*pi, (ring15+ring16)/2, 30.0/67*2*pi, 31.0/67*2*pi,ring15,ring16),
    (31.5/67*2*pi, (ring15+ring16)/2, 31.0/67*2*pi, 32.0/67*2*pi,ring15,ring16),
    (32.5/67*2*pi, (ring15+ring16)/2, 32.0/67*2*pi, 33.0/67*2*pi,ring15,ring16),
    (33.5/67*2*pi, (ring15+ring16)/2, 33.0/67*2*pi, 34.0/67*2*pi,ring15,ring16),
    (34.5/67*2*pi, (ring15+ring16)/2, 34.0/67*2*pi, 35.0/67*2*pi,ring15,ring16),
    (35.5/67*2*pi, (ring15+ring16)/2, 35.0/67*2*pi, 36.0/67*2*pi,ring15,ring16),
    (36.5/67*2*pi, (ring15+ring16)/2, 36.0/67*2*pi, 37.0/67*2*pi,ring15,ring16),
    (37.5/67*2*pi, (ring15+ring16)/2, 37.0/67*2*pi, 38.0/67*2*pi,ring15,ring16),
    (38.5/67*2*pi, (ring15+ring16)/2, 38.0/67*2*pi, 39.0/67*2*pi,ring15,ring16),
    (39.5/67*2*pi, (ring15+ring16)/2, 39.0/67*2*pi, 40.0/67*2*pi,ring15,ring16),
    (40.5/67*2*pi, (ring15+ring16)/2, 40.0/67*2*pi, 41.0/67*2*pi,ring15,ring16),
    (41.5/67*2*pi, (ring15+ring16)/2, 41.0/67*2*pi, 42.0/67*2*pi,ring15,ring16),
    (42.5/67*2*pi, (ring15+ring16)/2, 42.0/67*2*pi, 43.0/67*2*pi,ring15,ring16),
    (43.5/67*2*pi, (ring15+ring16)/2, 43.0/67*2*pi, 44.0/67*2*pi,ring15,ring16),
    (44.5/67*2*pi, (ring15+ring16)/2, 44.0/67*2*pi, 45.0/67*2*pi,ring15,ring16),
    (45.5/67*2*pi, (ring15+ring16)/2, 45.0/67*2*pi, 46.0/67*2*pi,ring15,ring16),
    (46.5/67*2*pi, (ring15+ring16)/2, 46.0/67*2*pi, 47.0/67*2*pi,ring15,ring16),
    (47.5/67*2*pi, (ring15+ring16)/2, 47.0/67*2*pi, 48.0/67*2*pi,ring15,ring16),
    (48.5/67*2*pi, (ring15+ring16)/2, 48.0/67*2*pi, 49.0/67*2*pi,ring15,ring16),
    (49.5/67*2*pi, (ring15+ring16)/2, 49.0/67*2*pi, 50.0/67*2*pi,ring15,ring16),
    (50.5/67*2*pi, (ring15+ring16)/2, 50.0/67*2*pi, 51.0/67*2*pi,ring15,ring16),
    (51.5/67*2*pi, (ring15+ring16)/2, 51.0/67*2*pi, 52.0/67*2*pi,ring15,ring16),
    (52.5/67*2*pi, (ring15+ring16)/2, 52.0/67*2*pi, 53.0/67*2*pi,ring15,ring16),
    (53.5/67*2*pi, (ring15+ring16)/2, 53.0/67*2*pi, 54.0/67*2*pi,ring15,ring16),
    (54.5/67*2*pi, (ring15+ring16)/2, 54.0/67*2*pi, 55.0/67*2*pi,ring15,ring16),
    (55.5/67*2*pi, (ring15+ring16)/2, 55.0/67*2*pi, 56.0/67*2*pi,ring15,ring16),
    (56.5/67*2*pi, (ring15+ring16)/2, 56.0/67*2*pi, 57.0/67*2*pi,ring15,ring16),
    (57.5/67*2*pi, (ring15+ring16)/2, 57.0/67*2*pi, 58.0/67*2*pi,ring15,ring16),
    (58.5/67*2*pi, (ring15+ring16)/2, 58.0/67*2*pi, 59.0/67*2*pi,ring15,ring16),
    (59.5/67*2*pi, (ring15+ring16)/2, 59.0/67*2*pi, 60.0/67*2*pi,ring15,ring16),
    (60.5/67*2*pi, (ring15+ring16)/2, 60.0/67*2*pi, 61.0/67*2*pi,ring15,ring16),
    (61.5/67*2*pi, (ring15+ring16)/2, 61.0/67*2*pi, 62.0/67*2*pi,ring15,ring16),
    (62.5/67*2*pi, (ring15+ring16)/2, 62.0/67*2*pi, 63.0/67*2*pi,ring15,ring16),
    (63.5/67*2*pi, (ring15+ring16)/2, 63.0/67*2*pi, 64.0/67*2*pi,ring15,ring16),
    (64.5/67*2*pi, (ring15+ring16)/2, 64.0/67*2*pi, 65.0/67*2*pi,ring15,ring16),
    (65.5/67*2*pi, (ring15+ring16)/2, 65.0/67*2*pi, 66.0/67*2*pi,ring15,ring16),
    (66.5/67*2*pi, (ring15+ring16)/2, 66.0/67*2*pi, 67.0/67*2*pi,ring15,ring16),


    (0.5/68*2*pi, (ring16+ring17)/2, 0.0/68*2*pi, 1.0/68*2*pi,ring16,ring17),
    (1.5/68*2*pi, (ring16+ring17)/2, 1.0/68*2*pi, 2.0/68*2*pi,ring16,ring17),
    (2.5/68*2*pi, (ring16+ring17)/2, 2.0/68*2*pi, 3.0/68*2*pi,ring16,ring17),
    (3.5/68*2*pi, (ring16+ring17)/2, 3.0/68*2*pi, 4.0/68*2*pi,ring16,ring17),
    (4.5/68*2*pi, (ring16+ring17)/2, 4.0/68*2*pi, 5.0/68*2*pi,ring16,ring17),
    (5.5/68*2*pi, (ring16+ring17)/2, 5.0/68*2*pi, 6.0/68*2*pi,ring16,ring17),
    (6.5/68*2*pi, (ring16+ring17)/2, 6.0/68*2*pi, 7.0/68*2*pi,ring16,ring17),
    (7.5/68*2*pi, (ring16+ring17)/2, 7.0/68*2*pi, 8.0/68*2*pi,ring16,ring17),
    (8.5/68*2*pi, (ring16+ring17)/2, 8.0/68*2*pi, 9.0/68*2*pi,ring16,ring17),
    (9.5/68*2*pi, (ring16+ring17)/2, 9.0/68*2*pi, 10.0/68*2*pi,ring16,ring17),
    (10.5/68*2*pi, (ring16+ring17)/2, 10.0/68*2*pi, 11.0/68*2*pi,ring16,ring17),
    (11.5/68*2*pi, (ring16+ring17)/2, 11.0/68*2*pi, 12.0/68*2*pi,ring16,ring17),
    (12.5/68*2*pi, (ring16+ring17)/2, 12.0/68*2*pi, 13.0/68*2*pi,ring16,ring17),
    (13.5/68*2*pi, (ring16+ring17)/2, 13.0/68*2*pi, 14.0/68*2*pi,ring16,ring17),
    (14.5/68*2*pi, (ring16+ring17)/2, 14.0/68*2*pi, 15.0/68*2*pi,ring16,ring17),
    (15.5/68*2*pi, (ring16+ring17)/2, 15.0/68*2*pi, 16.0/68*2*pi,ring16,ring17),
    (16.5/68*2*pi, (ring16+ring17)/2, 16.0/68*2*pi, 17.0/68*2*pi,ring16,ring17),
    (17.5/68*2*pi, (ring16+ring17)/2, 17.0/68*2*pi, 18.0/68*2*pi,ring16,ring17),
    (18.5/68*2*pi, (ring16+ring17)/2, 18.0/68*2*pi, 19.0/68*2*pi,ring16,ring17),
    (19.5/68*2*pi, (ring16+ring17)/2, 19.0/68*2*pi, 20.0/68*2*pi,ring16,ring17),
    (20.5/68*2*pi, (ring16+ring17)/2, 20.0/68*2*pi, 21.0/68*2*pi,ring16,ring17),
    (21.5/68*2*pi, (ring16+ring17)/2, 21.0/68*2*pi, 22.0/68*2*pi,ring16,ring17),
    (22.5/68*2*pi, (ring16+ring17)/2, 22.0/68*2*pi, 23.0/68*2*pi,ring16,ring17),
    (23.5/68*2*pi, (ring16+ring17)/2, 23.0/68*2*pi, 24.0/68*2*pi,ring16,ring17),
    (24.5/68*2*pi, (ring16+ring17)/2, 24.0/68*2*pi, 25.0/68*2*pi,ring16,ring17),
    (25.5/68*2*pi, (ring16+ring17)/2, 25.0/68*2*pi, 26.0/68*2*pi,ring16,ring17),
    (26.5/68*2*pi, (ring16+ring17)/2, 26.0/68*2*pi, 27.0/68*2*pi,ring16,ring17),
    (27.5/68*2*pi, (ring16+ring17)/2, 27.0/68*2*pi, 28.0/68*2*pi,ring16,ring17),
    (28.5/68*2*pi, (ring16+ring17)/2, 28.0/68*2*pi, 29.0/68*2*pi,ring16,ring17),
    (29.5/68*2*pi, (ring16+ring17)/2, 29.0/68*2*pi, 30.0/68*2*pi,ring16,ring17),
    (30.5/68*2*pi, (ring16+ring17)/2, 30.0/68*2*pi, 31.0/68*2*pi,ring16,ring17),
    (31.5/68*2*pi, (ring16+ring17)/2, 31.0/68*2*pi, 32.0/68*2*pi,ring16,ring17),
    (32.5/68*2*pi, (ring16+ring17)/2, 32.0/68*2*pi, 33.0/68*2*pi,ring16,ring17),
    (33.5/68*2*pi, (ring16+ring17)/2, 33.0/68*2*pi, 34.0/68*2*pi,ring16,ring17),
    (34.5/68*2*pi, (ring16+ring17)/2, 34.0/68*2*pi, 35.0/68*2*pi,ring16,ring17),
    (35.5/68*2*pi, (ring16+ring17)/2, 35.0/68*2*pi, 36.0/68*2*pi,ring16,ring17),
    (36.5/68*2*pi, (ring16+ring17)/2, 36.0/68*2*pi, 37.0/68*2*pi,ring16,ring17),
    (37.5/68*2*pi, (ring16+ring17)/2, 37.0/68*2*pi, 38.0/68*2*pi,ring16,ring17),
    (38.5/68*2*pi, (ring16+ring17)/2, 38.0/68*2*pi, 39.0/68*2*pi,ring16,ring17),
    (39.5/68*2*pi, (ring16+ring17)/2, 39.0/68*2*pi, 40.0/68*2*pi,ring16,ring17),
    (40.5/68*2*pi, (ring16+ring17)/2, 40.0/68*2*pi, 41.0/68*2*pi,ring16,ring17),
    (41.5/68*2*pi, (ring16+ring17)/2, 41.0/68*2*pi, 42.0/68*2*pi,ring16,ring17),
    (42.5/68*2*pi, (ring16+ring17)/2, 42.0/68*2*pi, 43.0/68*2*pi,ring16,ring17),
    (43.5/68*2*pi, (ring16+ring17)/2, 43.0/68*2*pi, 44.0/68*2*pi,ring16,ring17),
    (44.5/68*2*pi, (ring16+ring17)/2, 44.0/68*2*pi, 45.0/68*2*pi,ring16,ring17),
    (45.5/68*2*pi, (ring16+ring17)/2, 45.0/68*2*pi, 46.0/68*2*pi,ring16,ring17),
    (46.5/68*2*pi, (ring16+ring17)/2, 46.0/68*2*pi, 47.0/68*2*pi,ring16,ring17),
    (47.5/68*2*pi, (ring16+ring17)/2, 47.0/68*2*pi, 48.0/68*2*pi,ring16,ring17),
    (48.5/68*2*pi, (ring16+ring17)/2, 48.0/68*2*pi, 49.0/68*2*pi,ring16,ring17),
    (49.5/68*2*pi, (ring16+ring17)/2, 49.0/68*2*pi, 50.0/68*2*pi,ring16,ring17),
    (50.5/68*2*pi, (ring16+ring17)/2, 50.0/68*2*pi, 51.0/68*2*pi,ring16,ring17),
    (51.5/68*2*pi, (ring16+ring17)/2, 51.0/68*2*pi, 52.0/68*2*pi,ring16,ring17),
    (52.5/68*2*pi, (ring16+ring17)/2, 52.0/68*2*pi, 53.0/68*2*pi,ring16,ring17),
    (53.5/68*2*pi, (ring16+ring17)/2, 53.0/68*2*pi, 54.0/68*2*pi,ring16,ring17),
    (54.5/68*2*pi, (ring16+ring17)/2, 54.0/68*2*pi, 55.0/68*2*pi,ring16,ring17),
    (55.5/68*2*pi, (ring16+ring17)/2, 55.0/68*2*pi, 56.0/68*2*pi,ring16,ring17),
    (56.5/68*2*pi, (ring16+ring17)/2, 56.0/68*2*pi, 57.0/68*2*pi,ring16,ring17),
    (57.5/68*2*pi, (ring16+ring17)/2, 57.0/68*2*pi, 58.0/68*2*pi,ring16,ring17),
    (58.5/68*2*pi, (ring16+ring17)/2, 58.0/68*2*pi, 59.0/68*2*pi,ring16,ring17),
    (59.5/68*2*pi, (ring16+ring17)/2, 59.0/68*2*pi, 60.0/68*2*pi,ring16,ring17),
    (60.5/68*2*pi, (ring16+ring17)/2, 60.0/68*2*pi, 61.0/68*2*pi,ring16,ring17),
    (61.5/68*2*pi, (ring16+ring17)/2, 61.0/68*2*pi, 62.0/68*2*pi,ring16,ring17),
    (62.5/68*2*pi, (ring16+ring17)/2, 62.0/68*2*pi, 63.0/68*2*pi,ring16,ring17),
    (63.5/68*2*pi, (ring16+ring17)/2, 63.0/68*2*pi, 64.0/68*2*pi,ring16,ring17),
    (64.5/68*2*pi, (ring16+ring17)/2, 64.0/68*2*pi, 65.0/68*2*pi,ring16,ring17),
    (65.5/68*2*pi, (ring16+ring17)/2, 65.0/68*2*pi, 66.0/68*2*pi,ring16,ring17),
    (66.5/68*2*pi, (ring16+ring17)/2, 66.0/68*2*pi, 67.0/68*2*pi,ring16,ring17),
    (67.5/68*2*pi, (ring16+ring17)/2, 67.0/68*2*pi, 68.0/68*2*pi,ring16,ring17),


    (0.5/69*2*pi, (ring17+ring18)/2, 0.0/69*2*pi, 1.0/69*2*pi,ring17,ring18),
    (1.5/69*2*pi, (ring17+ring18)/2, 1.0/69*2*pi, 2.0/69*2*pi,ring17,ring18),
    (2.5/69*2*pi, (ring17+ring18)/2, 2.0/69*2*pi, 3.0/69*2*pi,ring17,ring18),
    (3.5/69*2*pi, (ring17+ring18)/2, 3.0/69*2*pi, 4.0/69*2*pi,ring17,ring18),
    (4.5/69*2*pi, (ring17+ring18)/2, 4.0/69*2*pi, 5.0/69*2*pi,ring17,ring18),
    (5.5/69*2*pi, (ring17+ring18)/2, 5.0/69*2*pi, 6.0/69*2*pi,ring17,ring18),
    (6.5/69*2*pi, (ring17+ring18)/2, 6.0/69*2*pi, 7.0/69*2*pi,ring17,ring18),
    (7.5/69*2*pi, (ring17+ring18)/2, 7.0/69*2*pi, 8.0/69*2*pi,ring17,ring18),
    (8.5/69*2*pi, (ring17+ring18)/2, 8.0/69*2*pi, 9.0/69*2*pi,ring17,ring18),
    (9.5/69*2*pi, (ring17+ring18)/2, 9.0/69*2*pi, 10.0/69*2*pi,ring17,ring18),
    (10.5/69*2*pi, (ring17+ring18)/2, 10.0/69*2*pi, 11.0/69*2*pi,ring17,ring18),
    (11.5/69*2*pi, (ring17+ring18)/2, 11.0/69*2*pi, 12.0/69*2*pi,ring17,ring18),
    (12.5/69*2*pi, (ring17+ring18)/2, 12.0/69*2*pi, 13.0/69*2*pi,ring17,ring18),
    (13.5/69*2*pi, (ring17+ring18)/2, 13.0/69*2*pi, 14.0/69*2*pi,ring17,ring18),
    (14.5/69*2*pi, (ring17+ring18)/2, 14.0/69*2*pi, 15.0/69*2*pi,ring17,ring18),
    (15.5/69*2*pi, (ring17+ring18)/2, 15.0/69*2*pi, 16.0/69*2*pi,ring17,ring18),
    (16.5/69*2*pi, (ring17+ring18)/2, 16.0/69*2*pi, 17.0/69*2*pi,ring17,ring18),
    (17.5/69*2*pi, (ring17+ring18)/2, 17.0/69*2*pi, 18.0/69*2*pi,ring17,ring18),
    (18.5/69*2*pi, (ring17+ring18)/2, 18.0/69*2*pi, 19.0/69*2*pi,ring17,ring18),
    (19.5/69*2*pi, (ring17+ring18)/2, 19.0/69*2*pi, 20.0/69*2*pi,ring17,ring18),
    (20.5/69*2*pi, (ring17+ring18)/2, 20.0/69*2*pi, 21.0/69*2*pi,ring17,ring18),
    (21.5/69*2*pi, (ring17+ring18)/2, 21.0/69*2*pi, 22.0/69*2*pi,ring17,ring18),
    (22.5/69*2*pi, (ring17+ring18)/2, 22.0/69*2*pi, 23.0/69*2*pi,ring17,ring18),
    (23.5/69*2*pi, (ring17+ring18)/2, 23.0/69*2*pi, 24.0/69*2*pi,ring17,ring18),
    (24.5/69*2*pi, (ring17+ring18)/2, 24.0/69*2*pi, 25.0/69*2*pi,ring17,ring18),
    (25.5/69*2*pi, (ring17+ring18)/2, 25.0/69*2*pi, 26.0/69*2*pi,ring17,ring18),
    (26.5/69*2*pi, (ring17+ring18)/2, 26.0/69*2*pi, 27.0/69*2*pi,ring17,ring18),
    (27.5/69*2*pi, (ring17+ring18)/2, 27.0/69*2*pi, 28.0/69*2*pi,ring17,ring18),
    (28.5/69*2*pi, (ring17+ring18)/2, 28.0/69*2*pi, 29.0/69*2*pi,ring17,ring18),
    (29.5/69*2*pi, (ring17+ring18)/2, 29.0/69*2*pi, 30.0/69*2*pi,ring17,ring18),
    (30.5/69*2*pi, (ring17+ring18)/2, 30.0/69*2*pi, 31.0/69*2*pi,ring17,ring18),
    (31.5/69*2*pi, (ring17+ring18)/2, 31.0/69*2*pi, 32.0/69*2*pi,ring17,ring18),
    (32.5/69*2*pi, (ring17+ring18)/2, 32.0/69*2*pi, 33.0/69*2*pi,ring17,ring18),
    (33.5/69*2*pi, (ring17+ring18)/2, 33.0/69*2*pi, 34.0/69*2*pi,ring17,ring18),
    (34.5/69*2*pi, (ring17+ring18)/2, 34.0/69*2*pi, 35.0/69*2*pi,ring17,ring18),
    (35.5/69*2*pi, (ring17+ring18)/2, 35.0/69*2*pi, 36.0/69*2*pi,ring17,ring18),
    (36.5/69*2*pi, (ring17+ring18)/2, 36.0/69*2*pi, 37.0/69*2*pi,ring17,ring18),
    (37.5/69*2*pi, (ring17+ring18)/2, 37.0/69*2*pi, 38.0/69*2*pi,ring17,ring18),
    (38.5/69*2*pi, (ring17+ring18)/2, 38.0/69*2*pi, 39.0/69*2*pi,ring17,ring18),
    (39.5/69*2*pi, (ring17+ring18)/2, 39.0/69*2*pi, 40.0/69*2*pi,ring17,ring18),
    (40.5/69*2*pi, (ring17+ring18)/2, 40.0/69*2*pi, 41.0/69*2*pi,ring17,ring18),
    (41.5/69*2*pi, (ring17+ring18)/2, 41.0/69*2*pi, 42.0/69*2*pi,ring17,ring18),
    (42.5/69*2*pi, (ring17+ring18)/2, 42.0/69*2*pi, 43.0/69*2*pi,ring17,ring18),
    (43.5/69*2*pi, (ring17+ring18)/2, 43.0/69*2*pi, 44.0/69*2*pi,ring17,ring18),
    (44.5/69*2*pi, (ring17+ring18)/2, 44.0/69*2*pi, 45.0/69*2*pi,ring17,ring18),
    (45.5/69*2*pi, (ring17+ring18)/2, 45.0/69*2*pi, 46.0/69*2*pi,ring17,ring18),
    (46.5/69*2*pi, (ring17+ring18)/2, 46.0/69*2*pi, 47.0/69*2*pi,ring17,ring18),
    (47.5/69*2*pi, (ring17+ring18)/2, 47.0/69*2*pi, 48.0/69*2*pi,ring17,ring18),
    (48.5/69*2*pi, (ring17+ring18)/2, 48.0/69*2*pi, 49.0/69*2*pi,ring17,ring18),
    (49.5/69*2*pi, (ring17+ring18)/2, 49.0/69*2*pi, 50.0/69*2*pi,ring17,ring18),
    (50.5/69*2*pi, (ring17+ring18)/2, 50.0/69*2*pi, 51.0/69*2*pi,ring17,ring18),
    (51.5/69*2*pi, (ring17+ring18)/2, 51.0/69*2*pi, 52.0/69*2*pi,ring17,ring18),
    (52.5/69*2*pi, (ring17+ring18)/2, 52.0/69*2*pi, 53.0/69*2*pi,ring17,ring18),
    (53.5/69*2*pi, (ring17+ring18)/2, 53.0/69*2*pi, 54.0/69*2*pi,ring17,ring18),
    (54.5/69*2*pi, (ring17+ring18)/2, 54.0/69*2*pi, 55.0/69*2*pi,ring17,ring18),
    (55.5/69*2*pi, (ring17+ring18)/2, 55.0/69*2*pi, 56.0/69*2*pi,ring17,ring18),
    (56.5/69*2*pi, (ring17+ring18)/2, 56.0/69*2*pi, 57.0/69*2*pi,ring17,ring18),
    (57.5/69*2*pi, (ring17+ring18)/2, 57.0/69*2*pi, 58.0/69*2*pi,ring17,ring18),
    (58.5/69*2*pi, (ring17+ring18)/2, 58.0/69*2*pi, 59.0/69*2*pi,ring17,ring18),
    (59.5/69*2*pi, (ring17+ring18)/2, 59.0/69*2*pi, 60.0/69*2*pi,ring17,ring18),
    (60.5/69*2*pi, (ring17+ring18)/2, 60.0/69*2*pi, 61.0/69*2*pi,ring17,ring18),
    (61.5/69*2*pi, (ring17+ring18)/2, 61.0/69*2*pi, 62.0/69*2*pi,ring17,ring18),
    (62.5/69*2*pi, (ring17+ring18)/2, 62.0/69*2*pi, 63.0/69*2*pi,ring17,ring18),
    (63.5/69*2*pi, (ring17+ring18)/2, 63.0/69*2*pi, 64.0/69*2*pi,ring17,ring18),
    (64.5/69*2*pi, (ring17+ring18)/2, 64.0/69*2*pi, 65.0/69*2*pi,ring17,ring18),
    (65.5/69*2*pi, (ring17+ring18)/2, 65.0/69*2*pi, 66.0/69*2*pi,ring17,ring18),
    (66.5/69*2*pi, (ring17+ring18)/2, 66.0/69*2*pi, 67.0/69*2*pi,ring17,ring18),
    (67.5/69*2*pi, (ring17+ring18)/2, 67.0/69*2*pi, 68.0/69*2*pi,ring17,ring18),
    (68.5/69*2*pi, (ring17+ring18)/2, 68.0/69*2*pi, 69.0/69*2*pi,ring17,ring18),

    {##############################################################################}

    (0.5/69*2*pi, (ring18+ring19)/2, 0.0/69*2*pi, 1.0/69*2*pi,ring18,ring19),
    (1.5/69*2*pi, (ring18+ring19)/2, 1.0/69*2*pi, 2.0/69*2*pi,ring18,ring19),
    (2.5/69*2*pi, (ring18+ring19)/2, 2.0/69*2*pi, 3.0/69*2*pi,ring18,ring19),
    (3.5/69*2*pi, (ring18+ring19)/2, 3.0/69*2*pi, 4.0/69*2*pi,ring18,ring19),
    (4.5/69*2*pi, (ring18+ring19)/2, 4.0/69*2*pi, 5.0/69*2*pi,ring18,ring19),
    (5.5/69*2*pi, (ring18+ring19)/2, 5.0/69*2*pi, 6.0/69*2*pi,ring18,ring19),
    (6.5/69*2*pi, (ring18+ring19)/2, 6.0/69*2*pi, 7.0/69*2*pi,ring18,ring19),
    (7.5/69*2*pi, (ring18+ring19)/2, 7.0/69*2*pi, 8.0/69*2*pi,ring18,ring19),
    (8.5/69*2*pi, (ring18+ring19)/2, 8.0/69*2*pi, 9.0/69*2*pi,ring18,ring19),
    (9.5/69*2*pi, (ring18+ring19)/2, 9.0/69*2*pi, 10.0/69*2*pi,ring18,ring19),
    (10.5/69*2*pi, (ring18+ring19)/2, 10.0/69*2*pi, 11.0/69*2*pi,ring18,ring19),
    (11.5/69*2*pi, (ring18+ring19)/2, 11.0/69*2*pi, 12.0/69*2*pi,ring18,ring19),
    (12.5/69*2*pi, (ring18+ring19)/2, 12.0/69*2*pi, 13.0/69*2*pi,ring18,ring19),
    (13.5/69*2*pi, (ring18+ring19)/2, 13.0/69*2*pi, 14.0/69*2*pi,ring18,ring19),
    (14.5/69*2*pi, (ring18+ring19)/2, 14.0/69*2*pi, 15.0/69*2*pi,ring18,ring19),
    (15.5/69*2*pi, (ring18+ring19)/2, 15.0/69*2*pi, 16.0/69*2*pi,ring18,ring19),
    (16.5/69*2*pi, (ring18+ring19)/2, 16.0/69*2*pi, 17.0/69*2*pi,ring18,ring19),
    (17.5/69*2*pi, (ring18+ring19)/2, 17.0/69*2*pi, 18.0/69*2*pi,ring18,ring19),
    (18.5/69*2*pi, (ring18+ring19)/2, 18.0/69*2*pi, 19.0/69*2*pi,ring18,ring19),
    (19.5/69*2*pi, (ring18+ring19)/2, 19.0/69*2*pi, 20.0/69*2*pi,ring18,ring19),
    (20.5/69*2*pi, (ring18+ring19)/2, 20.0/69*2*pi, 21.0/69*2*pi,ring18,ring19),
    (21.5/69*2*pi, (ring18+ring19)/2, 21.0/69*2*pi, 22.0/69*2*pi,ring18,ring19),
    (22.5/69*2*pi, (ring18+ring19)/2, 22.0/69*2*pi, 23.0/69*2*pi,ring18,ring19),
    (23.5/69*2*pi, (ring18+ring19)/2, 23.0/69*2*pi, 24.0/69*2*pi,ring18,ring19),
    (24.5/69*2*pi, (ring18+ring19)/2, 24.0/69*2*pi, 25.0/69*2*pi,ring18,ring19),
    (25.5/69*2*pi, (ring18+ring19)/2, 25.0/69*2*pi, 26.0/69*2*pi,ring18,ring19),
    (26.5/69*2*pi, (ring18+ring19)/2, 26.0/69*2*pi, 27.0/69*2*pi,ring18,ring19),
    (27.5/69*2*pi, (ring18+ring19)/2, 27.0/69*2*pi, 28.0/69*2*pi,ring18,ring19),
    (28.5/69*2*pi, (ring18+ring19)/2, 28.0/69*2*pi, 29.0/69*2*pi,ring18,ring19),
    (29.5/69*2*pi, (ring18+ring19)/2, 29.0/69*2*pi, 30.0/69*2*pi,ring18,ring19),
    (30.5/69*2*pi, (ring18+ring19)/2, 30.0/69*2*pi, 31.0/69*2*pi,ring18,ring19),
    (31.5/69*2*pi, (ring18+ring19)/2, 31.0/69*2*pi, 32.0/69*2*pi,ring18,ring19),
    (32.5/69*2*pi, (ring18+ring19)/2, 32.0/69*2*pi, 33.0/69*2*pi,ring18,ring19),
    (33.5/69*2*pi, (ring18+ring19)/2, 33.0/69*2*pi, 34.0/69*2*pi,ring18,ring19),
    (34.5/69*2*pi, (ring18+ring19)/2, 34.0/69*2*pi, 35.0/69*2*pi,ring18,ring19),
    (35.5/69*2*pi, (ring18+ring19)/2, 35.0/69*2*pi, 36.0/69*2*pi,ring18,ring19),
    (36.5/69*2*pi, (ring18+ring19)/2, 36.0/69*2*pi, 37.0/69*2*pi,ring18,ring19),
    (37.5/69*2*pi, (ring18+ring19)/2, 37.0/69*2*pi, 38.0/69*2*pi,ring18,ring19),
    (38.5/69*2*pi, (ring18+ring19)/2, 38.0/69*2*pi, 39.0/69*2*pi,ring18,ring19),
    (39.5/69*2*pi, (ring18+ring19)/2, 39.0/69*2*pi, 40.0/69*2*pi,ring18,ring19),
    (40.5/69*2*pi, (ring18+ring19)/2, 40.0/69*2*pi, 41.0/69*2*pi,ring18,ring19),
    (41.5/69*2*pi, (ring18+ring19)/2, 41.0/69*2*pi, 42.0/69*2*pi,ring18,ring19),
    (42.5/69*2*pi, (ring18+ring19)/2, 42.0/69*2*pi, 43.0/69*2*pi,ring18,ring19),
    (43.5/69*2*pi, (ring18+ring19)/2, 43.0/69*2*pi, 44.0/69*2*pi,ring18,ring19),
    (44.5/69*2*pi, (ring18+ring19)/2, 44.0/69*2*pi, 45.0/69*2*pi,ring18,ring19),
    (45.5/69*2*pi, (ring18+ring19)/2, 45.0/69*2*pi, 46.0/69*2*pi,ring18,ring19),
    (46.5/69*2*pi, (ring18+ring19)/2, 46.0/69*2*pi, 47.0/69*2*pi,ring18,ring19),
    (47.5/69*2*pi, (ring18+ring19)/2, 47.0/69*2*pi, 48.0/69*2*pi,ring18,ring19),
    (48.5/69*2*pi, (ring18+ring19)/2, 48.0/69*2*pi, 49.0/69*2*pi,ring18,ring19),
    (49.5/69*2*pi, (ring18+ring19)/2, 49.0/69*2*pi, 50.0/69*2*pi,ring18,ring19),
    (50.5/69*2*pi, (ring18+ring19)/2, 50.0/69*2*pi, 51.0/69*2*pi,ring18,ring19),
    (51.5/69*2*pi, (ring18+ring19)/2, 51.0/69*2*pi, 52.0/69*2*pi,ring18,ring19),
    (52.5/69*2*pi, (ring18+ring19)/2, 52.0/69*2*pi, 53.0/69*2*pi,ring18,ring19),
    (53.5/69*2*pi, (ring18+ring19)/2, 53.0/69*2*pi, 54.0/69*2*pi,ring18,ring19),
    (54.5/69*2*pi, (ring18+ring19)/2, 54.0/69*2*pi, 55.0/69*2*pi,ring18,ring19),
    (55.5/69*2*pi, (ring18+ring19)/2, 55.0/69*2*pi, 56.0/69*2*pi,ring18,ring19),
    (56.5/69*2*pi, (ring18+ring19)/2, 56.0/69*2*pi, 57.0/69*2*pi,ring18,ring19),
    (57.5/69*2*pi, (ring18+ring19)/2, 57.0/69*2*pi, 58.0/69*2*pi,ring18,ring19),
    (58.5/69*2*pi, (ring18+ring19)/2, 58.0/69*2*pi, 59.0/69*2*pi,ring18,ring19),
    (59.5/69*2*pi, (ring18+ring19)/2, 59.0/69*2*pi, 60.0/69*2*pi,ring18,ring19),
    (60.5/69*2*pi, (ring18+ring19)/2, 60.0/69*2*pi, 61.0/69*2*pi,ring18,ring19),
    (61.5/69*2*pi, (ring18+ring19)/2, 61.0/69*2*pi, 62.0/69*2*pi,ring18,ring19),
    (62.5/69*2*pi, (ring18+ring19)/2, 62.0/69*2*pi, 63.0/69*2*pi,ring18,ring19),
    (63.5/69*2*pi, (ring18+ring19)/2, 63.0/69*2*pi, 64.0/69*2*pi,ring18,ring19),
    (64.5/69*2*pi, (ring18+ring19)/2, 64.0/69*2*pi, 65.0/69*2*pi,ring18,ring19),
    (65.5/69*2*pi, (ring18+ring19)/2, 65.0/69*2*pi, 66.0/69*2*pi,ring18,ring19),
    (66.5/69*2*pi, (ring18+ring19)/2, 66.0/69*2*pi, 67.0/69*2*pi,ring18,ring19),
    (67.5/69*2*pi, (ring18+ring19)/2, 67.0/69*2*pi, 68.0/69*2*pi,ring18,ring19),
    (68.5/69*2*pi, (ring18+ring19)/2, 68.0/69*2*pi, 69.0/69*2*pi,ring18,ring19),



    (0.5/68*2*pi, (ring19+ring20)/2, 0.0/68*2*pi, 1.0/68*2*pi,ring19,ring20),
    (1.5/68*2*pi, (ring19+ring20)/2, 1.0/68*2*pi, 2.0/68*2*pi,ring19,ring20),
    (2.5/68*2*pi, (ring19+ring20)/2, 2.0/68*2*pi, 3.0/68*2*pi,ring19,ring20),
    (3.5/68*2*pi, (ring19+ring20)/2, 3.0/68*2*pi, 4.0/68*2*pi,ring19,ring20),
    (4.5/68*2*pi, (ring19+ring20)/2, 4.0/68*2*pi, 5.0/68*2*pi,ring19,ring20),
    (5.5/68*2*pi, (ring19+ring20)/2, 5.0/68*2*pi, 6.0/68*2*pi,ring19,ring20),
    (6.5/68*2*pi, (ring19+ring20)/2, 6.0/68*2*pi, 7.0/68*2*pi,ring19,ring20),
    (7.5/68*2*pi, (ring19+ring20)/2, 7.0/68*2*pi, 8.0/68*2*pi,ring19,ring20),
    (8.5/68*2*pi, (ring19+ring20)/2, 8.0/68*2*pi, 9.0/68*2*pi,ring19,ring20),
    (9.5/68*2*pi, (ring19+ring20)/2, 9.0/68*2*pi, 10.0/68*2*pi,ring19,ring20),
    (10.5/68*2*pi, (ring19+ring20)/2, 10.0/68*2*pi, 11.0/68*2*pi,ring19,ring20),
    (11.5/68*2*pi, (ring19+ring20)/2, 11.0/68*2*pi, 12.0/68*2*pi,ring19,ring20),
    (12.5/68*2*pi, (ring19+ring20)/2, 12.0/68*2*pi, 13.0/68*2*pi,ring19,ring20),
    (13.5/68*2*pi, (ring19+ring20)/2, 13.0/68*2*pi, 14.0/68*2*pi,ring19,ring20),
    (14.5/68*2*pi, (ring19+ring20)/2, 14.0/68*2*pi, 15.0/68*2*pi,ring19,ring20),
    (15.5/68*2*pi, (ring19+ring20)/2, 15.0/68*2*pi, 16.0/68*2*pi,ring19,ring20),
    (16.5/68*2*pi, (ring19+ring20)/2, 16.0/68*2*pi, 17.0/68*2*pi,ring19,ring20),
    (17.5/68*2*pi, (ring19+ring20)/2, 17.0/68*2*pi, 18.0/68*2*pi,ring19,ring20),
    (18.5/68*2*pi, (ring19+ring20)/2, 18.0/68*2*pi, 19.0/68*2*pi,ring19,ring20),
    (19.5/68*2*pi, (ring19+ring20)/2, 19.0/68*2*pi, 20.0/68*2*pi,ring19,ring20),
    (20.5/68*2*pi, (ring19+ring20)/2, 20.0/68*2*pi, 21.0/68*2*pi,ring19,ring20),
    (21.5/68*2*pi, (ring19+ring20)/2, 21.0/68*2*pi, 22.0/68*2*pi,ring19,ring20),
    (22.5/68*2*pi, (ring19+ring20)/2, 22.0/68*2*pi, 23.0/68*2*pi,ring19,ring20),
    (23.5/68*2*pi, (ring19+ring20)/2, 23.0/68*2*pi, 24.0/68*2*pi,ring19,ring20),
    (24.5/68*2*pi, (ring19+ring20)/2, 24.0/68*2*pi, 25.0/68*2*pi,ring19,ring20),
    (25.5/68*2*pi, (ring19+ring20)/2, 25.0/68*2*pi, 26.0/68*2*pi,ring19,ring20),
    (26.5/68*2*pi, (ring19+ring20)/2, 26.0/68*2*pi, 27.0/68*2*pi,ring19,ring20),
    (27.5/68*2*pi, (ring19+ring20)/2, 27.0/68*2*pi, 28.0/68*2*pi,ring19,ring20),
    (28.5/68*2*pi, (ring19+ring20)/2, 28.0/68*2*pi, 29.0/68*2*pi,ring19,ring20),
    (29.5/68*2*pi, (ring19+ring20)/2, 29.0/68*2*pi, 30.0/68*2*pi,ring19,ring20),
    (30.5/68*2*pi, (ring19+ring20)/2, 30.0/68*2*pi, 31.0/68*2*pi,ring19,ring20),
    (31.5/68*2*pi, (ring19+ring20)/2, 31.0/68*2*pi, 32.0/68*2*pi,ring19,ring20),
    (32.5/68*2*pi, (ring19+ring20)/2, 32.0/68*2*pi, 33.0/68*2*pi,ring19,ring20),
    (33.5/68*2*pi, (ring19+ring20)/2, 33.0/68*2*pi, 34.0/68*2*pi,ring19,ring20),
    (34.5/68*2*pi, (ring19+ring20)/2, 34.0/68*2*pi, 35.0/68*2*pi,ring19,ring20),
    (35.5/68*2*pi, (ring19+ring20)/2, 35.0/68*2*pi, 36.0/68*2*pi,ring19,ring20),
    (36.5/68*2*pi, (ring19+ring20)/2, 36.0/68*2*pi, 37.0/68*2*pi,ring19,ring20),
    (37.5/68*2*pi, (ring19+ring20)/2, 37.0/68*2*pi, 38.0/68*2*pi,ring19,ring20),
    (38.5/68*2*pi, (ring19+ring20)/2, 38.0/68*2*pi, 39.0/68*2*pi,ring19,ring20),
    (39.5/68*2*pi, (ring19+ring20)/2, 39.0/68*2*pi, 40.0/68*2*pi,ring19,ring20),
    (40.5/68*2*pi, (ring19+ring20)/2, 40.0/68*2*pi, 41.0/68*2*pi,ring19,ring20),
    (41.5/68*2*pi, (ring19+ring20)/2, 41.0/68*2*pi, 42.0/68*2*pi,ring19,ring20),
    (42.5/68*2*pi, (ring19+ring20)/2, 42.0/68*2*pi, 43.0/68*2*pi,ring19,ring20),
    (43.5/68*2*pi, (ring19+ring20)/2, 43.0/68*2*pi, 44.0/68*2*pi,ring19,ring20),
    (44.5/68*2*pi, (ring19+ring20)/2, 44.0/68*2*pi, 45.0/68*2*pi,ring19,ring20),
    (45.5/68*2*pi, (ring19+ring20)/2, 45.0/68*2*pi, 46.0/68*2*pi,ring19,ring20),
    (46.5/68*2*pi, (ring19+ring20)/2, 46.0/68*2*pi, 47.0/68*2*pi,ring19,ring20),
    (47.5/68*2*pi, (ring19+ring20)/2, 47.0/68*2*pi, 48.0/68*2*pi,ring19,ring20),
    (48.5/68*2*pi, (ring19+ring20)/2, 48.0/68*2*pi, 49.0/68*2*pi,ring19,ring20),
    (49.5/68*2*pi, (ring19+ring20)/2, 49.0/68*2*pi, 50.0/68*2*pi,ring19,ring20),
    (50.5/68*2*pi, (ring19+ring20)/2, 50.0/68*2*pi, 51.0/68*2*pi,ring19,ring20),
    (51.5/68*2*pi, (ring19+ring20)/2, 51.0/68*2*pi, 52.0/68*2*pi,ring19,ring20),
    (52.5/68*2*pi, (ring19+ring20)/2, 52.0/68*2*pi, 53.0/68*2*pi,ring19,ring20),
    (53.5/68*2*pi, (ring19+ring20)/2, 53.0/68*2*pi, 54.0/68*2*pi,ring19,ring20),
    (54.5/68*2*pi, (ring19+ring20)/2, 54.0/68*2*pi, 55.0/68*2*pi,ring19,ring20),
    (55.5/68*2*pi, (ring19+ring20)/2, 55.0/68*2*pi, 56.0/68*2*pi,ring19,ring20),
    (56.5/68*2*pi, (ring19+ring20)/2, 56.0/68*2*pi, 57.0/68*2*pi,ring19,ring20),
    (57.5/68*2*pi, (ring19+ring20)/2, 57.0/68*2*pi, 58.0/68*2*pi,ring19,ring20),
    (58.5/68*2*pi, (ring19+ring20)/2, 58.0/68*2*pi, 59.0/68*2*pi,ring19,ring20),
    (59.5/68*2*pi, (ring19+ring20)/2, 59.0/68*2*pi, 60.0/68*2*pi,ring19,ring20),
    (60.5/68*2*pi, (ring19+ring20)/2, 60.0/68*2*pi, 61.0/68*2*pi,ring19,ring20),
    (61.5/68*2*pi, (ring19+ring20)/2, 61.0/68*2*pi, 62.0/68*2*pi,ring19,ring20),
    (62.5/68*2*pi, (ring19+ring20)/2, 62.0/68*2*pi, 63.0/68*2*pi,ring19,ring20),
    (63.5/68*2*pi, (ring19+ring20)/2, 63.0/68*2*pi, 64.0/68*2*pi,ring19,ring20),
    (64.5/68*2*pi, (ring19+ring20)/2, 64.0/68*2*pi, 65.0/68*2*pi,ring19,ring20),
    (65.5/68*2*pi, (ring19+ring20)/2, 65.0/68*2*pi, 66.0/68*2*pi,ring19,ring20),
    (66.5/68*2*pi, (ring19+ring20)/2, 66.0/68*2*pi, 67.0/68*2*pi,ring19,ring20),
    (67.5/68*2*pi, (ring19+ring20)/2, 67.0/68*2*pi, 68.0/68*2*pi,ring19,ring20),



    (0.5/67*2*pi, (ring20+ring21)/2, 0.0/67*2*pi, 1.0/67*2*pi,ring20,ring21),
    (1.5/67*2*pi, (ring20+ring21)/2, 1.0/67*2*pi, 2.0/67*2*pi,ring20,ring21),
    (2.5/67*2*pi, (ring20+ring21)/2, 2.0/67*2*pi, 3.0/67*2*pi,ring20,ring21),
    (3.5/67*2*pi, (ring20+ring21)/2, 3.0/67*2*pi, 4.0/67*2*pi,ring20,ring21),
    (4.5/67*2*pi, (ring20+ring21)/2, 4.0/67*2*pi, 5.0/67*2*pi,ring20,ring21),
    (5.5/67*2*pi, (ring20+ring21)/2, 5.0/67*2*pi, 6.0/67*2*pi,ring20,ring21),
    (6.5/67*2*pi, (ring20+ring21)/2, 6.0/67*2*pi, 7.0/67*2*pi,ring20,ring21),
    (7.5/67*2*pi, (ring20+ring21)/2, 7.0/67*2*pi, 8.0/67*2*pi,ring20,ring21),
    (8.5/67*2*pi, (ring20+ring21)/2, 8.0/67*2*pi, 9.0/67*2*pi,ring20,ring21),
    (9.5/67*2*pi, (ring20+ring21)/2, 9.0/67*2*pi, 10.0/67*2*pi,ring20,ring21),
    (10.5/67*2*pi, (ring20+ring21)/2, 10.0/67*2*pi, 11.0/67*2*pi,ring20,ring21),
    (11.5/67*2*pi, (ring20+ring21)/2, 11.0/67*2*pi, 12.0/67*2*pi,ring20,ring21),
    (12.5/67*2*pi, (ring20+ring21)/2, 12.0/67*2*pi, 13.0/67*2*pi,ring20,ring21),
    (13.5/67*2*pi, (ring20+ring21)/2, 13.0/67*2*pi, 14.0/67*2*pi,ring20,ring21),
    (14.5/67*2*pi, (ring20+ring21)/2, 14.0/67*2*pi, 15.0/67*2*pi,ring20,ring21),
    (15.5/67*2*pi, (ring20+ring21)/2, 15.0/67*2*pi, 16.0/67*2*pi,ring20,ring21),
    (16.5/67*2*pi, (ring20+ring21)/2, 16.0/67*2*pi, 17.0/67*2*pi,ring20,ring21),
    (17.5/67*2*pi, (ring20+ring21)/2, 17.0/67*2*pi, 18.0/67*2*pi,ring20,ring21),
    (18.5/67*2*pi, (ring20+ring21)/2, 18.0/67*2*pi, 19.0/67*2*pi,ring20,ring21),
    (19.5/67*2*pi, (ring20+ring21)/2, 19.0/67*2*pi, 20.0/67*2*pi,ring20,ring21),
    (20.5/67*2*pi, (ring20+ring21)/2, 20.0/67*2*pi, 21.0/67*2*pi,ring20,ring21),
    (21.5/67*2*pi, (ring20+ring21)/2, 21.0/67*2*pi, 22.0/67*2*pi,ring20,ring21),
    (22.5/67*2*pi, (ring20+ring21)/2, 22.0/67*2*pi, 23.0/67*2*pi,ring20,ring21),
    (23.5/67*2*pi, (ring20+ring21)/2, 23.0/67*2*pi, 24.0/67*2*pi,ring20,ring21),
    (24.5/67*2*pi, (ring20+ring21)/2, 24.0/67*2*pi, 25.0/67*2*pi,ring20,ring21),
    (25.5/67*2*pi, (ring20+ring21)/2, 25.0/67*2*pi, 26.0/67*2*pi,ring20,ring21),
    (26.5/67*2*pi, (ring20+ring21)/2, 26.0/67*2*pi, 27.0/67*2*pi,ring20,ring21),
    (27.5/67*2*pi, (ring20+ring21)/2, 27.0/67*2*pi, 28.0/67*2*pi,ring20,ring21),
    (28.5/67*2*pi, (ring20+ring21)/2, 28.0/67*2*pi, 29.0/67*2*pi,ring20,ring21),
    (29.5/67*2*pi, (ring20+ring21)/2, 29.0/67*2*pi, 30.0/67*2*pi,ring20,ring21),
    (30.5/67*2*pi, (ring20+ring21)/2, 30.0/67*2*pi, 31.0/67*2*pi,ring20,ring21),
    (31.5/67*2*pi, (ring20+ring21)/2, 31.0/67*2*pi, 32.0/67*2*pi,ring20,ring21),
    (32.5/67*2*pi, (ring20+ring21)/2, 32.0/67*2*pi, 33.0/67*2*pi,ring20,ring21),
    (33.5/67*2*pi, (ring20+ring21)/2, 33.0/67*2*pi, 34.0/67*2*pi,ring20,ring21),
    (34.5/67*2*pi, (ring20+ring21)/2, 34.0/67*2*pi, 35.0/67*2*pi,ring20,ring21),
    (35.5/67*2*pi, (ring20+ring21)/2, 35.0/67*2*pi, 36.0/67*2*pi,ring20,ring21),
    (36.5/67*2*pi, (ring20+ring21)/2, 36.0/67*2*pi, 37.0/67*2*pi,ring20,ring21),
    (37.5/67*2*pi, (ring20+ring21)/2, 37.0/67*2*pi, 38.0/67*2*pi,ring20,ring21),
    (38.5/67*2*pi, (ring20+ring21)/2, 38.0/67*2*pi, 39.0/67*2*pi,ring20,ring21),
    (39.5/67*2*pi, (ring20+ring21)/2, 39.0/67*2*pi, 40.0/67*2*pi,ring20,ring21),
    (40.5/67*2*pi, (ring20+ring21)/2, 40.0/67*2*pi, 41.0/67*2*pi,ring20,ring21),
    (41.5/67*2*pi, (ring20+ring21)/2, 41.0/67*2*pi, 42.0/67*2*pi,ring20,ring21),
    (42.5/67*2*pi, (ring20+ring21)/2, 42.0/67*2*pi, 43.0/67*2*pi,ring20,ring21),
    (43.5/67*2*pi, (ring20+ring21)/2, 43.0/67*2*pi, 44.0/67*2*pi,ring20,ring21),
    (44.5/67*2*pi, (ring20+ring21)/2, 44.0/67*2*pi, 45.0/67*2*pi,ring20,ring21),
    (45.5/67*2*pi, (ring20+ring21)/2, 45.0/67*2*pi, 46.0/67*2*pi,ring20,ring21),
    (46.5/67*2*pi, (ring20+ring21)/2, 46.0/67*2*pi, 47.0/67*2*pi,ring20,ring21),
    (47.5/67*2*pi, (ring20+ring21)/2, 47.0/67*2*pi, 48.0/67*2*pi,ring20,ring21),
    (48.5/67*2*pi, (ring20+ring21)/2, 48.0/67*2*pi, 49.0/67*2*pi,ring20,ring21),
    (49.5/67*2*pi, (ring20+ring21)/2, 49.0/67*2*pi, 50.0/67*2*pi,ring20,ring21),
    (50.5/67*2*pi, (ring20+ring21)/2, 50.0/67*2*pi, 51.0/67*2*pi,ring20,ring21),
    (51.5/67*2*pi, (ring20+ring21)/2, 51.0/67*2*pi, 52.0/67*2*pi,ring20,ring21),
    (52.5/67*2*pi, (ring20+ring21)/2, 52.0/67*2*pi, 53.0/67*2*pi,ring20,ring21),
    (53.5/67*2*pi, (ring20+ring21)/2, 53.0/67*2*pi, 54.0/67*2*pi,ring20,ring21),
    (54.5/67*2*pi, (ring20+ring21)/2, 54.0/67*2*pi, 55.0/67*2*pi,ring20,ring21),
    (55.5/67*2*pi, (ring20+ring21)/2, 55.0/67*2*pi, 56.0/67*2*pi,ring20,ring21),
    (56.5/67*2*pi, (ring20+ring21)/2, 56.0/67*2*pi, 57.0/67*2*pi,ring20,ring21),
    (57.5/67*2*pi, (ring20+ring21)/2, 57.0/67*2*pi, 58.0/67*2*pi,ring20,ring21),
    (58.5/67*2*pi, (ring20+ring21)/2, 58.0/67*2*pi, 59.0/67*2*pi,ring20,ring21),
    (59.5/67*2*pi, (ring20+ring21)/2, 59.0/67*2*pi, 60.0/67*2*pi,ring20,ring21),
    (60.5/67*2*pi, (ring20+ring21)/2, 60.0/67*2*pi, 61.0/67*2*pi,ring20,ring21),
    (61.5/67*2*pi, (ring20+ring21)/2, 61.0/67*2*pi, 62.0/67*2*pi,ring20,ring21),
    (62.5/67*2*pi, (ring20+ring21)/2, 62.0/67*2*pi, 63.0/67*2*pi,ring20,ring21),
    (63.5/67*2*pi, (ring20+ring21)/2, 63.0/67*2*pi, 64.0/67*2*pi,ring20,ring21),
    (64.5/67*2*pi, (ring20+ring21)/2, 64.0/67*2*pi, 65.0/67*2*pi,ring20,ring21),
    (65.5/67*2*pi, (ring20+ring21)/2, 65.0/67*2*pi, 66.0/67*2*pi,ring20,ring21),
    (66.5/67*2*pi, (ring20+ring21)/2, 66.0/67*2*pi, 67.0/67*2*pi,ring20,ring21),


    (0.5/65*2*pi, (ring21+ring22)/2, 0.0/65*2*pi, 1.0/65*2*pi,ring21,ring22),
    (1.5/65*2*pi, (ring21+ring22)/2, 1.0/65*2*pi, 2.0/65*2*pi,ring21,ring22),
    (2.5/65*2*pi, (ring21+ring22)/2, 2.0/65*2*pi, 3.0/65*2*pi,ring21,ring22),
    (3.5/65*2*pi, (ring21+ring22)/2, 3.0/65*2*pi, 4.0/65*2*pi,ring21,ring22),
    (4.5/65*2*pi, (ring21+ring22)/2, 4.0/65*2*pi, 5.0/65*2*pi,ring21,ring22),
    (5.5/65*2*pi, (ring21+ring22)/2, 5.0/65*2*pi, 6.0/65*2*pi,ring21,ring22),
    (6.5/65*2*pi, (ring21+ring22)/2, 6.0/65*2*pi, 7.0/65*2*pi,ring21,ring22),
    (7.5/65*2*pi, (ring21+ring22)/2, 7.0/65*2*pi, 8.0/65*2*pi,ring21,ring22),
    (8.5/65*2*pi, (ring21+ring22)/2, 8.0/65*2*pi, 9.0/65*2*pi,ring21,ring22),
    (9.5/65*2*pi, (ring21+ring22)/2, 9.0/65*2*pi, 10.0/65*2*pi,ring21,ring22),
    (10.5/65*2*pi, (ring21+ring22)/2, 10.0/65*2*pi, 11.0/65*2*pi,ring21,ring22),
    (11.5/65*2*pi, (ring21+ring22)/2, 11.0/65*2*pi, 12.0/65*2*pi,ring21,ring22),
    (12.5/65*2*pi, (ring21+ring22)/2, 12.0/65*2*pi, 13.0/65*2*pi,ring21,ring22),
    (13.5/65*2*pi, (ring21+ring22)/2, 13.0/65*2*pi, 14.0/65*2*pi,ring21,ring22),
    (14.5/65*2*pi, (ring21+ring22)/2, 14.0/65*2*pi, 15.0/65*2*pi,ring21,ring22),
    (15.5/65*2*pi, (ring21+ring22)/2, 15.0/65*2*pi, 16.0/65*2*pi,ring21,ring22),
    (16.5/65*2*pi, (ring21+ring22)/2, 16.0/65*2*pi, 17.0/65*2*pi,ring21,ring22),
    (17.5/65*2*pi, (ring21+ring22)/2, 17.0/65*2*pi, 18.0/65*2*pi,ring21,ring22),
    (18.5/65*2*pi, (ring21+ring22)/2, 18.0/65*2*pi, 19.0/65*2*pi,ring21,ring22),
    (19.5/65*2*pi, (ring21+ring22)/2, 19.0/65*2*pi, 20.0/65*2*pi,ring21,ring22),
    (20.5/65*2*pi, (ring21+ring22)/2, 20.0/65*2*pi, 21.0/65*2*pi,ring21,ring22),
    (21.5/65*2*pi, (ring21+ring22)/2, 21.0/65*2*pi, 22.0/65*2*pi,ring21,ring22),
    (22.5/65*2*pi, (ring21+ring22)/2, 22.0/65*2*pi, 23.0/65*2*pi,ring21,ring22),
    (23.5/65*2*pi, (ring21+ring22)/2, 23.0/65*2*pi, 24.0/65*2*pi,ring21,ring22),
    (24.5/65*2*pi, (ring21+ring22)/2, 24.0/65*2*pi, 25.0/65*2*pi,ring21,ring22),
    (25.5/65*2*pi, (ring21+ring22)/2, 25.0/65*2*pi, 26.0/65*2*pi,ring21,ring22),
    (26.5/65*2*pi, (ring21+ring22)/2, 26.0/65*2*pi, 27.0/65*2*pi,ring21,ring22),
    (27.5/65*2*pi, (ring21+ring22)/2, 27.0/65*2*pi, 28.0/65*2*pi,ring21,ring22),
    (28.5/65*2*pi, (ring21+ring22)/2, 28.0/65*2*pi, 29.0/65*2*pi,ring21,ring22),
    (29.5/65*2*pi, (ring21+ring22)/2, 29.0/65*2*pi, 30.0/65*2*pi,ring21,ring22),
    (30.5/65*2*pi, (ring21+ring22)/2, 30.0/65*2*pi, 31.0/65*2*pi,ring21,ring22),
    (31.5/65*2*pi, (ring21+ring22)/2, 31.0/65*2*pi, 32.0/65*2*pi,ring21,ring22),
    (32.5/65*2*pi, (ring21+ring22)/2, 32.0/65*2*pi, 33.0/65*2*pi,ring21,ring22),
    (33.5/65*2*pi, (ring21+ring22)/2, 33.0/65*2*pi, 34.0/65*2*pi,ring21,ring22),
    (34.5/65*2*pi, (ring21+ring22)/2, 34.0/65*2*pi, 35.0/65*2*pi,ring21,ring22),
    (35.5/65*2*pi, (ring21+ring22)/2, 35.0/65*2*pi, 36.0/65*2*pi,ring21,ring22),
    (36.5/65*2*pi, (ring21+ring22)/2, 36.0/65*2*pi, 37.0/65*2*pi,ring21,ring22),
    (37.5/65*2*pi, (ring21+ring22)/2, 37.0/65*2*pi, 38.0/65*2*pi,ring21,ring22),
    (38.5/65*2*pi, (ring21+ring22)/2, 38.0/65*2*pi, 39.0/65*2*pi,ring21,ring22),
    (39.5/65*2*pi, (ring21+ring22)/2, 39.0/65*2*pi, 40.0/65*2*pi,ring21,ring22),
    (40.5/65*2*pi, (ring21+ring22)/2, 40.0/65*2*pi, 41.0/65*2*pi,ring21,ring22),
    (41.5/65*2*pi, (ring21+ring22)/2, 41.0/65*2*pi, 42.0/65*2*pi,ring21,ring22),
    (42.5/65*2*pi, (ring21+ring22)/2, 42.0/65*2*pi, 43.0/65*2*pi,ring21,ring22),
    (43.5/65*2*pi, (ring21+ring22)/2, 43.0/65*2*pi, 44.0/65*2*pi,ring21,ring22),
    (44.5/65*2*pi, (ring21+ring22)/2, 44.0/65*2*pi, 45.0/65*2*pi,ring21,ring22),
    (45.5/65*2*pi, (ring21+ring22)/2, 45.0/65*2*pi, 46.0/65*2*pi,ring21,ring22),
    (46.5/65*2*pi, (ring21+ring22)/2, 46.0/65*2*pi, 47.0/65*2*pi,ring21,ring22),
    (47.5/65*2*pi, (ring21+ring22)/2, 47.0/65*2*pi, 48.0/65*2*pi,ring21,ring22),
    (48.5/65*2*pi, (ring21+ring22)/2, 48.0/65*2*pi, 49.0/65*2*pi,ring21,ring22),
    (49.5/65*2*pi, (ring21+ring22)/2, 49.0/65*2*pi, 50.0/65*2*pi,ring21,ring22),
    (50.5/65*2*pi, (ring21+ring22)/2, 50.0/65*2*pi, 51.0/65*2*pi,ring21,ring22),
    (51.5/65*2*pi, (ring21+ring22)/2, 51.0/65*2*pi, 52.0/65*2*pi,ring21,ring22),
    (52.5/65*2*pi, (ring21+ring22)/2, 52.0/65*2*pi, 53.0/65*2*pi,ring21,ring22),
    (53.5/65*2*pi, (ring21+ring22)/2, 53.0/65*2*pi, 54.0/65*2*pi,ring21,ring22),
    (54.5/65*2*pi, (ring21+ring22)/2, 54.0/65*2*pi, 55.0/65*2*pi,ring21,ring22),
    (55.5/65*2*pi, (ring21+ring22)/2, 55.0/65*2*pi, 56.0/65*2*pi,ring21,ring22),
    (56.5/65*2*pi, (ring21+ring22)/2, 56.0/65*2*pi, 57.0/65*2*pi,ring21,ring22),
    (57.5/65*2*pi, (ring21+ring22)/2, 57.0/65*2*pi, 58.0/65*2*pi,ring21,ring22),
    (58.5/65*2*pi, (ring21+ring22)/2, 58.0/65*2*pi, 59.0/65*2*pi,ring21,ring22),
    (59.5/65*2*pi, (ring21+ring22)/2, 59.0/65*2*pi, 60.0/65*2*pi,ring21,ring22),
    (60.5/65*2*pi, (ring21+ring22)/2, 60.0/65*2*pi, 61.0/65*2*pi,ring21,ring22),
    (61.5/65*2*pi, (ring21+ring22)/2, 61.0/65*2*pi, 62.0/65*2*pi,ring21,ring22),
    (62.5/65*2*pi, (ring21+ring22)/2, 62.0/65*2*pi, 63.0/65*2*pi,ring21,ring22),
    (63.5/65*2*pi, (ring21+ring22)/2, 63.0/65*2*pi, 64.0/65*2*pi,ring21,ring22),
    (64.5/65*2*pi, (ring21+ring22)/2, 64.0/65*2*pi, 65.0/65*2*pi,ring21,ring22),



    (0.5/63*2*pi, (ring22+ring23)/2, 0.0/63*2*pi, 1.0/63*2*pi,ring22,ring23),
    (1.5/63*2*pi, (ring22+ring23)/2, 1.0/63*2*pi, 2.0/63*2*pi,ring22,ring23),
    (2.5/63*2*pi, (ring22+ring23)/2, 2.0/63*2*pi, 3.0/63*2*pi,ring22,ring23),
    (3.5/63*2*pi, (ring22+ring23)/2, 3.0/63*2*pi, 4.0/63*2*pi,ring22,ring23),
    (4.5/63*2*pi, (ring22+ring23)/2, 4.0/63*2*pi, 5.0/63*2*pi,ring22,ring23),
    (5.5/63*2*pi, (ring22+ring23)/2, 5.0/63*2*pi, 6.0/63*2*pi,ring22,ring23),
    (6.5/63*2*pi, (ring22+ring23)/2, 6.0/63*2*pi, 7.0/63*2*pi,ring22,ring23),
    (7.5/63*2*pi, (ring22+ring23)/2, 7.0/63*2*pi, 8.0/63*2*pi,ring22,ring23),
    (8.5/63*2*pi, (ring22+ring23)/2, 8.0/63*2*pi, 9.0/63*2*pi,ring22,ring23),
    (9.5/63*2*pi, (ring22+ring23)/2, 9.0/63*2*pi, 10.0/63*2*pi,ring22,ring23),
    (10.5/63*2*pi, (ring22+ring23)/2, 10.0/63*2*pi, 11.0/63*2*pi,ring22,ring23),
    (11.5/63*2*pi, (ring22+ring23)/2, 11.0/63*2*pi, 12.0/63*2*pi,ring22,ring23),
    (12.5/63*2*pi, (ring22+ring23)/2, 12.0/63*2*pi, 13.0/63*2*pi,ring22,ring23),
    (13.5/63*2*pi, (ring22+ring23)/2, 13.0/63*2*pi, 14.0/63*2*pi,ring22,ring23),
    (14.5/63*2*pi, (ring22+ring23)/2, 14.0/63*2*pi, 15.0/63*2*pi,ring22,ring23),
    (15.5/63*2*pi, (ring22+ring23)/2, 15.0/63*2*pi, 16.0/63*2*pi,ring22,ring23),
    (16.5/63*2*pi, (ring22+ring23)/2, 16.0/63*2*pi, 17.0/63*2*pi,ring22,ring23),
    (17.5/63*2*pi, (ring22+ring23)/2, 17.0/63*2*pi, 18.0/63*2*pi,ring22,ring23),
    (18.5/63*2*pi, (ring22+ring23)/2, 18.0/63*2*pi, 19.0/63*2*pi,ring22,ring23),
    (19.5/63*2*pi, (ring22+ring23)/2, 19.0/63*2*pi, 20.0/63*2*pi,ring22,ring23),
    (20.5/63*2*pi, (ring22+ring23)/2, 20.0/63*2*pi, 21.0/63*2*pi,ring22,ring23),
    (21.5/63*2*pi, (ring22+ring23)/2, 21.0/63*2*pi, 22.0/63*2*pi,ring22,ring23),
    (22.5/63*2*pi, (ring22+ring23)/2, 22.0/63*2*pi, 23.0/63*2*pi,ring22,ring23),
    (23.5/63*2*pi, (ring22+ring23)/2, 23.0/63*2*pi, 24.0/63*2*pi,ring22,ring23),
    (24.5/63*2*pi, (ring22+ring23)/2, 24.0/63*2*pi, 25.0/63*2*pi,ring22,ring23),
    (25.5/63*2*pi, (ring22+ring23)/2, 25.0/63*2*pi, 26.0/63*2*pi,ring22,ring23),
    (26.5/63*2*pi, (ring22+ring23)/2, 26.0/63*2*pi, 27.0/63*2*pi,ring22,ring23),
    (27.5/63*2*pi, (ring22+ring23)/2, 27.0/63*2*pi, 28.0/63*2*pi,ring22,ring23),
    (28.5/63*2*pi, (ring22+ring23)/2, 28.0/63*2*pi, 29.0/63*2*pi,ring22,ring23),
    (29.5/63*2*pi, (ring22+ring23)/2, 29.0/63*2*pi, 30.0/63*2*pi,ring22,ring23),
    (30.5/63*2*pi, (ring22+ring23)/2, 30.0/63*2*pi, 31.0/63*2*pi,ring22,ring23),
    (31.5/63*2*pi, (ring22+ring23)/2, 31.0/63*2*pi, 32.0/63*2*pi,ring22,ring23),
    (32.5/63*2*pi, (ring22+ring23)/2, 32.0/63*2*pi, 33.0/63*2*pi,ring22,ring23),
    (33.5/63*2*pi, (ring22+ring23)/2, 33.0/63*2*pi, 34.0/63*2*pi,ring22,ring23),
    (34.5/63*2*pi, (ring22+ring23)/2, 34.0/63*2*pi, 35.0/63*2*pi,ring22,ring23),
    (35.5/63*2*pi, (ring22+ring23)/2, 35.0/63*2*pi, 36.0/63*2*pi,ring22,ring23),
    (36.5/63*2*pi, (ring22+ring23)/2, 36.0/63*2*pi, 37.0/63*2*pi,ring22,ring23),
    (37.5/63*2*pi, (ring22+ring23)/2, 37.0/63*2*pi, 38.0/63*2*pi,ring22,ring23),
    (38.5/63*2*pi, (ring22+ring23)/2, 38.0/63*2*pi, 39.0/63*2*pi,ring22,ring23),
    (39.5/63*2*pi, (ring22+ring23)/2, 39.0/63*2*pi, 40.0/63*2*pi,ring22,ring23),
    (40.5/63*2*pi, (ring22+ring23)/2, 40.0/63*2*pi, 41.0/63*2*pi,ring22,ring23),
    (41.5/63*2*pi, (ring22+ring23)/2, 41.0/63*2*pi, 42.0/63*2*pi,ring22,ring23),
    (42.5/63*2*pi, (ring22+ring23)/2, 42.0/63*2*pi, 43.0/63*2*pi,ring22,ring23),
    (43.5/63*2*pi, (ring22+ring23)/2, 43.0/63*2*pi, 44.0/63*2*pi,ring22,ring23),
    (44.5/63*2*pi, (ring22+ring23)/2, 44.0/63*2*pi, 45.0/63*2*pi,ring22,ring23),
    (45.5/63*2*pi, (ring22+ring23)/2, 45.0/63*2*pi, 46.0/63*2*pi,ring22,ring23),
    (46.5/63*2*pi, (ring22+ring23)/2, 46.0/63*2*pi, 47.0/63*2*pi,ring22,ring23),
    (47.5/63*2*pi, (ring22+ring23)/2, 47.0/63*2*pi, 48.0/63*2*pi,ring22,ring23),
    (48.5/63*2*pi, (ring22+ring23)/2, 48.0/63*2*pi, 49.0/63*2*pi,ring22,ring23),
    (49.5/63*2*pi, (ring22+ring23)/2, 49.0/63*2*pi, 50.0/63*2*pi,ring22,ring23),
    (50.5/63*2*pi, (ring22+ring23)/2, 50.0/63*2*pi, 51.0/63*2*pi,ring22,ring23),
    (51.5/63*2*pi, (ring22+ring23)/2, 51.0/63*2*pi, 52.0/63*2*pi,ring22,ring23),
    (52.5/63*2*pi, (ring22+ring23)/2, 52.0/63*2*pi, 53.0/63*2*pi,ring22,ring23),
    (53.5/63*2*pi, (ring22+ring23)/2, 53.0/63*2*pi, 54.0/63*2*pi,ring22,ring23),
    (54.5/63*2*pi, (ring22+ring23)/2, 54.0/63*2*pi, 55.0/63*2*pi,ring22,ring23),
    (55.5/63*2*pi, (ring22+ring23)/2, 55.0/63*2*pi, 56.0/63*2*pi,ring22,ring23),
    (56.5/63*2*pi, (ring22+ring23)/2, 56.0/63*2*pi, 57.0/63*2*pi,ring22,ring23),
    (57.5/63*2*pi, (ring22+ring23)/2, 57.0/63*2*pi, 58.0/63*2*pi,ring22,ring23),
    (58.5/63*2*pi, (ring22+ring23)/2, 58.0/63*2*pi, 59.0/63*2*pi,ring22,ring23),
    (59.5/63*2*pi, (ring22+ring23)/2, 59.0/63*2*pi, 60.0/63*2*pi,ring22,ring23),
    (60.5/63*2*pi, (ring22+ring23)/2, 60.0/63*2*pi, 61.0/63*2*pi,ring22,ring23),
    (61.5/63*2*pi, (ring22+ring23)/2, 61.0/63*2*pi, 62.0/63*2*pi,ring22,ring23),
    (62.5/63*2*pi, (ring22+ring23)/2, 62.0/63*2*pi, 63.0/63*2*pi,ring22,ring23),



    (0.5/60*2*pi, (ring23+ring24)/2, 0.0/60*2*pi, 1.0/60*2*pi,ring23,ring24),
    (1.5/60*2*pi, (ring23+ring24)/2, 1.0/60*2*pi, 2.0/60*2*pi,ring23,ring24),
    (2.5/60*2*pi, (ring23+ring24)/2, 2.0/60*2*pi, 3.0/60*2*pi,ring23,ring24),
    (3.5/60*2*pi, (ring23+ring24)/2, 3.0/60*2*pi, 4.0/60*2*pi,ring23,ring24),
    (4.5/60*2*pi, (ring23+ring24)/2, 4.0/60*2*pi, 5.0/60*2*pi,ring23,ring24),
    (5.5/60*2*pi, (ring23+ring24)/2, 5.0/60*2*pi, 6.0/60*2*pi,ring23,ring24),
    (6.5/60*2*pi, (ring23+ring24)/2, 6.0/60*2*pi, 7.0/60*2*pi,ring23,ring24),
    (7.5/60*2*pi, (ring23+ring24)/2, 7.0/60*2*pi, 8.0/60*2*pi,ring23,ring24),
    (8.5/60*2*pi, (ring23+ring24)/2, 8.0/60*2*pi, 9.0/60*2*pi,ring23,ring24),
    (9.5/60*2*pi, (ring23+ring24)/2, 9.0/60*2*pi, 10.0/60*2*pi,ring23,ring24),
    (10.5/60*2*pi, (ring23+ring24)/2, 10.0/60*2*pi, 11.0/60*2*pi,ring23,ring24),
    (11.5/60*2*pi, (ring23+ring24)/2, 11.0/60*2*pi, 12.0/60*2*pi,ring23,ring24),
    (12.5/60*2*pi, (ring23+ring24)/2, 12.0/60*2*pi, 13.0/60*2*pi,ring23,ring24),
    (13.5/60*2*pi, (ring23+ring24)/2, 13.0/60*2*pi, 14.0/60*2*pi,ring23,ring24),
    (14.5/60*2*pi, (ring23+ring24)/2, 14.0/60*2*pi, 15.0/60*2*pi,ring23,ring24),
    (15.5/60*2*pi, (ring23+ring24)/2, 15.0/60*2*pi, 16.0/60*2*pi,ring23,ring24),
    (16.5/60*2*pi, (ring23+ring24)/2, 16.0/60*2*pi, 17.0/60*2*pi,ring23,ring24),
    (17.5/60*2*pi, (ring23+ring24)/2, 17.0/60*2*pi, 18.0/60*2*pi,ring23,ring24),
    (18.5/60*2*pi, (ring23+ring24)/2, 18.0/60*2*pi, 19.0/60*2*pi,ring23,ring24),
    (19.5/60*2*pi, (ring23+ring24)/2, 19.0/60*2*pi, 20.0/60*2*pi,ring23,ring24),
    (20.5/60*2*pi, (ring23+ring24)/2, 20.0/60*2*pi, 21.0/60*2*pi,ring23,ring24),
    (21.5/60*2*pi, (ring23+ring24)/2, 21.0/60*2*pi, 22.0/60*2*pi,ring23,ring24),
    (22.5/60*2*pi, (ring23+ring24)/2, 22.0/60*2*pi, 23.0/60*2*pi,ring23,ring24),
    (23.5/60*2*pi, (ring23+ring24)/2, 23.0/60*2*pi, 24.0/60*2*pi,ring23,ring24),
    (24.5/60*2*pi, (ring23+ring24)/2, 24.0/60*2*pi, 25.0/60*2*pi,ring23,ring24),
    (25.5/60*2*pi, (ring23+ring24)/2, 25.0/60*2*pi, 26.0/60*2*pi,ring23,ring24),
    (26.5/60*2*pi, (ring23+ring24)/2, 26.0/60*2*pi, 27.0/60*2*pi,ring23,ring24),
    (27.5/60*2*pi, (ring23+ring24)/2, 27.0/60*2*pi, 28.0/60*2*pi,ring23,ring24),
    (28.5/60*2*pi, (ring23+ring24)/2, 28.0/60*2*pi, 29.0/60*2*pi,ring23,ring24),
    (29.5/60*2*pi, (ring23+ring24)/2, 29.0/60*2*pi, 30.0/60*2*pi,ring23,ring24),
    (30.5/60*2*pi, (ring23+ring24)/2, 30.0/60*2*pi, 31.0/60*2*pi,ring23,ring24),
    (31.5/60*2*pi, (ring23+ring24)/2, 31.0/60*2*pi, 32.0/60*2*pi,ring23,ring24),
    (32.5/60*2*pi, (ring23+ring24)/2, 32.0/60*2*pi, 33.0/60*2*pi,ring23,ring24),
    (33.5/60*2*pi, (ring23+ring24)/2, 33.0/60*2*pi, 34.0/60*2*pi,ring23,ring24),
    (34.5/60*2*pi, (ring23+ring24)/2, 34.0/60*2*pi, 35.0/60*2*pi,ring23,ring24),
    (35.5/60*2*pi, (ring23+ring24)/2, 35.0/60*2*pi, 36.0/60*2*pi,ring23,ring24),
    (36.5/60*2*pi, (ring23+ring24)/2, 36.0/60*2*pi, 37.0/60*2*pi,ring23,ring24),
    (37.5/60*2*pi, (ring23+ring24)/2, 37.0/60*2*pi, 38.0/60*2*pi,ring23,ring24),
    (38.5/60*2*pi, (ring23+ring24)/2, 38.0/60*2*pi, 39.0/60*2*pi,ring23,ring24),
    (39.5/60*2*pi, (ring23+ring24)/2, 39.0/60*2*pi, 40.0/60*2*pi,ring23,ring24),
    (40.5/60*2*pi, (ring23+ring24)/2, 40.0/60*2*pi, 41.0/60*2*pi,ring23,ring24),
    (41.5/60*2*pi, (ring23+ring24)/2, 41.0/60*2*pi, 42.0/60*2*pi,ring23,ring24),
    (42.5/60*2*pi, (ring23+ring24)/2, 42.0/60*2*pi, 43.0/60*2*pi,ring23,ring24),
    (43.5/60*2*pi, (ring23+ring24)/2, 43.0/60*2*pi, 44.0/60*2*pi,ring23,ring24),
    (44.5/60*2*pi, (ring23+ring24)/2, 44.0/60*2*pi, 45.0/60*2*pi,ring23,ring24),
    (45.5/60*2*pi, (ring23+ring24)/2, 45.0/60*2*pi, 46.0/60*2*pi,ring23,ring24),
    (46.5/60*2*pi, (ring23+ring24)/2, 46.0/60*2*pi, 47.0/60*2*pi,ring23,ring24),
    (47.5/60*2*pi, (ring23+ring24)/2, 47.0/60*2*pi, 48.0/60*2*pi,ring23,ring24),
    (48.5/60*2*pi, (ring23+ring24)/2, 48.0/60*2*pi, 49.0/60*2*pi,ring23,ring24),
    (49.5/60*2*pi, (ring23+ring24)/2, 49.0/60*2*pi, 50.0/60*2*pi,ring23,ring24),
    (50.5/60*2*pi, (ring23+ring24)/2, 50.0/60*2*pi, 51.0/60*2*pi,ring23,ring24),
    (51.5/60*2*pi, (ring23+ring24)/2, 51.0/60*2*pi, 52.0/60*2*pi,ring23,ring24),
    (52.5/60*2*pi, (ring23+ring24)/2, 52.0/60*2*pi, 53.0/60*2*pi,ring23,ring24),
    (53.5/60*2*pi, (ring23+ring24)/2, 53.0/60*2*pi, 54.0/60*2*pi,ring23,ring24),
    (54.5/60*2*pi, (ring23+ring24)/2, 54.0/60*2*pi, 55.0/60*2*pi,ring23,ring24),
    (55.5/60*2*pi, (ring23+ring24)/2, 55.0/60*2*pi, 56.0/60*2*pi,ring23,ring24),
    (56.5/60*2*pi, (ring23+ring24)/2, 56.0/60*2*pi, 57.0/60*2*pi,ring23,ring24),
    (57.5/60*2*pi, (ring23+ring24)/2, 57.0/60*2*pi, 58.0/60*2*pi,ring23,ring24),
    (58.5/60*2*pi, (ring23+ring24)/2, 58.0/60*2*pi, 59.0/60*2*pi,ring23,ring24),
    (59.5/60*2*pi, (ring23+ring24)/2, 59.0/60*2*pi, 60.0/60*2*pi,ring23,ring24),


    (0.5/56*2*pi, (ring24+ring25)/2, 0.0/56*2*pi, 1.0/56*2*pi,ring24,ring25),
    (1.5/56*2*pi, (ring24+ring25)/2, 1.0/56*2*pi, 2.0/56*2*pi,ring24,ring25),
    (2.5/56*2*pi, (ring24+ring25)/2, 2.0/56*2*pi, 3.0/56*2*pi,ring24,ring25),
    (3.5/56*2*pi, (ring24+ring25)/2, 3.0/56*2*pi, 4.0/56*2*pi,ring24,ring25),
    (4.5/56*2*pi, (ring24+ring25)/2, 4.0/56*2*pi, 5.0/56*2*pi,ring24,ring25),
    (5.5/56*2*pi, (ring24+ring25)/2, 5.0/56*2*pi, 6.0/56*2*pi,ring24,ring25),
    (6.5/56*2*pi, (ring24+ring25)/2, 6.0/56*2*pi, 7.0/56*2*pi,ring24,ring25),
    (7.5/56*2*pi, (ring24+ring25)/2, 7.0/56*2*pi, 8.0/56*2*pi,ring24,ring25),
    (8.5/56*2*pi, (ring24+ring25)/2, 8.0/56*2*pi, 9.0/56*2*pi,ring24,ring25),
    (9.5/56*2*pi, (ring24+ring25)/2, 9.0/56*2*pi, 10.0/56*2*pi,ring24,ring25),
    (10.5/56*2*pi, (ring24+ring25)/2, 10.0/56*2*pi, 11.0/56*2*pi,ring24,ring25),
    (11.5/56*2*pi, (ring24+ring25)/2, 11.0/56*2*pi, 12.0/56*2*pi,ring24,ring25),
    (12.5/56*2*pi, (ring24+ring25)/2, 12.0/56*2*pi, 13.0/56*2*pi,ring24,ring25),
    (13.5/56*2*pi, (ring24+ring25)/2, 13.0/56*2*pi, 14.0/56*2*pi,ring24,ring25),
    (14.5/56*2*pi, (ring24+ring25)/2, 14.0/56*2*pi, 15.0/56*2*pi,ring24,ring25),
    (15.5/56*2*pi, (ring24+ring25)/2, 15.0/56*2*pi, 16.0/56*2*pi,ring24,ring25),
    (16.5/56*2*pi, (ring24+ring25)/2, 16.0/56*2*pi, 17.0/56*2*pi,ring24,ring25),
    (17.5/56*2*pi, (ring24+ring25)/2, 17.0/56*2*pi, 18.0/56*2*pi,ring24,ring25),
    (18.5/56*2*pi, (ring24+ring25)/2, 18.0/56*2*pi, 19.0/56*2*pi,ring24,ring25),
    (19.5/56*2*pi, (ring24+ring25)/2, 19.0/56*2*pi, 20.0/56*2*pi,ring24,ring25),
    (20.5/56*2*pi, (ring24+ring25)/2, 20.0/56*2*pi, 21.0/56*2*pi,ring24,ring25),
    (21.5/56*2*pi, (ring24+ring25)/2, 21.0/56*2*pi, 22.0/56*2*pi,ring24,ring25),
    (22.5/56*2*pi, (ring24+ring25)/2, 22.0/56*2*pi, 23.0/56*2*pi,ring24,ring25),
    (23.5/56*2*pi, (ring24+ring25)/2, 23.0/56*2*pi, 24.0/56*2*pi,ring24,ring25),
    (24.5/56*2*pi, (ring24+ring25)/2, 24.0/56*2*pi, 25.0/56*2*pi,ring24,ring25),
    (25.5/56*2*pi, (ring24+ring25)/2, 25.0/56*2*pi, 26.0/56*2*pi,ring24,ring25),
    (26.5/56*2*pi, (ring24+ring25)/2, 26.0/56*2*pi, 27.0/56*2*pi,ring24,ring25),
    (27.5/56*2*pi, (ring24+ring25)/2, 27.0/56*2*pi, 28.0/56*2*pi,ring24,ring25),
    (28.5/56*2*pi, (ring24+ring25)/2, 28.0/56*2*pi, 29.0/56*2*pi,ring24,ring25),
    (29.5/56*2*pi, (ring24+ring25)/2, 29.0/56*2*pi, 30.0/56*2*pi,ring24,ring25),
    (30.5/56*2*pi, (ring24+ring25)/2, 30.0/56*2*pi, 31.0/56*2*pi,ring24,ring25),
    (31.5/56*2*pi, (ring24+ring25)/2, 31.0/56*2*pi, 32.0/56*2*pi,ring24,ring25),
    (32.5/56*2*pi, (ring24+ring25)/2, 32.0/56*2*pi, 33.0/56*2*pi,ring24,ring25),
    (33.5/56*2*pi, (ring24+ring25)/2, 33.0/56*2*pi, 34.0/56*2*pi,ring24,ring25),
    (34.5/56*2*pi, (ring24+ring25)/2, 34.0/56*2*pi, 35.0/56*2*pi,ring24,ring25),
    (35.5/56*2*pi, (ring24+ring25)/2, 35.0/56*2*pi, 36.0/56*2*pi,ring24,ring25),
    (36.5/56*2*pi, (ring24+ring25)/2, 36.0/56*2*pi, 37.0/56*2*pi,ring24,ring25),
    (37.5/56*2*pi, (ring24+ring25)/2, 37.0/56*2*pi, 38.0/56*2*pi,ring24,ring25),
    (38.5/56*2*pi, (ring24+ring25)/2, 38.0/56*2*pi, 39.0/56*2*pi,ring24,ring25),
    (39.5/56*2*pi, (ring24+ring25)/2, 39.0/56*2*pi, 40.0/56*2*pi,ring24,ring25),
    (40.5/56*2*pi, (ring24+ring25)/2, 40.0/56*2*pi, 41.0/56*2*pi,ring24,ring25),
    (41.5/56*2*pi, (ring24+ring25)/2, 41.0/56*2*pi, 42.0/56*2*pi,ring24,ring25),
    (42.5/56*2*pi, (ring24+ring25)/2, 42.0/56*2*pi, 43.0/56*2*pi,ring24,ring25),
    (43.5/56*2*pi, (ring24+ring25)/2, 43.0/56*2*pi, 44.0/56*2*pi,ring24,ring25),
    (44.5/56*2*pi, (ring24+ring25)/2, 44.0/56*2*pi, 45.0/56*2*pi,ring24,ring25),
    (45.5/56*2*pi, (ring24+ring25)/2, 45.0/56*2*pi, 46.0/56*2*pi,ring24,ring25),
    (46.5/56*2*pi, (ring24+ring25)/2, 46.0/56*2*pi, 47.0/56*2*pi,ring24,ring25),
    (47.5/56*2*pi, (ring24+ring25)/2, 47.0/56*2*pi, 48.0/56*2*pi,ring24,ring25),
    (48.5/56*2*pi, (ring24+ring25)/2, 48.0/56*2*pi, 49.0/56*2*pi,ring24,ring25),
    (49.5/56*2*pi, (ring24+ring25)/2, 49.0/56*2*pi, 50.0/56*2*pi,ring24,ring25),
    (50.5/56*2*pi, (ring24+ring25)/2, 50.0/56*2*pi, 51.0/56*2*pi,ring24,ring25),
    (51.5/56*2*pi, (ring24+ring25)/2, 51.0/56*2*pi, 52.0/56*2*pi,ring24,ring25),
    (52.5/56*2*pi, (ring24+ring25)/2, 52.0/56*2*pi, 53.0/56*2*pi,ring24,ring25),
    (53.5/56*2*pi, (ring24+ring25)/2, 53.0/56*2*pi, 54.0/56*2*pi,ring24,ring25),
    (54.5/56*2*pi, (ring24+ring25)/2, 54.0/56*2*pi, 55.0/56*2*pi,ring24,ring25),
    (55.5/56*2*pi, (ring24+ring25)/2, 55.0/56*2*pi, 56.0/56*2*pi,ring24,ring25),


    (0.5/52*2*pi, (ring25+ring26)/2, 0.0/52*2*pi, 1.0/52*2*pi,ring25,ring26),
    (1.5/52*2*pi, (ring25+ring26)/2, 1.0/52*2*pi, 2.0/52*2*pi,ring25,ring26),
    (2.5/52*2*pi, (ring25+ring26)/2, 2.0/52*2*pi, 3.0/52*2*pi,ring25,ring26),
    (3.5/52*2*pi, (ring25+ring26)/2, 3.0/52*2*pi, 4.0/52*2*pi,ring25,ring26),
    (4.5/52*2*pi, (ring25+ring26)/2, 4.0/52*2*pi, 5.0/52*2*pi,ring25,ring26),
    (5.5/52*2*pi, (ring25+ring26)/2, 5.0/52*2*pi, 6.0/52*2*pi,ring25,ring26),
    (6.5/52*2*pi, (ring25+ring26)/2, 6.0/52*2*pi, 7.0/52*2*pi,ring25,ring26),
    (7.5/52*2*pi, (ring25+ring26)/2, 7.0/52*2*pi, 8.0/52*2*pi,ring25,ring26),
    (8.5/52*2*pi, (ring25+ring26)/2, 8.0/52*2*pi, 9.0/52*2*pi,ring25,ring26),
    (9.5/52*2*pi, (ring25+ring26)/2, 9.0/52*2*pi, 10.0/52*2*pi,ring25,ring26),
    (10.5/52*2*pi, (ring25+ring26)/2, 10.0/52*2*pi, 11.0/52*2*pi,ring25,ring26),
    (11.5/52*2*pi, (ring25+ring26)/2, 11.0/52*2*pi, 12.0/52*2*pi,ring25,ring26),
    (12.5/52*2*pi, (ring25+ring26)/2, 12.0/52*2*pi, 13.0/52*2*pi,ring25,ring26),
    (13.5/52*2*pi, (ring25+ring26)/2, 13.0/52*2*pi, 14.0/52*2*pi,ring25,ring26),
    (14.5/52*2*pi, (ring25+ring26)/2, 14.0/52*2*pi, 15.0/52*2*pi,ring25,ring26),
    (15.5/52*2*pi, (ring25+ring26)/2, 15.0/52*2*pi, 16.0/52*2*pi,ring25,ring26),
    (16.5/52*2*pi, (ring25+ring26)/2, 16.0/52*2*pi, 17.0/52*2*pi,ring25,ring26),
    (17.5/52*2*pi, (ring25+ring26)/2, 17.0/52*2*pi, 18.0/52*2*pi,ring25,ring26),
    (18.5/52*2*pi, (ring25+ring26)/2, 18.0/52*2*pi, 19.0/52*2*pi,ring25,ring26),
    (19.5/52*2*pi, (ring25+ring26)/2, 19.0/52*2*pi, 20.0/52*2*pi,ring25,ring26),
    (20.5/52*2*pi, (ring25+ring26)/2, 20.0/52*2*pi, 21.0/52*2*pi,ring25,ring26),
    (21.5/52*2*pi, (ring25+ring26)/2, 21.0/52*2*pi, 22.0/52*2*pi,ring25,ring26),
    (22.5/52*2*pi, (ring25+ring26)/2, 22.0/52*2*pi, 23.0/52*2*pi,ring25,ring26),
    (23.5/52*2*pi, (ring25+ring26)/2, 23.0/52*2*pi, 24.0/52*2*pi,ring25,ring26),
    (24.5/52*2*pi, (ring25+ring26)/2, 24.0/52*2*pi, 25.0/52*2*pi,ring25,ring26),
    (25.5/52*2*pi, (ring25+ring26)/2, 25.0/52*2*pi, 26.0/52*2*pi,ring25,ring26),
    (26.5/52*2*pi, (ring25+ring26)/2, 26.0/52*2*pi, 27.0/52*2*pi,ring25,ring26),
    (27.5/52*2*pi, (ring25+ring26)/2, 27.0/52*2*pi, 28.0/52*2*pi,ring25,ring26),
    (28.5/52*2*pi, (ring25+ring26)/2, 28.0/52*2*pi, 29.0/52*2*pi,ring25,ring26),
    (29.5/52*2*pi, (ring25+ring26)/2, 29.0/52*2*pi, 30.0/52*2*pi,ring25,ring26),
    (30.5/52*2*pi, (ring25+ring26)/2, 30.0/52*2*pi, 31.0/52*2*pi,ring25,ring26),
    (31.5/52*2*pi, (ring25+ring26)/2, 31.0/52*2*pi, 32.0/52*2*pi,ring25,ring26),
    (32.5/52*2*pi, (ring25+ring26)/2, 32.0/52*2*pi, 33.0/52*2*pi,ring25,ring26),
    (33.5/52*2*pi, (ring25+ring26)/2, 33.0/52*2*pi, 34.0/52*2*pi,ring25,ring26),
    (34.5/52*2*pi, (ring25+ring26)/2, 34.0/52*2*pi, 35.0/52*2*pi,ring25,ring26),
    (35.5/52*2*pi, (ring25+ring26)/2, 35.0/52*2*pi, 36.0/52*2*pi,ring25,ring26),
    (36.5/52*2*pi, (ring25+ring26)/2, 36.0/52*2*pi, 37.0/52*2*pi,ring25,ring26),
    (37.5/52*2*pi, (ring25+ring26)/2, 37.0/52*2*pi, 38.0/52*2*pi,ring25,ring26),
    (38.5/52*2*pi, (ring25+ring26)/2, 38.0/52*2*pi, 39.0/52*2*pi,ring25,ring26),
    (39.5/52*2*pi, (ring25+ring26)/2, 39.0/52*2*pi, 40.0/52*2*pi,ring25,ring26),
    (40.5/52*2*pi, (ring25+ring26)/2, 40.0/52*2*pi, 41.0/52*2*pi,ring25,ring26),
    (41.5/52*2*pi, (ring25+ring26)/2, 41.0/52*2*pi, 42.0/52*2*pi,ring25,ring26),
    (42.5/52*2*pi, (ring25+ring26)/2, 42.0/52*2*pi, 43.0/52*2*pi,ring25,ring26),
    (43.5/52*2*pi, (ring25+ring26)/2, 43.0/52*2*pi, 44.0/52*2*pi,ring25,ring26),
    (44.5/52*2*pi, (ring25+ring26)/2, 44.0/52*2*pi, 45.0/52*2*pi,ring25,ring26),
    (45.5/52*2*pi, (ring25+ring26)/2, 45.0/52*2*pi, 46.0/52*2*pi,ring25,ring26),
    (46.5/52*2*pi, (ring25+ring26)/2, 46.0/52*2*pi, 47.0/52*2*pi,ring25,ring26),
    (47.5/52*2*pi, (ring25+ring26)/2, 47.0/52*2*pi, 48.0/52*2*pi,ring25,ring26),
    (48.5/52*2*pi, (ring25+ring26)/2, 48.0/52*2*pi, 49.0/52*2*pi,ring25,ring26),
    (49.5/52*2*pi, (ring25+ring26)/2, 49.0/52*2*pi, 50.0/52*2*pi,ring25,ring26),
    (50.5/52*2*pi, (ring25+ring26)/2, 50.0/52*2*pi, 51.0/52*2*pi,ring25,ring26),
    (51.5/52*2*pi, (ring25+ring26)/2, 51.0/52*2*pi, 52.0/52*2*pi,ring25,ring26),


    (0.5/48*2*pi, (ring26+ring27)/2, 0.0/48*2*pi, 1.0/48*2*pi,ring26,ring27),
    (1.5/48*2*pi, (ring26+ring27)/2, 1.0/48*2*pi, 2.0/48*2*pi,ring26,ring27),
    (2.5/48*2*pi, (ring26+ring27)/2, 2.0/48*2*pi, 3.0/48*2*pi,ring26,ring27),
    (3.5/48*2*pi, (ring26+ring27)/2, 3.0/48*2*pi, 4.0/48*2*pi,ring26,ring27),
    (4.5/48*2*pi, (ring26+ring27)/2, 4.0/48*2*pi, 5.0/48*2*pi,ring26,ring27),
    (5.5/48*2*pi, (ring26+ring27)/2, 5.0/48*2*pi, 6.0/48*2*pi,ring26,ring27),
    (6.5/48*2*pi, (ring26+ring27)/2, 6.0/48*2*pi, 7.0/48*2*pi,ring26,ring27),
    (7.5/48*2*pi, (ring26+ring27)/2, 7.0/48*2*pi, 8.0/48*2*pi,ring26,ring27),
    (8.5/48*2*pi, (ring26+ring27)/2, 8.0/48*2*pi, 9.0/48*2*pi,ring26,ring27),
    (9.5/48*2*pi, (ring26+ring27)/2, 9.0/48*2*pi, 10.0/48*2*pi,ring26,ring27),
    (10.5/48*2*pi, (ring26+ring27)/2, 10.0/48*2*pi, 11.0/48*2*pi,ring26,ring27),
    (11.5/48*2*pi, (ring26+ring27)/2, 11.0/48*2*pi, 12.0/48*2*pi,ring26,ring27),
    (12.5/48*2*pi, (ring26+ring27)/2, 12.0/48*2*pi, 13.0/48*2*pi,ring26,ring27),
    (13.5/48*2*pi, (ring26+ring27)/2, 13.0/48*2*pi, 14.0/48*2*pi,ring26,ring27),
    (14.5/48*2*pi, (ring26+ring27)/2, 14.0/48*2*pi, 15.0/48*2*pi,ring26,ring27),
    (15.5/48*2*pi, (ring26+ring27)/2, 15.0/48*2*pi, 16.0/48*2*pi,ring26,ring27),
    (16.5/48*2*pi, (ring26+ring27)/2, 16.0/48*2*pi, 17.0/48*2*pi,ring26,ring27),
    (17.5/48*2*pi, (ring26+ring27)/2, 17.0/48*2*pi, 18.0/48*2*pi,ring26,ring27),
    (18.5/48*2*pi, (ring26+ring27)/2, 18.0/48*2*pi, 19.0/48*2*pi,ring26,ring27),
    (19.5/48*2*pi, (ring26+ring27)/2, 19.0/48*2*pi, 20.0/48*2*pi,ring26,ring27),
    (20.5/48*2*pi, (ring26+ring27)/2, 20.0/48*2*pi, 21.0/48*2*pi,ring26,ring27),
    (21.5/48*2*pi, (ring26+ring27)/2, 21.0/48*2*pi, 22.0/48*2*pi,ring26,ring27),
    (22.5/48*2*pi, (ring26+ring27)/2, 22.0/48*2*pi, 23.0/48*2*pi,ring26,ring27),
    (23.5/48*2*pi, (ring26+ring27)/2, 23.0/48*2*pi, 24.0/48*2*pi,ring26,ring27),
    (24.5/48*2*pi, (ring26+ring27)/2, 24.0/48*2*pi, 25.0/48*2*pi,ring26,ring27),
    (25.5/48*2*pi, (ring26+ring27)/2, 25.0/48*2*pi, 26.0/48*2*pi,ring26,ring27),
    (26.5/48*2*pi, (ring26+ring27)/2, 26.0/48*2*pi, 27.0/48*2*pi,ring26,ring27),
    (27.5/48*2*pi, (ring26+ring27)/2, 27.0/48*2*pi, 28.0/48*2*pi,ring26,ring27),
    (28.5/48*2*pi, (ring26+ring27)/2, 28.0/48*2*pi, 29.0/48*2*pi,ring26,ring27),
    (29.5/48*2*pi, (ring26+ring27)/2, 29.0/48*2*pi, 30.0/48*2*pi,ring26,ring27),
    (30.5/48*2*pi, (ring26+ring27)/2, 30.0/48*2*pi, 31.0/48*2*pi,ring26,ring27),
    (31.5/48*2*pi, (ring26+ring27)/2, 31.0/48*2*pi, 32.0/48*2*pi,ring26,ring27),
    (32.5/48*2*pi, (ring26+ring27)/2, 32.0/48*2*pi, 33.0/48*2*pi,ring26,ring27),
    (33.5/48*2*pi, (ring26+ring27)/2, 33.0/48*2*pi, 34.0/48*2*pi,ring26,ring27),
    (34.5/48*2*pi, (ring26+ring27)/2, 34.0/48*2*pi, 35.0/48*2*pi,ring26,ring27),
    (35.5/48*2*pi, (ring26+ring27)/2, 35.0/48*2*pi, 36.0/48*2*pi,ring26,ring27),
    (36.5/48*2*pi, (ring26+ring27)/2, 36.0/48*2*pi, 37.0/48*2*pi,ring26,ring27),
    (37.5/48*2*pi, (ring26+ring27)/2, 37.0/48*2*pi, 38.0/48*2*pi,ring26,ring27),
    (38.5/48*2*pi, (ring26+ring27)/2, 38.0/48*2*pi, 39.0/48*2*pi,ring26,ring27),
    (39.5/48*2*pi, (ring26+ring27)/2, 39.0/48*2*pi, 40.0/48*2*pi,ring26,ring27),
    (40.5/48*2*pi, (ring26+ring27)/2, 40.0/48*2*pi, 41.0/48*2*pi,ring26,ring27),
    (41.5/48*2*pi, (ring26+ring27)/2, 41.0/48*2*pi, 42.0/48*2*pi,ring26,ring27),
    (42.5/48*2*pi, (ring26+ring27)/2, 42.0/48*2*pi, 43.0/48*2*pi,ring26,ring27),
    (43.5/48*2*pi, (ring26+ring27)/2, 43.0/48*2*pi, 44.0/48*2*pi,ring26,ring27),
    (44.5/48*2*pi, (ring26+ring27)/2, 44.0/48*2*pi, 45.0/48*2*pi,ring26,ring27),
    (45.5/48*2*pi, (ring26+ring27)/2, 45.0/48*2*pi, 46.0/48*2*pi,ring26,ring27),
    (46.5/48*2*pi, (ring26+ring27)/2, 46.0/48*2*pi, 47.0/48*2*pi,ring26,ring27),
    (47.5/48*2*pi, (ring26+ring27)/2, 47.0/48*2*pi, 48.0/48*2*pi,ring26,ring27),




    (0.5/43*2*pi, (ring27+ring28)/2, 0.0/43*2*pi, 1.0/43*2*pi,ring27,ring28),
    (1.5/43*2*pi, (ring27+ring28)/2, 1.0/43*2*pi, 2.0/43*2*pi,ring27,ring28),
    (2.5/43*2*pi, (ring27+ring28)/2, 2.0/43*2*pi, 3.0/43*2*pi,ring27,ring28),
    (3.5/43*2*pi, (ring27+ring28)/2, 3.0/43*2*pi, 4.0/43*2*pi,ring27,ring28),
    (4.5/43*2*pi, (ring27+ring28)/2, 4.0/43*2*pi, 5.0/43*2*pi,ring27,ring28),
    (5.5/43*2*pi, (ring27+ring28)/2, 5.0/43*2*pi, 6.0/43*2*pi,ring27,ring28),
    (6.5/43*2*pi, (ring27+ring28)/2, 6.0/43*2*pi, 7.0/43*2*pi,ring27,ring28),
    (7.5/43*2*pi, (ring27+ring28)/2, 7.0/43*2*pi, 8.0/43*2*pi,ring27,ring28),
    (8.5/43*2*pi, (ring27+ring28)/2, 8.0/43*2*pi, 9.0/43*2*pi,ring27,ring28),
    (9.5/43*2*pi, (ring27+ring28)/2, 9.0/43*2*pi, 10.0/43*2*pi,ring27,ring28),
    (10.5/43*2*pi, (ring27+ring28)/2, 10.0/43*2*pi, 11.0/43*2*pi,ring27,ring28),
    (11.5/43*2*pi, (ring27+ring28)/2, 11.0/43*2*pi, 12.0/43*2*pi,ring27,ring28),
    (12.5/43*2*pi, (ring27+ring28)/2, 12.0/43*2*pi, 13.0/43*2*pi,ring27,ring28),
    (13.5/43*2*pi, (ring27+ring28)/2, 13.0/43*2*pi, 14.0/43*2*pi,ring27,ring28),
    (14.5/43*2*pi, (ring27+ring28)/2, 14.0/43*2*pi, 15.0/43*2*pi,ring27,ring28),
    (15.5/43*2*pi, (ring27+ring28)/2, 15.0/43*2*pi, 16.0/43*2*pi,ring27,ring28),
    (16.5/43*2*pi, (ring27+ring28)/2, 16.0/43*2*pi, 17.0/43*2*pi,ring27,ring28),
    (17.5/43*2*pi, (ring27+ring28)/2, 17.0/43*2*pi, 18.0/43*2*pi,ring27,ring28),
    (18.5/43*2*pi, (ring27+ring28)/2, 18.0/43*2*pi, 19.0/43*2*pi,ring27,ring28),
    (19.5/43*2*pi, (ring27+ring28)/2, 19.0/43*2*pi, 20.0/43*2*pi,ring27,ring28),
    (20.5/43*2*pi, (ring27+ring28)/2, 20.0/43*2*pi, 21.0/43*2*pi,ring27,ring28),
    (21.5/43*2*pi, (ring27+ring28)/2, 21.0/43*2*pi, 22.0/43*2*pi,ring27,ring28),
    (22.5/43*2*pi, (ring27+ring28)/2, 22.0/43*2*pi, 23.0/43*2*pi,ring27,ring28),
    (23.5/43*2*pi, (ring27+ring28)/2, 23.0/43*2*pi, 24.0/43*2*pi,ring27,ring28),
    (24.5/43*2*pi, (ring27+ring28)/2, 24.0/43*2*pi, 25.0/43*2*pi,ring27,ring28),
    (25.5/43*2*pi, (ring27+ring28)/2, 25.0/43*2*pi, 26.0/43*2*pi,ring27,ring28),
    (26.5/43*2*pi, (ring27+ring28)/2, 26.0/43*2*pi, 27.0/43*2*pi,ring27,ring28),
    (27.5/43*2*pi, (ring27+ring28)/2, 27.0/43*2*pi, 28.0/43*2*pi,ring27,ring28),
    (28.5/43*2*pi, (ring27+ring28)/2, 28.0/43*2*pi, 29.0/43*2*pi,ring27,ring28),
    (29.5/43*2*pi, (ring27+ring28)/2, 29.0/43*2*pi, 30.0/43*2*pi,ring27,ring28),
    (30.5/43*2*pi, (ring27+ring28)/2, 30.0/43*2*pi, 31.0/43*2*pi,ring27,ring28),
    (31.5/43*2*pi, (ring27+ring28)/2, 31.0/43*2*pi, 32.0/43*2*pi,ring27,ring28),
    (32.5/43*2*pi, (ring27+ring28)/2, 32.0/43*2*pi, 33.0/43*2*pi,ring27,ring28),
    (33.5/43*2*pi, (ring27+ring28)/2, 33.0/43*2*pi, 34.0/43*2*pi,ring27,ring28),
    (34.5/43*2*pi, (ring27+ring28)/2, 34.0/43*2*pi, 35.0/43*2*pi,ring27,ring28),
    (35.5/43*2*pi, (ring27+ring28)/2, 35.0/43*2*pi, 36.0/43*2*pi,ring27,ring28),
    (36.5/43*2*pi, (ring27+ring28)/2, 36.0/43*2*pi, 37.0/43*2*pi,ring27,ring28),
    (37.5/43*2*pi, (ring27+ring28)/2, 37.0/43*2*pi, 38.0/43*2*pi,ring27,ring28),
    (38.5/43*2*pi, (ring27+ring28)/2, 38.0/43*2*pi, 39.0/43*2*pi,ring27,ring28),
    (39.5/43*2*pi, (ring27+ring28)/2, 39.0/43*2*pi, 40.0/43*2*pi,ring27,ring28),
    (40.5/43*2*pi, (ring27+ring28)/2, 40.0/43*2*pi, 41.0/43*2*pi,ring27,ring28),
    (41.5/43*2*pi, (ring27+ring28)/2, 41.0/43*2*pi, 42.0/43*2*pi,ring27,ring28),
    (42.5/43*2*pi, (ring27+ring28)/2, 42.0/43*2*pi, 43.0/43*2*pi,ring27,ring28),


    (0.5/38*2*pi, (ring28+ring29)/2, 0.0/38*2*pi, 1.0/38*2*pi,ring28,ring29),
    (1.5/38*2*pi, (ring28+ring29)/2, 1.0/38*2*pi, 2.0/38*2*pi,ring28,ring29),
    (2.5/38*2*pi, (ring28+ring29)/2, 2.0/38*2*pi, 3.0/38*2*pi,ring28,ring29),
    (3.5/38*2*pi, (ring28+ring29)/2, 3.0/38*2*pi, 4.0/38*2*pi,ring28,ring29),
    (4.5/38*2*pi, (ring28+ring29)/2, 4.0/38*2*pi, 5.0/38*2*pi,ring28,ring29),
    (5.5/38*2*pi, (ring28+ring29)/2, 5.0/38*2*pi, 6.0/38*2*pi,ring28,ring29),
    (6.5/38*2*pi, (ring28+ring29)/2, 6.0/38*2*pi, 7.0/38*2*pi,ring28,ring29),
    (7.5/38*2*pi, (ring28+ring29)/2, 7.0/38*2*pi, 8.0/38*2*pi,ring28,ring29),
    (8.5/38*2*pi, (ring28+ring29)/2, 8.0/38*2*pi, 9.0/38*2*pi,ring28,ring29),
    (9.5/38*2*pi, (ring28+ring29)/2, 9.0/38*2*pi, 10.0/38*2*pi,ring28,ring29),
    (10.5/38*2*pi, (ring28+ring29)/2, 10.0/38*2*pi, 11.0/38*2*pi,ring28,ring29),
    (11.5/38*2*pi, (ring28+ring29)/2, 11.0/38*2*pi, 12.0/38*2*pi,ring28,ring29),
    (12.5/38*2*pi, (ring28+ring29)/2, 12.0/38*2*pi, 13.0/38*2*pi,ring28,ring29),
    (13.5/38*2*pi, (ring28+ring29)/2, 13.0/38*2*pi, 14.0/38*2*pi,ring28,ring29),
    (14.5/38*2*pi, (ring28+ring29)/2, 14.0/38*2*pi, 15.0/38*2*pi,ring28,ring29),
    (15.5/38*2*pi, (ring28+ring29)/2, 15.0/38*2*pi, 16.0/38*2*pi,ring28,ring29),
    (16.5/38*2*pi, (ring28+ring29)/2, 16.0/38*2*pi, 17.0/38*2*pi,ring28,ring29),
    (17.5/38*2*pi, (ring28+ring29)/2, 17.0/38*2*pi, 18.0/38*2*pi,ring28,ring29),
    (18.5/38*2*pi, (ring28+ring29)/2, 18.0/38*2*pi, 19.0/38*2*pi,ring28,ring29),
    (19.5/38*2*pi, (ring28+ring29)/2, 19.0/38*2*pi, 20.0/38*2*pi,ring28,ring29),
    (20.5/38*2*pi, (ring28+ring29)/2, 20.0/38*2*pi, 21.0/38*2*pi,ring28,ring29),
    (21.5/38*2*pi, (ring28+ring29)/2, 21.0/38*2*pi, 22.0/38*2*pi,ring28,ring29),
    (22.5/38*2*pi, (ring28+ring29)/2, 22.0/38*2*pi, 23.0/38*2*pi,ring28,ring29),
    (23.5/38*2*pi, (ring28+ring29)/2, 23.0/38*2*pi, 24.0/38*2*pi,ring28,ring29),
    (24.5/38*2*pi, (ring28+ring29)/2, 24.0/38*2*pi, 25.0/38*2*pi,ring28,ring29),
    (25.5/38*2*pi, (ring28+ring29)/2, 25.0/38*2*pi, 26.0/38*2*pi,ring28,ring29),
    (26.5/38*2*pi, (ring28+ring29)/2, 26.0/38*2*pi, 27.0/38*2*pi,ring28,ring29),
    (27.5/38*2*pi, (ring28+ring29)/2, 27.0/38*2*pi, 28.0/38*2*pi,ring28,ring29),
    (28.5/38*2*pi, (ring28+ring29)/2, 28.0/38*2*pi, 29.0/38*2*pi,ring28,ring29),
    (29.5/38*2*pi, (ring28+ring29)/2, 29.0/38*2*pi, 30.0/38*2*pi,ring28,ring29),
    (30.5/38*2*pi, (ring28+ring29)/2, 30.0/38*2*pi, 31.0/38*2*pi,ring28,ring29),
    (31.5/38*2*pi, (ring28+ring29)/2, 31.0/38*2*pi, 32.0/38*2*pi,ring28,ring29),
    (32.5/38*2*pi, (ring28+ring29)/2, 32.0/38*2*pi, 33.0/38*2*pi,ring28,ring29),
    (33.5/38*2*pi, (ring28+ring29)/2, 33.0/38*2*pi, 34.0/38*2*pi,ring28,ring29),
    (34.5/38*2*pi, (ring28+ring29)/2, 34.0/38*2*pi, 35.0/38*2*pi,ring28,ring29),
    (35.5/38*2*pi, (ring28+ring29)/2, 35.0/38*2*pi, 36.0/38*2*pi,ring28,ring29),
    (36.5/38*2*pi, (ring28+ring29)/2, 36.0/38*2*pi, 37.0/38*2*pi,ring28,ring29),
    (37.5/38*2*pi, (ring28+ring29)/2, 37.0/38*2*pi, 38.0/38*2*pi,ring28,ring29),



    (0.5/33*2*pi, (ring29+ring30)/2, 0.0/33*2*pi, 1.0/33*2*pi,ring29,ring30),
    (1.5/33*2*pi, (ring29+ring30)/2, 1.0/33*2*pi, 2.0/33*2*pi,ring29,ring30),
    (2.5/33*2*pi, (ring29+ring30)/2, 2.0/33*2*pi, 3.0/33*2*pi,ring29,ring30),
    (3.5/33*2*pi, (ring29+ring30)/2, 3.0/33*2*pi, 4.0/33*2*pi,ring29,ring30),
    (4.5/33*2*pi, (ring29+ring30)/2, 4.0/33*2*pi, 5.0/33*2*pi,ring29,ring30),
    (5.5/33*2*pi, (ring29+ring30)/2, 5.0/33*2*pi, 6.0/33*2*pi,ring29,ring30),
    (6.5/33*2*pi, (ring29+ring30)/2, 6.0/33*2*pi, 7.0/33*2*pi,ring29,ring30),
    (7.5/33*2*pi, (ring29+ring30)/2, 7.0/33*2*pi, 8.0/33*2*pi,ring29,ring30),
    (8.5/33*2*pi, (ring29+ring30)/2, 8.0/33*2*pi, 9.0/33*2*pi,ring29,ring30),
    (9.5/33*2*pi, (ring29+ring30)/2, 9.0/33*2*pi, 10.0/33*2*pi,ring29,ring30),
    (10.5/33*2*pi, (ring29+ring30)/2, 10.0/33*2*pi, 11.0/33*2*pi,ring29,ring30),
    (11.5/33*2*pi, (ring29+ring30)/2, 11.0/33*2*pi, 12.0/33*2*pi,ring29,ring30),
    (12.5/33*2*pi, (ring29+ring30)/2, 12.0/33*2*pi, 13.0/33*2*pi,ring29,ring30),
    (13.5/33*2*pi, (ring29+ring30)/2, 13.0/33*2*pi, 14.0/33*2*pi,ring29,ring30),
    (14.5/33*2*pi, (ring29+ring30)/2, 14.0/33*2*pi, 15.0/33*2*pi,ring29,ring30),
    (15.5/33*2*pi, (ring29+ring30)/2, 15.0/33*2*pi, 16.0/33*2*pi,ring29,ring30),
    (16.5/33*2*pi, (ring29+ring30)/2, 16.0/33*2*pi, 17.0/33*2*pi,ring29,ring30),
    (17.5/33*2*pi, (ring29+ring30)/2, 17.0/33*2*pi, 18.0/33*2*pi,ring29,ring30),
    (18.5/33*2*pi, (ring29+ring30)/2, 18.0/33*2*pi, 19.0/33*2*pi,ring29,ring30),
    (19.5/33*2*pi, (ring29+ring30)/2, 19.0/33*2*pi, 20.0/33*2*pi,ring29,ring30),
    (20.5/33*2*pi, (ring29+ring30)/2, 20.0/33*2*pi, 21.0/33*2*pi,ring29,ring30),
    (21.5/33*2*pi, (ring29+ring30)/2, 21.0/33*2*pi, 22.0/33*2*pi,ring29,ring30),
    (22.5/33*2*pi, (ring29+ring30)/2, 22.0/33*2*pi, 23.0/33*2*pi,ring29,ring30),
    (23.5/33*2*pi, (ring29+ring30)/2, 23.0/33*2*pi, 24.0/33*2*pi,ring29,ring30),
    (24.5/33*2*pi, (ring29+ring30)/2, 24.0/33*2*pi, 25.0/33*2*pi,ring29,ring30),
    (25.5/33*2*pi, (ring29+ring30)/2, 25.0/33*2*pi, 26.0/33*2*pi,ring29,ring30),
    (26.5/33*2*pi, (ring29+ring30)/2, 26.0/33*2*pi, 27.0/33*2*pi,ring29,ring30),
    (27.5/33*2*pi, (ring29+ring30)/2, 27.0/33*2*pi, 28.0/33*2*pi,ring29,ring30),
    (28.5/33*2*pi, (ring29+ring30)/2, 28.0/33*2*pi, 29.0/33*2*pi,ring29,ring30),
    (29.5/33*2*pi, (ring29+ring30)/2, 29.0/33*2*pi, 30.0/33*2*pi,ring29,ring30),
    (30.5/33*2*pi, (ring29+ring30)/2, 30.0/33*2*pi, 31.0/33*2*pi,ring29,ring30),
    (31.5/33*2*pi, (ring29+ring30)/2, 31.0/33*2*pi, 32.0/33*2*pi,ring29,ring30),
    (32.5/33*2*pi, (ring29+ring30)/2, 32.0/33*2*pi, 33.0/33*2*pi,ring29,ring30),


    (0.5/27*2*pi, (ring30+ring31)/2, 0.0/27*2*pi, 1.0/27*2*pi,ring30,ring31),
    (1.5/27*2*pi, (ring30+ring31)/2, 1.0/27*2*pi, 2.0/27*2*pi,ring30,ring31),
    (2.5/27*2*pi, (ring30+ring31)/2, 2.0/27*2*pi, 3.0/27*2*pi,ring30,ring31),
    (3.5/27*2*pi, (ring30+ring31)/2, 3.0/27*2*pi, 4.0/27*2*pi,ring30,ring31),
    (4.5/27*2*pi, (ring30+ring31)/2, 4.0/27*2*pi, 5.0/27*2*pi,ring30,ring31),
    (5.5/27*2*pi, (ring30+ring31)/2, 5.0/27*2*pi, 6.0/27*2*pi,ring30,ring31),
    (6.5/27*2*pi, (ring30+ring31)/2, 6.0/27*2*pi, 7.0/27*2*pi,ring30,ring31),
    (7.5/27*2*pi, (ring30+ring31)/2, 7.0/27*2*pi, 8.0/27*2*pi,ring30,ring31),
    (8.5/27*2*pi, (ring30+ring31)/2, 8.0/27*2*pi, 9.0/27*2*pi,ring30,ring31),
    (9.5/27*2*pi, (ring30+ring31)/2, 9.0/27*2*pi, 10.0/27*2*pi,ring30,ring31),
    (10.5/27*2*pi, (ring30+ring31)/2, 10.0/27*2*pi, 11.0/27*2*pi,ring30,ring31),
    (11.5/27*2*pi, (ring30+ring31)/2, 11.0/27*2*pi, 12.0/27*2*pi,ring30,ring31),
    (12.5/27*2*pi, (ring30+ring31)/2, 12.0/27*2*pi, 13.0/27*2*pi,ring30,ring31),
    (13.5/27*2*pi, (ring30+ring31)/2, 13.0/27*2*pi, 14.0/27*2*pi,ring30,ring31),
    (14.5/27*2*pi, (ring30+ring31)/2, 14.0/27*2*pi, 15.0/27*2*pi,ring30,ring31),
    (15.5/27*2*pi, (ring30+ring31)/2, 15.0/27*2*pi, 16.0/27*2*pi,ring30,ring31),
    (16.5/27*2*pi, (ring30+ring31)/2, 16.0/27*2*pi, 17.0/27*2*pi,ring30,ring31),
    (17.5/27*2*pi, (ring30+ring31)/2, 17.0/27*2*pi, 18.0/27*2*pi,ring30,ring31),
    (18.5/27*2*pi, (ring30+ring31)/2, 18.0/27*2*pi, 19.0/27*2*pi,ring30,ring31),
    (19.5/27*2*pi, (ring30+ring31)/2, 19.0/27*2*pi, 20.0/27*2*pi,ring30,ring31),
    (20.5/27*2*pi, (ring30+ring31)/2, 20.0/27*2*pi, 21.0/27*2*pi,ring30,ring31),
    (21.5/27*2*pi, (ring30+ring31)/2, 21.0/27*2*pi, 22.0/27*2*pi,ring30,ring31),
    (22.5/27*2*pi, (ring30+ring31)/2, 22.0/27*2*pi, 23.0/27*2*pi,ring30,ring31),
    (23.5/27*2*pi, (ring30+ring31)/2, 23.0/27*2*pi, 24.0/27*2*pi,ring30,ring31),
    (24.5/27*2*pi, (ring30+ring31)/2, 24.0/27*2*pi, 25.0/27*2*pi,ring30,ring31),
    (25.5/27*2*pi, (ring30+ring31)/2, 25.0/27*2*pi, 26.0/27*2*pi,ring30,ring31),
    (26.5/27*2*pi, (ring30+ring31)/2, 26.0/27*2*pi, 27.0/27*2*pi,ring30,ring31),


    (0.5/21*2*pi, (ring31+ring32)/2, 0.0/21*2*pi, 1.0/21*2*pi,ring31,ring32),
    (1.5/21*2*pi, (ring31+ring32)/2, 1.0/21*2*pi, 2.0/21*2*pi,ring31,ring32),
    (2.5/21*2*pi, (ring31+ring32)/2, 2.0/21*2*pi, 3.0/21*2*pi,ring31,ring32),
    (3.5/21*2*pi, (ring31+ring32)/2, 3.0/21*2*pi, 4.0/21*2*pi,ring31,ring32),
    (4.5/21*2*pi, (ring31+ring32)/2, 4.0/21*2*pi, 5.0/21*2*pi,ring31,ring32),
    (5.5/21*2*pi, (ring31+ring32)/2, 5.0/21*2*pi, 6.0/21*2*pi,ring31,ring32),
    (6.5/21*2*pi, (ring31+ring32)/2, 6.0/21*2*pi, 7.0/21*2*pi,ring31,ring32),
    (7.5/21*2*pi, (ring31+ring32)/2, 7.0/21*2*pi, 8.0/21*2*pi,ring31,ring32),
    (8.5/21*2*pi, (ring31+ring32)/2, 8.0/21*2*pi, 9.0/21*2*pi,ring31,ring32),
    (9.5/21*2*pi, (ring31+ring32)/2, 9.0/21*2*pi, 10.0/21*2*pi,ring31,ring32),
    (10.5/21*2*pi, (ring31+ring32)/2, 10.0/21*2*pi, 11.0/21*2*pi,ring31,ring32),
    (11.5/21*2*pi, (ring31+ring32)/2, 11.0/21*2*pi, 12.0/21*2*pi,ring31,ring32),
    (12.5/21*2*pi, (ring31+ring32)/2, 12.0/21*2*pi, 13.0/21*2*pi,ring31,ring32),
    (13.5/21*2*pi, (ring31+ring32)/2, 13.0/21*2*pi, 14.0/21*2*pi,ring31,ring32),
    (14.5/21*2*pi, (ring31+ring32)/2, 14.0/21*2*pi, 15.0/21*2*pi,ring31,ring32),
    (15.5/21*2*pi, (ring31+ring32)/2, 15.0/21*2*pi, 16.0/21*2*pi,ring31,ring32),
    (16.5/21*2*pi, (ring31+ring32)/2, 16.0/21*2*pi, 17.0/21*2*pi,ring31,ring32),
    (17.5/21*2*pi, (ring31+ring32)/2, 17.0/21*2*pi, 18.0/21*2*pi,ring31,ring32),
    (18.5/21*2*pi, (ring31+ring32)/2, 18.0/21*2*pi, 19.0/21*2*pi,ring31,ring32),
    (19.5/21*2*pi, (ring31+ring32)/2, 19.0/21*2*pi, 20.0/21*2*pi,ring31,ring32),
    (20.5/21*2*pi, (ring31+ring32)/2, 20.0/21*2*pi, 21.0/21*2*pi,ring31,ring32),



    (0.5/15*2*pi, (ring32+ring33)/2, 0.0/15*2*pi, 1.0/15*2*pi,ring32,ring33),
    (1.5/15*2*pi, (ring32+ring33)/2, 1.0/15*2*pi, 2.0/15*2*pi,ring32,ring33),
    (2.5/15*2*pi, (ring32+ring33)/2, 2.0/15*2*pi, 3.0/15*2*pi,ring32,ring33),
    (3.5/15*2*pi, (ring32+ring33)/2, 3.0/15*2*pi, 4.0/15*2*pi,ring32,ring33),
    (4.5/15*2*pi, (ring32+ring33)/2, 4.0/15*2*pi, 5.0/15*2*pi,ring32,ring33),
    (5.5/15*2*pi, (ring32+ring33)/2, 5.0/15*2*pi, 6.0/15*2*pi,ring32,ring33),
    (6.5/15*2*pi, (ring32+ring33)/2, 6.0/15*2*pi, 7.0/15*2*pi,ring32,ring33),
    (7.5/15*2*pi, (ring32+ring33)/2, 7.0/15*2*pi, 8.0/15*2*pi,ring32,ring33),
    (8.5/15*2*pi, (ring32+ring33)/2, 8.0/15*2*pi, 9.0/15*2*pi,ring32,ring33),
    (9.5/15*2*pi, (ring32+ring33)/2, 9.0/15*2*pi, 10.0/15*2*pi,ring32,ring33),
    (10.5/15*2*pi, (ring32+ring33)/2, 10.0/15*2*pi, 11.0/15*2*pi,ring32,ring33),
    (11.5/15*2*pi, (ring32+ring33)/2, 11.0/15*2*pi, 12.0/15*2*pi,ring32,ring33),
    (12.5/15*2*pi, (ring32+ring33)/2, 12.0/15*2*pi, 13.0/15*2*pi,ring32,ring33),
    (13.5/15*2*pi, (ring32+ring33)/2, 13.0/15*2*pi, 14.0/15*2*pi,ring32,ring33),
    (14.5/15*2*pi, (ring32+ring33)/2, 14.0/15*2*pi, 15.0/15*2*pi,ring32,ring33),

    (0.5/9*2*pi, (ring33+ring34)/2, 0.0/9*2*pi, 1.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (1.5/9*2*pi, (ring33+ring34)/2, 1.0/9*2*pi, 2.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (2.5/9*2*pi, (ring33+ring34)/2, 2.0/9*2*pi, 3.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (3.5/9*2*pi, (ring33+ring34)/2, 3.0/9*2*pi, 4.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (4.5/9*2*pi, (ring33+ring34)/2, 4.0/9*2*pi, 5.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (5.5/9*2*pi, (ring33+ring34)/2, 5.0/9*2*pi, 6.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (6.5/9*2*pi, (ring33+ring34)/2, 6.0/9*2*pi, 7.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (7.5/9*2*pi, (ring33+ring34)/2, 7.0/9*2*pi, 8.0/9*2*pi,ring33,ring34),  {9 circle segments}
    (8.5/9*2*pi, (ring33+ring34)/2, 8.0/9*2*pi, 9.0/9*2*pi,ring33,ring34),  {9 circle segments}

    (0.5/3*2*pi, (ring34+ring35)/2, 0.0/3*2*pi, 1.0/3*2*pi,ring34,ring35),  {3 circle segments}
    (1.5/3*2*pi, (ring34+ring35)/2, 1.0/3*2*pi, 2.0/3*2*pi,ring34,ring35),  {3 circle segments}
    (2.5/3*2*pi, (ring34+ring35)/2, 2.0/3*2*pi, 3.0/3*2*pi,ring34,ring35),  {3 circle segments}

    ( 0       ,   ring36          ,  0        ,pi         ,ring35,ring36 )); {1 segment}   {north pole }



implementation
uses  sysutils;

Const

Stepsize=90/17.5;{5.142857143 degrees}

rings1476: array[0..36] of real=
// (-90,-85.23224404, -75.66348756, -65.99286637, -56.14497387,-46.03163067,-35.54307745,-24.53348115,-12.79440589, 0.0 ,+12.79440589,+24.53348115,+35.54307745,+46.03163067,+56.14497387,+65.99286637,+75.66348756,+85.23224404,90);
 (-90,	{	90	}
 -stepsize*17,	{	-87.42857143	}
 -stepsize*16,	{	-82.28571429	}
 -stepsize*15,	{	-77.14285714	}
 -stepsize*14,	{	-72	}
 -stepsize*13,	{	-66.85714286	}
 -stepsize*12,	{	-61.71428571	}
 -stepsize*11,	{	-56.57142857	}
 -stepsize*10,	{	-51.42857143	}
 -stepsize*9,	{	-46.28571429	}
 -stepsize*8,	{	-41.14285714	}
 -stepsize*7,	{	-36	}
 -stepsize*6,	{	-30.85714286	}
 -stepsize*5,	{	-25.71428571	}
 -stepsize*4,	{	-20.57142857	}
 -stepsize*3,	{	-15.42857143	}
 -stepsize*2,	{	-10.28571429	}
 -stepsize*1,	{	-5.142857143	}
  stepsize*0,	{	-0	}
  stepsize*1,	{	5.142857143	}
  stepsize*2,	{	10.28571429	}
  stepsize*3,	{	15.42857143	}
  stepsize*4,	{	20.57142857	}
  stepsize*5,	{	25.71428571	}
  stepsize*6,	{	30.85714286	}
  stepsize*7,	{	36	}
  stepsize*8,	{	41.14285714	}
  stepsize*9,	{	46.28571429	}
  stepsize*10,	{	51.42857143	}
  stepsize*11,	{	56.57142857	}
  stepsize*12,	{	61.71428571	}
  stepsize*13,	{	66.85714286	}
  stepsize*14,	{	72	}
  stepsize*15,	{	77.14285714	}
  stepsize*16,	{	82.28571429	}
  stepsize*17,	{	87.42857143	}
  90); 	{	90	}



seg_length=36;

segments1476: array[1..seg_length] of integer= {number of division in each latitude ring}
 {RA cells		RA step distance north[degr]		RA step distance south[degr] }
 (1	,
 3	,{	5.383779642	,	16.1079919	}
 9	,{	5.369330633	,	8.900837358	}
 15	,{	5.340502415	,	7.416407865	}
 21	,{	5.297434189	,	6.737571971	}
 27	,{	5.240333755	,	6.318248833	}
 33	,{	5.169476318	,	6.009785252	}
 38	,{	5.219024035	,	5.906745491	}
 43	,{	5.21991462	,	5.785640782	}
 48	,{	5.182969867	,	5.648035995	}
 52	,{	5.213571688	,	5.600886884	}
 56	,{	5.200823535	,	5.518599387	}
 60	,{	5.150692762	,	5.405813207	}
 63	,{	5.148393531	,	5.349913547	}
 65	,{	5.185300822	,	5.338871228	}
 67	,{	5.179501938	,	5.286785849	}
 68	,{	5.209038998	,	5.272805086	}
 69	,{	5.196387621	,	5.217391304	}

 69	,{	5.217391304	,	5.196387621	}
 68	,{	5.272805086	,	5.209038998	}
 67	,{	5.286785849	,	5.179501938	}
 65	,{	5.338871228	,	5.185300822	}
 63	,{	5.349913547	,	5.148393531	}
 60	,{	5.405813207	,	5.150692762	}
 56	,{	5.518599387	,	5.200823535	}
 52	,{	5.600886884	,	5.213571688	}
 48	,{	5.648035995	,	5.182969867	}
 43	,{	5.785640782	,	5.21991462	}
 38	,{	5.906745491	,	5.219024035	}
 33	,{	6.009785252	,	5.169476318	}
 27	,{	6.318248833	,	5.240333755	}
 21	,{	6.737571971	,	5.297434189	}
 15	,{	7.416407865	,	5.340502415	}
 9	,{	8.900837358	,	5.369330633	}
 3	,{	16.1079919	,	5.383779642	}
 1);






function filenames1476(nr:integer): string;
var
  la,lo,m : integer;
  lat,seg : string;
begin
  //const
  //filenames1476 : array[1..1476] of string= {}
  //(('0101.1476'),

  // ('0201.1476'),
  // ('0202.1476'),
  // ('0203.1476'),

  // ('0301.1476'),
  // ('0302.1476'),
  m:=0;
  la:=1;
  repeat
   lo:=segments1476[la];
   m:=m+lo;
   if nr<=m then
   begin
     str(la,lat); if length(lat)=1 then lat:='0' +lat;
     str(nr-(m-lo),seg); if length(seg)=1 then seg:='0' +seg;
     result:=lat+seg+'.1476';
     exit;
   end;
   inc(la);
  until la>seg_length; {36}
end;

function name1476(ra,dec:real): string; {give segment name}
var
   d : integer;
   found: boolean;
   dum  :string;
begin
  found:=false;
  d:=0;

  if dec>+pi/2 then dec:=PI/2;
  if dec<-pi/2 then dec:=-PI/2;
  repeat {find dec ring}
    inc(d);
    if dec*180/pi<rings1476[d] then begin found:=true; str(d,result); if length(result)=1 then result:='0' +result; end;

  until ((found=true) or (d>=seg_length));

 {find ra segment}
  if ra>=2*pi then ra:=0;
  if ra<0     then ra:=0;
  str( 1+trunc(segments1476[d]*ra/(2*pi)),dum);
  if length(dum)=1 then dum:='0' +dum;
  result:=result+dum+'.1476';
end;

PROCEDURE ang_sep(ra1,dec1,ra2,dec2 : real;var sep: real); { By Han Kleijn}
var cos_sep:real;
{caculates angular separation. according formula 9.1 old meeus}
Begin
  cos_sep:=sin(dec1)*sin(dec2)+ cos(dec1)*cos(dec2)*cos(ra1-ra2);
  if ABS(cos_sep)<1 then begin sep:=(PI/2-ARCTAN(cos_sep/(SQRT(1-SQR(cos_sep))))) end {arccos function}
  else
  begin if cos_sep>0 then sep:=0 {note bij x=1 klapt uitkomst net om}
                     else sep:=PI;
  end; {arccos function}

end;
function  limit_radialen(z:double):double;
begin
  while z<0 do z:=z+2*pi;
  while z>=2*pi do z:=z-2*pi; {corrected 2019}
  limit_radialen:=z;
end;


begin

end.
